<?php require_once("class/WebAPI.php"); ?>
<?php
Class ToolDocConverter {
	
	public static function convertTMX( $file, $ext, $langS, $langT, $ext_out = NULL ){
		$result = TRUE;
		$tmx = NULL;
		if ($ext_out === NULL){
			$ext_t = "tmx";
		} else {
			$ext_t = $ext_out;
		}
		
		// tmpディレクトリ
		$dirTmp = Setting::get("PATH_DATA_TMP");
		
		$escFile   = escapeshellcmd($file);
		$escLangS  = escapeshellcmd($langS);
		$escLangT  = escapeshellcmd($langT);
		$escDirTmp = escapeshellcmd($dirTmp);
		$output    = "{$escFile}.{$ext_t}";

		////////////////////////////
		// 文書コンバータ(WebAPI) //
		////////////////////////////
		$objWebAPI     = new WebAPI();
		if ( $objWebAPI->convertGet( $ext , $escLangS , $escLangT , $escFile , $output , $ext_t) === FALSE ){
			$result = FALSE;
		}
		
		if ( $result ){
			if ( ($tmx = file_get_contents($output)) === FALSE ){
				$result = FALSE;
				Util::printLog("docConverter - readError {$output}");
			}
		}
		
		// 後始末
		if ( file_exists($output) ){
			unlink($output);
		}
		
		return ($result) ? $tmx : FALSE;
	}
}
