<?php require_once("class/DocTmx.php"); ?>
<?php
Class View_system_bbs_post extends View {
	const USER_ID_ALL_USER = 0;

	const VIEW_MODE_DETAIL = 0;
	const VIEW_MODE_SIMPLE = 1;
	public static function VIEW_MODE_TABLE( $key = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_SYSTEM_BBS_POST";
		
		$arrTable = array(
			self::VIEW_MODE_DETAIL => "{$WORD($wk, 1)}",
			self::VIEW_MODE_SIMPLE => "{$WORD($wk, 2)}",
		);
		
		return is_null($key) ? $arrTable : $arrTable[$key];
	}
	
	const VIEW_REPLY_SHOW = 0;
	const VIEW_REPLY_HIDE = 1;
	public static function VIEW_REPLY_TABLE( $key = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_SYSTEM_BBS_POST";
		
		$arrTable = array(
			self::VIEW_REPLY_SHOW => "{$WORD($wk, 3)}",
			self::VIEW_REPLY_HIDE => "{$WORD($wk, 4)}",
		);
		
		return is_null($key) ? $arrTable : $arrTable[$key];
	}
	
	const ORDER_ASC      = 1;
	const ORDER_DESC     = 2;
	const ORDER_LAST_ASC  = 3;
	const ORDER_LAST_DESC = 4;
	public static function ORDER_TABLE( $key = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_SYSTEM_BBS_POST";
		
		$arrTable = array(
			self::ORDER_ASC      => "{$WORD($wk, 5)}",
			self::ORDER_DESC     => "{$WORD($wk, 6)}",
			self::ORDER_LAST_ASC  => "{$WORD($wk, 7)}",
			self::ORDER_LAST_DESC => "{$WORD($wk, 8)}",
		);
		
		return is_null($key) ? $arrTable : $arrTable[$key];
	}
	
	const TAB_LIST = 0;
	const TAB_NEW  = 1;
	
	/***************************************************************
	 * 名前:
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function tab( $tab, $auth, $projectID = 0, $id = 0 ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_SYSTEM_BBS_POST";
		
		$html = FALSE;
		$query = array();
		
		switch ( $tab ){
			//------------------------
			// 掲示板一覧
			case self::TAB_LIST:
				$html = $this->tab_list( $auth, $projectID, $id );
				break;
			//------------------------
			// 投稿
			case self::TAB_NEW:
				if ( $auth->writeItem(INIT_ID, $id, $projectID) ){
					$html = Printer::link("{$WORD($wk, 9)}", NULL, "icon-plus", NULL, NULL, "minhon.bbs.post.postDialog(true, {$id}, null);");
				}
				break;
		}
		
		return $html;
	}
	
	/***************************************************************
	 * 名前:
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function tab_list( $auth, $projectID = 0, $id = 0, $selectViewMode = NULL, $selectViewReply = NULL, $selectOrder = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_SYSTEM_BBS_POST";
		
		$html = FALSE;
		if( ! $auth->read($id, $projectID) ){
			return $html;
		}
		
		$arrPullDown = array();
		if ( is_numeric($projectID) && ($projectID > 0) ){
			$arrPullDown[0] = Printer::link( "{$WORD($wk, 10)}", "menu-danger", "icon-search", NULL, NULL, "minhon.bbs2.formToggle();" );
		}
		
		// モード
		$arrSubMenu = array();
		foreach ( self::VIEW_MODE_TABLE() as $view => $text ){
			$arrSubMenu[$view] = Printer::link( $text, NULL, NULL, NULL, NULL, "minhon.bbs2.allChangeViewMode({$view});");
		}
		$arrPullDown[1] = array(
			"title" => "{$WORD($wk, 11)} : ".self::VIEW_MODE_TABLE($selectViewMode),
			"item"  => $arrSubMenu,
		);
		
		// 返答
		$arrSubMenu = array();
		foreach ( self::VIEW_REPLY_TABLE() as $view => $text ){
			$arrSubMenu[$view] = Printer::link( $text, NULL, NULL, NULL, NULL, "minhon.bbs2.allChangeViewReply({$view});");
		}
		$arrPullDown[2] = array(
			"title" => "{$WORD($wk, 12)} : ".self::VIEW_REPLY_TABLE($selectViewReply),
			"item"  => $arrSubMenu,
		);
		
		// 並び順
		$arrSubMenu = array();
		foreach ( self::ORDER_TABLE() as $order => $text ){
			$arrSubMenu[$order] = Printer::link( $text, NULL, NULL, NULL, NULL, "minhon.bbs2.changeOrder({$order});");
//			$arrSubMenu[$order] = Printer::link( $text, NULL, NULL, NULL, "./detail.html?q_id={$qID}&q_view_mode={$qViewMode}&q_view_reply={$qViewReply}&q_order={$order}");
		}
		$arrPullDown[3] = array(
			"title" => "{$WORD($wk, 13)} : ".self::ORDER_TABLE($selectOrder),
			"item"  => $arrSubMenu,
		);
		
		$html = array(
			"title" => "{$WORD($wk, 14)}",
			"item"  => $arrPullDown,
		);
		
		return $html;
	}
	
	/***************************************************************
	 * 名前: threadSort
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	var $threadSortOrder = NULL;
	private function threadSort( $a, $b ){
		switch ( $this->threadSortOrder ){
			case self::ORDER_ASC:
			case self::ORDER_DESC:
				$val_a = $a["data"]["t_bbs_post_no"];
				$val_b = $b["data"]["t_bbs_post_no"];
				break;
			case self::ORDER_LAST_ASC:
			case self::ORDER_LAST_DESC:
				$val_a = $a["last_no"];
				$val_b = $b["last_no"];
				break;
			default:
				return 0;
		}
		
		$res = 0;
		if ( $val_a < $val_b ){
			$res = -1;
		} else if ( $val_a > $val_b ){
			$res = 1;
		}
		
		switch ( $this->threadSortOrder ){
			case self::ORDER_ASC:
			case self::ORDER_LAST_ASC:
				$res *= 1;
				break;
			case self::ORDER_DESC:
			case self::ORDER_LAST_DESC:
				$res *= -1;
				break;
		}
		
		return $res;
	}
	
	/***************************************************************
	 * 名前: convertDataToThreadData
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	private function convertDataToThreadData($arrData, $order, $parentNo = 0 ){
		$result = array();
		foreach ( $arrData as &$data ){
			$no     = $data["t_bbs_post_no"];
			$parent = $data["t_bbs_post_parent_no"];
			if ( $parentNo === $parent ){
				// 
				$child = $this->convertDataToThreadData($arrData, $order, $no);
				// 
				$lastNo = $data["t_bbs_post_no"];
				foreach ( $child as $childData ){
					if ( $childData["data"]["t_bbs_post_no"] > $lastNo ){
						$lastNo = $childData["data"]["t_bbs_post_no"];
					}
					if ( $childData["last_no"] > $lastNo ){
						$lastNo = $childData["last_no"];
					}
				}
				$result[$no] = array(
					"data"    => $data,
					"child"   => $child,
					"last_no" => $lastNo,
				);
				unset($data);
			}
		}
		// 並び替え
		$this->threadSortOrder = $order;
		uasort($result, array($this, "threadSort"));
		return $result;
	}
	
	/***************************************************************
	 * 名前: thread
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function thread( $id, $isSystem, $order, $arrData, $arrAppended = array() ){
		$arrTreeData = $this->convertDataToThreadData($arrData, $order);
		
		// スレッド形式で表示
		$html = "";
		foreach ( $arrTreeData as $treeData ){
			$html .= $this->post($isSystem, $treeData["data"], $treeData["child"], $arrAppended);
		}
		return $html;
	}
	
	/***************************************************************
	 * 名前: post
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function post( $isSystem, $data, $arrChildTreeData, $arrAppended, $viewReplyBtn = TRUE, $margin = FALSE ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_SYSTEM_BBS_POST";
		
		$auth = Auth::instance("bbs");
		$objDAOBbsPostTermRoot      = DAO::instance("bbs_post_term_root", Term::KIND_TERM);
		$objDAOBbsPostBilingualRoot = DAO::instance("bbs_post_term_root", Term::KIND_BILINGUAL);
		$objDAOBbsPostData          = DAO::instance("bbs_post_data");
		
		$no        = $data["t_bbs_post_no"];
		$parentNo  = $data["t_bbs_post_parent_no"];
		$stage     = $data["t_bbs_post_stage"];
		$type      = $data["t_bbs_post_type"];
		$role      = $data["t_bbs_post_role"];
		$arrTarget = $data["t_bbs_post_target"];
		$object    = $data["t_bbs_post_object"];
		$title     = $data["t_bbs_post_title"];
		$text      = $data["t_bbs_post_text"];
		$document  = $data["t_bbs_post_document"];
		$register  = $data["t_bbs_post_register"];
		$bbsID     = $data["t_bbs_id"];
		$userID    = $data["t_user_id"];
		$userType  = $data["t_user_type"];
		$userName  = $data["t_user_name"];
		
		// 番号
		$hNo = "No.".Util::esc($no);
		// タイトル
		$hTitle = Printer::icon("icon-comment", NULL, $title);
		if ( $margin ){
			$hTitle = Printer::ellipsis( $hTitle, 15, FALSE );
		}
		// 内容
		$hText = Util::esc($text);
		$hText = preg_replace("/&gt;&gt;(\d+)/", "<a href=\"#bbs_post_$1\">&gt;&gt;$1</a>", $hText);
		$hText = nl2br($hText);
		// 投稿者
		$hUser  = Printer::icon("icon-user", DAO::T_USER_TYPE_COLOR_TABLE($userType), $userName);
		if ( Validate::inKeyArray($role, Task::ROLE_TABLE()) ){
			$hUser .= Printer::label("label-default", Task::ROLE_TABLE($role), array("data-user-role"=>$role));
		}
		// 投稿日時
		$hRegister = Printer::icon("icon-time", NULL, $register);
		// 相手
		$hTarget = "";
		$hArrTarget = array();
		if ( count($arrTarget) > 0 ){
			$hUser .= Printer::icon("icon-arrow-right");
			
			foreach ( $arrTarget as $userID => $target ){
				if ( $userID == self::USER_ID_ALL_USER ){
					$hArrTarget[] = Printer::icon("icon-user", NULL, "{$WORD($wk, 20)}");
					continue;
				}
				$userType = $target["type"];
				$userName = $target["name"];
				
				$hTargetUser = Printer::icon("icon-user", DAO::T_USER_TYPE_COLOR_TABLE($userType), $userName);
				foreach ( $target["role"] as $role ){
					if ( ($roleText = Task::ROLE_TABLE($role)) !== FALSE ){
						$hTargetUser .= Printer::label("label-default", $roleText, array("data-user-role"=>$role));
					}
				}
				$hArrTarget[] = $hTargetUser;
			}
		}
		if ( count($hArrTarget) > 0 ){
			$hTarget = implode("<br/>", $hArrTarget);
		}
		$hSep = "<span class=\"sep\"></span>";
		// 返答
		$hReply = "";
		if ( $auth->writeItem(INIT_ID, $bbsID) && $viewReplyBtn ){
			$hReplyBtnText = "{$WORD($wk, 21)}";
			$hReply .= Printer::link($hReplyBtnText, "btn btn-default btn-sm", "icon-comment", NULL, NULL, "minhon.bbs.post.postDialog(true, {$bbsID}, {$no})");
		}
		if ( $parentNo === 0 && $viewReplyBtn ){
			$hReplyCountText = Util::esc("{$WORD($wk, 22)}")." (<span>0</span>)";
			$hReply .= Printer::link($hReplyCountText, "btn btn-default btn-sm btnViewReply", NULL, NULL, NULL, "", NULL, FALSE);
			$hReply .= Printer::link("<b class=\"caret\"></b>", "btn btn-circle", NULL, NULL, NULL, "minhon.bbs2.onClickDropdownLink(this)", array("data-toggle"=>"dropdown"), FALSE);
		}
		if ( strlen($hReply) > 0 ){
			$hReply = $hSep . $hReply;
		}
		
		// オブジェクト
		$hObject = "";
		// 文書（QReditから選択して登録された場合に表示される）
		if ( strcmp(trim($document), "") !== 0 ){
			$objDocTmx = new DocTmx();
			if ( $objDocTmx->load($document) && $objDocTmx->validate() ){
				if ( is_null($documentTitle = $objDocTmx->getHeaderPropValue("source_title")) ){
					$documentTitle = "[DOCUMENT]";
				}
				$hObjectDocTitle = Printer::label("label-default", "{$WORD($wk, 23)}");
				$hObjectDocLink  = Printer::link($documentTitle, NULL, "icon-file", NULL, NULL, "minhon.bbs.post.documentDialog({$bbsID}, {$no})");
$hObject .= <<< HTML
				<tr>
					<td>{$hObjectDocTitle}</td>
					<td>{$hObjectDocLink}</td>
				</tr>
HTML;
			}
		}
		// 用語集
		$resDAOBbsPostTermRoot = $objDAOBbsPostTermRoot->get($no, $bbsID);
		if ( $resDAOBbsPostTermRoot["result"] === RES_OK ){
			$selectTermRoot = array();
			foreach ( $resDAOBbsPostTermRoot["data"] as $dataBbsPostTermRoot ){
				$selectTermRoot[$dataBbsPostTermRoot["t_term_root_id"]] = $dataBbsPostTermRoot["t_term_root_name"];
			}
			if ( count($selectTermRoot) > 0 ){
				$hTermRootTitle = Printer::label("label-default", "{$WORD($wk, 24)}");
				$hTermRoot      = $this->formTerm(FALSE, NULL, $arrAppended["term"], $selectTermRoot);
$hObject .= <<< HTML
				<tr>
					<td>{$hTermRootTitle}</td>
					<td>{$hTermRoot}</td>
				</tr>
HTML;
			}
		}
		// 対訳集
		$resDAOBbsPostBilingualRoot = $objDAOBbsPostBilingualRoot->get($no, $bbsID);
		if ( $resDAOBbsPostBilingualRoot["result"] === RES_OK ){
			$selectBilingualRoot = array();
			foreach ( $resDAOBbsPostBilingualRoot["data"] as $dataBbsPostBilingualRoot ){
				$selectBilingualRoot[$dataBbsPostBilingualRoot["t_term_root_id"]] = $dataBbsPostBilingualRoot["t_term_root_name"];
			}
			if ( count($selectBilingualRoot) > 0 ){
				$hBilingualRootTitle = Printer::label("label-default", "{$WORD($wk, 25)}");
				$hBilingualRoot      = $this->formBilingual(FALSE, NULL, $arrAppended["bilingual"], $selectBilingualRoot);
$hObject .= <<< HTML
				<tr>
					<td>{$hBilingualRootTitle}</td>
					<td>{$hBilingualRoot}</td>
				</tr>
HTML;
			}
		}
		// データ
		$resDAOBbsPostData = $objDAOBbsPostData->get($no, $bbsID);
		if ( $resDAOBbsPostData["result"] === RES_OK ){
			$selectData = array();
			foreach ( $resDAOBbsPostData["data"] as $dataBbsPostData ){
				$selectData[$dataBbsPostData["t_data_id"]] = $dataBbsPostData["t_data_title"];
			}
			if ( count($selectData) > 0 ){
				$hDataTitle = Printer::label("label-default", "{$WORD($wk, 26)}");
				$hData      = $this->formData(FALSE, NULL, $arrAppended["data"], $selectData);
$hObject .= <<< HTML
				<tr>
					<td>{$hDataTitle}</td>
					<td>{$hData}</td>
				</tr>
HTML;
			}
		}
		
		if ( strlen($hObject) > 0 ){
$hObject = <<< HTML
				<div class="bbs-post-object">
					<table><tbody>
						{$hObject}
					</tbody></table>
				</div>
HTML;
		}
		
		$hChild = "";
		if ( is_array($arrChildTreeData) ){
			foreach ( $arrChildTreeData as $childTreeData ){
				$hChild .= $this->post( $isSystem, $childTreeData["data"], $childTreeData["child"], $arrAppended, $viewReplyBtn, $margin ? $margin+1 : 1 );
			}
		}
		
		$hOption = "";
		if ( ! $isSystem ){
			// ステージ
			$hStage = Printer::label("label-default", DAO::T_BBS_POST_STAGE_TABLE($stage), array("data-bbs-post-stage"=>$stage));
			// タイプ
			$hType = Printer::label(NULL, DAO::T_BBS_POST_TYPE_TABLE($type), array("data-bbs-post-type"=>$type));
			
$hOption = <<< HTML
			<div class="bbs-post-option">
				{$hStage}
				{$hType}
			</div>
HTML;
		}
		
$hBody = <<< HTML
			<div class="bbs-post-title">
				<span style="font-size: 1.2em">{$hTitle}</span>
				<span style="font-size: 0.8em; padding-left: 5px; padding-right: 10px">({$hNo})</span>
				<span style="padding: 0 3px">{$hUser}</span>
				<span style="white-space: normal; width: 100%; padding-left: 5px; padding-right: 10px">{$hTarget}</span>
				<span>{$hRegister}</span>
				<span class="dropdown">{$hReply}</span>
			</div>
			<div class="bbs-post-body">
				<div class="bbs-post-text">
					{$hOption}
					{$hText}
				</div>
				{$hObject}
			</div>
HTML;
		
		$hMargin = "";
		if ( $margin ){
			$hReplyIcon = Printer::icon("icon-chevron-right", "rgba(0,0,0,0.5)");
			for ( $i = 0; $i < $margin; $i++ ){
				$alpha = 0.1 + ($i * 0.1);
				if ( $i === ($margin-1) ){
					$hMargin .= "<div class=\"cell-reply\" style=\"background-color: rgba(128, 128, 128, {$alpha})\">{$hReplyIcon}</div>";
				} else {
					$hMargin .= "<div class=\"cell-reply\" style=\"background-color: rgba(128, 128, 128, {$alpha})\"></div>";
				}
			}
		}
		
		$rootClass = "";
		if ( $parentNo === 0 ){
			$rootClass = " item-root";
		}
		
$html = <<< HTML
		<li class="list-group-item list-group-item-no-padding {$rootClass}" id="bbs_post_{$no}">
			<div class="bbs-post-table">
				{$hMargin}
				<div class="cell-bbs-post">{$hBody}</div>
			</div>
			<span class="list-group-overlay"></span>
		</li>
		{$hChild}
HTML;
		
		if ( ! $margin ){
$html = <<< HTML
	<ul class="list-group">
		{$html}
	</ul>
HTML;
		}
		
		return $html;
	}
	
	/***************************************************************
	 * 名前: threadDropdown
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function threadDropdown(){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_SYSTEM_BBS_POST";
		
$html = <<< HTML
	<ul id="bbsRootDropdown" class="dropdown-menu pull-right" style="top: auto">
		<li><a id="bbsViewModeSimple" href="#" role="menuitem" tabindex="-1">{$WORD($wk, 27)}</a></li>
		<li><a id="bbsViewModeDetail" href="#" role="menuitem" tabindex="-1">{$WORD($wk, 28)}</a></li>
		<li class="disabled"><a id="bbsViewReplyNone" href="#" role="menuitem" tabindex="-1">{$WORD($wk, 29)}</a></li>
		<li><a id="bbsViewReplyShow" href="#" role="menuitem" tabindex="-1">{$WORD($wk, 30)} (<span>0</span>) </a></li>
		<li><a id="bbsViewReplyHide" href="#" role="menuitem" tabindex="-1">{$WORD($wk, 31)}</a></li>
	</ul>
HTML;
		
		return $html;
	}
	
	/***************************************************************
	 * 名前: target
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function target( $arrData, $arrSelect ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_SYSTEM_BBS_POST";
		
		$html = "";
		
		$arr = array();
		$allUser = self::USER_ID_ALL_USER;
		
		foreach ( $arrData as $data ){
			$role     = $data["t_project_user_role"];
			$userID   = $data["t_user_id"];
			$userName = $data["t_user_name"];
			
			$arr[$userID]["name"] = $userName;
			$arr[$userID]["role"][] = $role;
			$arr[$userID]["select"] = array();
		}
		foreach ( $arrSelect as $selectData ){
			$arrUserRole = explode("_", $selectData);
			if ( count($arrUserRole) !== 2 ){
				continue;
			}
			$userID = $arrUserRole[0];
			$role   = $arrUserRole[1];
			if ( isset($arr[$userID]) ){
				$arr[$userID]["select"][] = $userID."_".$role;
			}
		}
		
		foreach ( $arr as $userID => $userData ){
			$userName = $userData["name"];
			$hUserName = Util::esc($userName);
			
			$arrRoleBtn = array();
			foreach ( $userData["role"] as $role ){
				if ( ($hRole = Task::ROLE_TABLE($role)) !== FALSE ){
					$arrRoleBtn[$userID."_".$role] = $hRole;
				}
			}
			if ( count($arrRoleBtn) === 0 ){
				continue;
			}
			$hUserData  = "<td>{$hUserName}</td>";
			$hUserData .= "<td>" . Printer::checkboxButtons("q_target[]", $arrRoleBtn, $userData["select"], "btn-default") . "</td>";
			$html .= "<tr>{$hUserData}</tr>";
		}
		
		$hButtonIcon = Printer::icon("icon-check");
		
$html = <<< HTML
		<div id="q_target" class="panel panel-default">
			<div class="panel-heading">
				<p class="panel-title" data-toggle="collapse" data-target="#q_target_body">{$WORD($wk, 32)}</p>
			</div>
			<div id="q_target_body" class="panel-collapse collapse in">
				<div class="panel-body">
					<button id="q_target_all" type="button" class="btn btn-default" data-toggle="button">
						{$hButtonIcon}
						<input type="checkbox" value="{$allUser}" name="q_target[]" style="display: none;"/>
						{$WORD($wk, 33)}
					</button>
					<table class="table">
						<thead>
							<th style="white-space:nowrap">{$WORD($wk, 34)}</th>
							<th>{$WORD($wk, 35)}</th>
						</thead>
						<tbody>
							{$html}
						</tbody>
					</table>
				</div>
			</div>
		</div>
HTML;
		
		return $html;
	}
}
