<?php
//----------------------------
// common
//----------------------------
define("RES_OK",                1);  // OK *js
define("RES_NG",               -1);  // NG *js
define("RES_NO_DATA",          -2);  // データが無い *js

define("OFF", 0);
define("ON",  1);
$G_ONOFF_TABLE = array(
	OFF,
	ON,
);

define("REQ_NON", NULL);  // リクエスト無し

define("INIT_ID", 0);           // 初期ID *js
define("INIT_DATE", "0000-00-00");

//----------------------------
// language
//----------------------------
// 言語コード
define("LANG_NN",    "--");
define("LANG_JA",    "ja");
define("LANG_EN",    "en");
define("LANG_CN",    "cn");
define("LANG_KO",    "ko");
define("LANG_TW",    "tw");
define("LANG_FR",    "fr");
define("LANG_DE",    "de");
define("LANG_RU",    "ru");
define("LANG_ES",    "es");

define("LANG_ZH_CN", "zh-CN");    // WebAPIの用語抽出で使用する。

define("LANG_S_INIT", LANG_EN);
define("LANG_T_INIT", LANG_JA);

//----------------------------
// app
//----------------------------
// bbsController.php
define("APP_BBS_CONTROLLER_MODE_POSTDOC",  0);  // モード(文書表示)  *js
define("APP_BBS_CONTROLLER_MODE_POSTFRM",  1);  // モード(postフォーム)  *js
define("APP_BBS_CONTROLLER_MODE_POSTSET",  2);  // モード(postセット)  *js
define("APP_BBS_CONTROLLER_MODE_ADDITION", 3);  // モード(追記)  *js
define("APP_BBS_CONTROLLER_MODE_DELETE",   4);  // モード(削除)  *js
$G_APP_BBS_CONTROLLER_MODE_TABLE = array(
	APP_BBS_CONTROLLER_MODE_POSTDOC,
	APP_BBS_CONTROLLER_MODE_POSTFRM,
	APP_BBS_CONTROLLER_MODE_POSTSET,
	APP_BBS_CONTROLLER_MODE_ADDITION,
	APP_BBS_CONTROLLER_MODE_DELETE,
);

// checkNameController.php
define("APP_CHECK_NAME_CONTROLLER_KIND_USER",      0); // 種類(ユーザー名)
define("APP_CHECK_NAME_CONTROLLER_KIND_DOCUMENT",  1); // 種類(文書名)
define("APP_CHECK_NAME_CONTROLLER_KIND_TERM",      2); // 種類(用語集名)
define("APP_CHECK_NAME_CONTROLLER_KIND_BILINGUAL", 3); // 種類(翻訳メモリ名)
define("APP_CHECK_NAME_CONTROLLER_KIND_DATA",      4); // 種類(データ)
$G_APP_CHECK_NAME_CONTROLLER_KIND_TABLE = array(
	APP_CHECK_NAME_CONTROLLER_KIND_USER,
	APP_CHECK_NAME_CONTROLLER_KIND_DOCUMENT,
	APP_CHECK_NAME_CONTROLLER_KIND_TERM,
	APP_CHECK_NAME_CONTROLLER_KIND_BILINGUAL,
	APP_CHECK_NAME_CONTROLLER_KIND_DATA,
);

// documentController.php
define("APP_DOCUMENT_CONTROLLER_MODE_GET",     0);  // モード(ゲット)  *js
define("APP_DOCUMENT_CONTROLLER_MODE_SET",     1);  // モード(セット)  *js
define("APP_DOCUMENT_CONTROLLER_MODE_EXPORT",  2);  // モード(エクスポート-TSV)  *js
define("APP_DOCUMENT_CONTROLLER_MODE_EXPORT2", 3);  // モード(エクスポート-訳文)  *js
define("APP_DOCUMENT_CONTROLLER_MODE_COPY",    4);  // モード(コピー)  *js
$G_APP_DOCUMENT_CONTROLLER_MODE_TABLE = array(
	APP_DOCUMENT_CONTROLLER_MODE_GET,
	APP_DOCUMENT_CONTROLLER_MODE_SET,
	APP_DOCUMENT_CONTROLLER_MODE_EXPORT,
	APP_DOCUMENT_CONTROLLER_MODE_EXPORT2,
	APP_DOCUMENT_CONTROLLER_MODE_COPY,
);

// loggingController.php
define("APP_LOGGING_CONTROLLER_MODE_LOOKUP", 0);  // モード(lookup)  *js
define("APP_LOGGING_CONTROLLER_MODE_LKUPSL", 1);  // モード(lookup select)  *js
$APP_LOGGING_CONTROLLER_MODE_TABLE = array(
	APP_LOGGING_CONTROLLER_MODE_LOOKUP,
	APP_LOGGING_CONTROLLER_MODE_LKUPSL,
);

// memberContoller.php
define("APP_MEMBER_CONTROLLER_MODE_GET_ORG", 0); // モード(ゲット)  *js
$APP_MEMBER_CONTROLLER_MODE_TABLE = array(
	APP_MEMBER_CONTROLLER_MODE_GET_ORG,
);

// projectController.php
define("APP_PROJECT_CONTROLLER_MODE_GET",    0);  // モード(ゲット)  *js
define("APP_PROJECT_CONTROLLER_MODE_SET",    1);  // モード(セット)  *js
define("APP_PROJECT_CONTROLLER_MODE_EXPORT", 2);  // モード(エクスポート)  *js
define("APP_PROJECT_CONTROLLER_MODE_INFO",   3);  // モード(ゲット)  *js
$APP_PROJECT_CONTROLLER_MODE_TABLE = array(
	APP_PROJECT_CONTROLLER_MODE_GET,
	APP_PROJECT_CONTROLLER_MODE_SET,
	APP_PROJECT_CONTROLLER_MODE_EXPORT,
	APP_PROJECT_CONTROLLER_MODE_INFO,
);

// suggestController.php
define("APP_SUGGEST_CONTROLLER_MODE_USER_NAME", 0); // モード(ユーザー名)  *js
define("APP_SUGGEST_CONTROLLER_MODE_ORG_NAME",  1); // モード(組織名)      *js
$G_APP_SUGGEST_CONTROLLER_KIND_TABLE = array(
	APP_SUGGEST_CONTROLLER_MODE_USER_NAME,
	APP_SUGGEST_CONTROLLER_MODE_ORG_NAME,
);

// taskController.php
define("APP_TASK_CONTROLLER_MODE_GET_TASK_DETAIL", 0);   // モード(ゲット)  *js
define("APP_TASK_CONTROLLER_MODE_GET_TASK_NEW",    1);   // モード(ゲット)  *js
define("APP_TASK_CONTROLLER_MODE_GET_TASK_EDIT",   2);   // モード(ゲット)  *js
define("APP_TASK_CONTROLLER_MODE_SET_TASK_UPDATE", 3);   // モード(セット)  *js
define("APP_TASK_CONTROLLER_MODE_SET_TASK_DELETE", 4);   // モード(セット)  *js
define("APP_TASK_CONTROLLER_MODE_GET_TASKINFO",    5);   // モード(ゲット)  *js
define("APP_TASK_CONTROLLER_MODE_SET_STATE",       6);   // モード(セット)  *js
define("APP_TASK_CONTROLLER_MODE_GET_TASKS_FROM_DOCUMENT", 7);  // モード(ゲット)  *js
define("APP_TASK_CONTROLLER_MODE_ACTION",     100);   // モード(アクション)  *js
$G_APP_TASK_CONTROLLER_MODE_TABLE = array(
	APP_TASK_CONTROLLER_MODE_GET_TASK_DETAIL,
	APP_TASK_CONTROLLER_MODE_GET_TASK_NEW,
	APP_TASK_CONTROLLER_MODE_GET_TASK_EDIT,
	APP_TASK_CONTROLLER_MODE_SET_TASK_UPDATE,
	APP_TASK_CONTROLLER_MODE_SET_TASK_DELETE,
	APP_TASK_CONTROLLER_MODE_GET_TASKINFO,
	APP_TASK_CONTROLLER_MODE_SET_STATE,
	APP_TASK_CONTROLLER_MODE_GET_TASKS_FROM_DOCUMENT,
	APP_TASK_CONTROLLER_MODE_ACTION,
);
// taskChartController.php
define("APP_TASK_CHART_CONTROLLER_MODE_DETAIL",          0);  // モード(詳細_デフォルト)  *js
define("APP_TASK_CHART_CONTROLLER_MODE_DETAIL_TASK",     1);  // モード(詳細_タスクグループごと)  *js
define("APP_TASK_CHART_CONTROLLER_MODE_DETAIL_USER",     2);  // モード(詳細_担当者ごと)  *js
define("APP_TASK_CHART_CONTROLLER_MODE_DETAIL_DOCUMENT", 3);  // モード(詳細_文書ごと)  *js
define("APP_TASK_CHART_CONTROLLER_MODE_ALLOCATE",       10);  // モード(割当)  *js
$G_APP_TASK_CHART_CONTROLLER_MODE_TABLE = array(
	APP_TASK_CHART_CONTROLLER_MODE_DETAIL,
	APP_TASK_CHART_CONTROLLER_MODE_DETAIL_TASK,
	APP_TASK_CHART_CONTROLLER_MODE_DETAIL_USER,
	APP_TASK_CHART_CONTROLLER_MODE_DETAIL_DOCUMENT,
	APP_TASK_CHART_CONTROLLER_MODE_ALLOCATE,
);
// termController.php
define("APP_TERM_CONTROLLER_MODE_FRM", 0);   // モード(フォーム)  *js
define("APP_TERM_CONTROLLER_MODE_SET", 1);   // モード(セット)  *js
define("APP_TERM_CONTROLLER_MODE_DEL", -1);  // モード(削除)  *js
$G_APP_TERM_CONTROLLER_MODE_TABLE = array(
	APP_TERM_CONTROLLER_MODE_FRM,
	APP_TERM_CONTROLLER_MODE_SET,
	APP_TERM_CONTROLLER_MODE_DEL,
);
//UserController.php
define("APP_USER_CONTROLLER_MODE_GET",                 0); // モード(ゲット)  *js
define("APP_USER_CONTROLLER_MODE_SET_STATE",           1); // モード(セット)  *js
define("APP_USER_CONTROLLER_MODE_SET_WARN_NON_ACTIVE", 2); // モード(セット 非活発ユーザー表示)   *js
$G_APP_USER_CONTROLLER_MODE_TABLE = array(
	APP_USER_CONTROLLER_MODE_GET,
	APP_USER_CONTROLLER_MODE_SET_STATE,
	APP_USER_CONTROLLER_MODE_SET_WARN_NON_ACTIVE,
);

// /content/search/index.html
define("CONTENT_SEARCH_INDEX_MODE_BILINGUAL", 1); // モード(対訳検索)      *js
define("CONTENT_SEARCH_INDEX_MODE_SIM",       2); // モード(類似文検索)    *js
define("CONTENT_SEARCH_INDEX_MODE_DOCUMENT",  3); // モード(文書対訳検索)  *js
$G_CONTENT_SEARCH_INDEX_MODE_TABLE = array(
	CONTENT_SEARCH_INDEX_MODE_DOCUMENT,
	CONTENT_SEARCH_INDEX_MODE_BILINGUAL,
	CONTENT_SEARCH_INDEX_MODE_SIM,
);

//----------------------------
// Macro
//----------------------------
$URL = "URL";
function URL( $url ){
	$url = htmlspecialchars($url, ENT_QUOTES, "UTF-8");
	
	if ( preg_match("/^https?:\//", $url) ){
		return $url;
	}
	if ( preg_match("/^\./", $url) ){
		return $url;
	}
	if ( preg_match("/^#/", $url) ){
		return $url;
	}
	
	return Setting::get("URL_HTTP_ROOT") . $url;
}

$WORD = "WORD";
function WORD(){
	$word = "";
	
	$args = func_get_args(); 
	
	$define = array_shift($args);
	$index  = array_shift($args);
	
	$defineWord = (is_null($index)) ? $define : sprintf("%s_%03d", $define, $index);
	
	if ( defined($defineWord) ){
		$word = constant($defineWord);
	} else {
		$word = $defineWord . " ";
	}
	
	array_unshift($args, $word);
	
	$word = call_user_func_array("sprintf", $args);
	
	return $word;
}
