-- MySQL dump 10.13  Distrib 5.1.58, for redhat-linux-gnu (x86_64)
--
-- Host: 10.102.33.11    Database: edudb
-- ------------------------------------------------------
-- Server version	5.0.95

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Not dumping tablespaces as no INFORMATION_SCHEMA.FILES table on this server
--

--
-- Table structure for table `t_bbs`
--

DROP TABLE IF EXISTS `t_bbs`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_bbs` (
  `t_bbs_id` mediumint(8) unsigned NOT NULL auto_increment,
  `t_bbs_name` varchar(255) NOT NULL default '',
  `t_bbs_text` mediumtext NOT NULL,
  `t_project_id` mediumint(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (`t_bbs_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_bbs_post`
--

DROP TABLE IF EXISTS `t_bbs_post`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_bbs_post` (
  `t_bbs_post_no` int(10) unsigned NOT NULL default '0',
  `t_bbs_post_parent_no` int(10) unsigned NOT NULL default '0',
  `t_bbs_post_state` tinyint(4) NOT NULL default '0',
  `t_bbs_post_kind` tinyint(3) unsigned NOT NULL default '0',
  `t_bbs_post_stage` tinyint(3) unsigned NOT NULL default '0',
  `t_bbs_post_type` tinyint(3) unsigned NOT NULL default '0',
  `t_bbs_post_role` smallint(5) unsigned NOT NULL default '0',
  `t_bbs_post_object` text NOT NULL,
  `t_bbs_post_title` varchar(255) NOT NULL default '',
  `t_bbs_post_text` mediumtext NOT NULL,
  `t_bbs_post_document` mediumtext NOT NULL,
  `t_bbs_post_document_select` text NOT NULL,
  `t_bbs_post_register` datetime NOT NULL,
  `t_bbs_id` mediumint(8) unsigned NOT NULL default '0',
  `t_user_id` mediumint(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (`t_bbs_post_no`,`t_bbs_id`),
  KEY `t_bbs_post_kind` (`t_bbs_post_kind`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_bbs_post_bilingual_root`
--

DROP TABLE IF EXISTS `t_bbs_post_bilingual_root`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_bbs_post_bilingual_root` (
  `t_bbs_post_no` int(10) unsigned NOT NULL default '0',
  `t_bbs_id` mediumint(8) unsigned NOT NULL default '0',
  `t_bilingual_root_id` mediumint(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (`t_bbs_post_no`,`t_bbs_id`,`t_bilingual_root_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_bbs_post_data`
--

DROP TABLE IF EXISTS `t_bbs_post_data`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_bbs_post_data` (
  `t_bbs_post_no` int(10) unsigned NOT NULL default '0',
  `t_bbs_id` mediumint(8) unsigned NOT NULL default '0',
  `t_data_id` mediumint(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (`t_bbs_post_no`,`t_bbs_id`,`t_data_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_bbs_post_target`
--

DROP TABLE IF EXISTS `t_bbs_post_target`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_bbs_post_target` (
  `t_bbs_post_target_role` smallint(5) unsigned NOT NULL default '0',
  `t_user_id` mediumint(8) unsigned NOT NULL default '0',
  `t_bbs_post_no` int(10) unsigned NOT NULL default '0',
  `t_bbs_id` mediumint(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (`t_bbs_post_target_role`,`t_user_id`,`t_bbs_post_no`,`t_bbs_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_bbs_post_term_root`
--

DROP TABLE IF EXISTS `t_bbs_post_term_root`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_bbs_post_term_root` (
  `t_bbs_post_no` int(10) unsigned NOT NULL default '0',
  `t_bbs_id` mediumint(8) unsigned NOT NULL default '0',
  `t_term_root_id` mediumint(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (`t_bbs_post_no`,`t_bbs_id`,`t_term_root_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_bilingual`
--

DROP TABLE IF EXISTS `t_bilingual`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_bilingual` (
  `t_bilingual_id` int(10) unsigned NOT NULL auto_increment,
  `t_bilingual_text_s` varchar(255) NOT NULL default '',
  `t_bilingual_text_t` varchar(255) NOT NULL default '',
  `t_bilingual_root_id` mediumint(8) unsigned default NULL,
  `t_user_id` mediumint(8) unsigned NOT NULL,
  PRIMARY KEY  (`t_bilingual_id`),
  UNIQUE KEY `t_bilingual_text` (`t_bilingual_text_s`,`t_bilingual_text_t`,`t_bilingual_root_id`),
  KEY `t_bilingual_text_s` (`t_bilingual_text_s`(10)),
  KEY `t_bilingual_text_t` (`t_bilingual_text_t`(10)),
  KEY `idx_bilingual_root_user` (`t_bilingual_root_id`,`t_user_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_bilingual_root`
--

DROP TABLE IF EXISTS `t_bilingual_root`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_bilingual_root` (
  `t_bilingual_root_id` mediumint(8) unsigned NOT NULL auto_increment,
  `t_bilingual_root_state` tinyint(4) NOT NULL default '0',
  `t_bilingual_root_public` tinyint(4) NOT NULL default '0',
  `t_bilingual_root_name` varchar(255) NOT NULL default '',
  `t_bilingual_root_lang_s` char(5) NOT NULL,
  `t_bilingual_root_lang_t` char(5) NOT NULL,
  `t_bilingual_root_update` datetime NOT NULL,
  `t_project_id` mediumint(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (`t_bilingual_root_id`),
  KEY `t_bilingual_root_state` (`t_bilingual_root_state`),
  KEY `t_bilingual_root_public` (`t_bilingual_root_public`),
  KEY `t_bilingual_root_update` (`t_bilingual_root_update`),
  KEY `t_project_id` (`t_project_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_data`
--

DROP TABLE IF EXISTS `t_data`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_data` (
  `t_data_id` mediumint(8) unsigned NOT NULL auto_increment,
  `t_data_state` tinyint(4) NOT NULL default '0',
  `t_data_public` tinyint(4) NOT NULL default '0',
  `t_data_type` varchar(255) default NULL,
  `t_data_title` varchar(255) NOT NULL,
  `t_data_props` mediumint(8) unsigned NOT NULL default '0',
  `t_data_comment` text NOT NULL,
  `t_data_register` datetime NOT NULL,
  `t_data_update` datetime NOT NULL,
  `t_user_id` mediumint(8) unsigned NOT NULL,
  `t_project_id` mediumint(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (`t_data_id`),
  KEY `t_data_state` (`t_data_state`),
  KEY `t_data_public` (`t_data_public`),
  KEY `t_data_update` (`t_data_update`),
  KEY `t_project_id` (`t_project_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_document`
--

DROP TABLE IF EXISTS `t_document`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_document` (
  `t_document_id` mediumint(8) unsigned NOT NULL auto_increment,
  `t_document_state` tinyint(4) NOT NULL default '0',
  `t_document_lang_s` char(2) NOT NULL default 'ja',
  `t_document_lang_t` char(2) NOT NULL default 'en',
  `t_document_title` varchar(255) NOT NULL,
  `t_document_text` mediumtext NOT NULL,
  `t_document_url` text NOT NULL,
  `t_document_comment` text NOT NULL,
  `t_document_register` datetime NOT NULL,
  `t_document_update` datetime NOT NULL,
  `t_project_id` mediumint(8) unsigned NOT NULL default '0',
  `t_user_id` mediumint(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (`t_document_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_document_text`
--

DROP TABLE IF EXISTS `t_document_text`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_document_text` (
  `t_document_text_id` int(10) unsigned NOT NULL auto_increment,
  `t_document_text_s` text NOT NULL,
  `t_document_text_t` text NOT NULL,
  `t_document_id` mediumint(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (`t_document_text_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_exterm`
--

DROP TABLE IF EXISTS `t_exterm`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_exterm` (
  `t_exterm_id` mediumint(8) unsigned NOT NULL auto_increment,
  `t_exterm_state` tinyint(4) NOT NULL default '0',
  `t_exterm_title` varchar(255) default NULL,
  `t_exterm_lang_s` char(5) NOT NULL,
  `t_exterm_lang_t` char(5) NOT NULL,
  `t_exterm_complete_term_root_id` mediumint(8) unsigned NOT NULL default '0',
  `t_exterm_register` datetime default NULL,
  `t_exterm_update` datetime default NULL,
  `t_user_id` mediumint(8) unsigned NOT NULL default '0',
  `t_project_id` mediumint(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (`t_exterm_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_log_lookup`
--

DROP TABLE IF EXISTS `t_log_lookup`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_log_lookup` (
  `t_log_lookup_date` timestamp NOT NULL default CURRENT_TIMESTAMP,
  `t_log_lookup_no` smallint(5) unsigned NOT NULL,
  `t_log_lookup_lang_s` char(2) NOT NULL default 'ja',
  `t_log_lookup_lang_t` char(2) NOT NULL default 'en',
  `t_log_lookup_index` smallint(5) unsigned NOT NULL default '0',
  `t_log_lookup_text` text NOT NULL,
  `t_log_lookup_pos` text NOT NULL,
  `t_log_lookup_dict_id` text NOT NULL,
  `t_log_lookup_dict_ids` text NOT NULL,
  `t_log_lookup_awareness` text NOT NULL,
  `t_user_id` mediumint(8) unsigned NOT NULL default '0',
  `t_project_id` mediumint(8) unsigned NOT NULL default '0',
  `t_task_id` mediumint(8) unsigned NOT NULL default '0',
  `t_task_type` tinyint(3) unsigned NOT NULL default '0',
  `t_task_role` smallint(5) unsigned NOT NULL default '0',
  `t_document_id` mediumint(8) unsigned NOT NULL default '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_log_lookup_select`
--

DROP TABLE IF EXISTS `t_log_lookup_select`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_log_lookup_select` (
  `t_log_lookup_select_date` timestamp NOT NULL default CURRENT_TIMESTAMP,
  `t_log_lookup_select_mode` tinyint(3) unsigned NOT NULL default '0',
  `t_log_lookup_select_no` smallint(5) unsigned NOT NULL default '0',
  `t_log_lookup_select_lang_s` char(2) NOT NULL default 'ja',
  `t_log_lookup_select_lang_t` char(2) NOT NULL default 'en',
  `t_log_lookup_select_text_s` text NOT NULL,
  `t_log_lookup_select_text_t` text NOT NULL,
  `t_log_lookup_select_heading` text NOT NULL,
  `t_log_lookup_select_kind` tinyint(3) unsigned NOT NULL default '0',
  `t_log_lookup_select_search_lang_s` char(2) NOT NULL default 'ja',
  `t_log_lookup_select_search_lang_t` char(2) NOT NULL default 'en',
  `t_user_id` mediumint(8) unsigned NOT NULL default '0',
  `t_project_id` mediumint(8) unsigned NOT NULL default '0',
  `t_task_id` mediumint(8) unsigned NOT NULL default '0',
  `t_task_type` tinyint(3) unsigned NOT NULL default '0',
  `t_task_role` smallint(5) unsigned NOT NULL default '0',
  `t_document_id` mediumint(8) unsigned NOT NULL default '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_log_task`
--

DROP TABLE IF EXISTS `t_log_task`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_log_task` (
  `t_log_task_date` timestamp NOT NULL default CURRENT_TIMESTAMP,
  `t_log_task_state` tinyint(4) NOT NULL default '0',
  `t_user_id` mediumint(8) unsigned NOT NULL default '0',
  `t_organization_id` smallint(8) unsigned NOT NULL default '0',
  `t_project_id` mediumint(8) unsigned NOT NULL default '0',
  `t_task_id` mediumint(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (`t_log_task_date`,`t_user_id`,`t_task_id`),
  KEY `t_organization_id` (`t_organization_id`),
  KEY `t_project_id` (`t_project_id`),
  KEY `t_task_id` (`t_task_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_login`
--

DROP TABLE IF EXISTS `t_login`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_login` (
  `t_login_state` tinyint(3) unsigned NOT NULL default '0',
  `t_login_date` timestamp NOT NULL default CURRENT_TIMESTAMP,
  `t_user_id` mediumint(8) unsigned NOT NULL default '0',
  KEY `t_user_id` (`t_user_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_organization`
--

DROP TABLE IF EXISTS `t_organization`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_organization` (
  `t_organization_id` smallint(5) unsigned NOT NULL auto_increment,
  `t_organization_name` char(50) NOT NULL default '',
  `t_mtauto_name` varchar(12) NOT NULL default '',
  `t_mtauto_key` varchar(64) NOT NULL default '',
  `t_mtauto_secret` varchar(64) NOT NULL default '',
  `t_organization_text` mediumtext NOT NULL,
  `t_organization_register` datetime default NULL,
  PRIMARY KEY  (`t_organization_id`),
  UNIQUE KEY `t_user_name` (`t_organization_name`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_project`
--

DROP TABLE IF EXISTS `t_project`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_project` (
  `t_project_id` mediumint(8) unsigned NOT NULL auto_increment,
  `t_project_state` tinyint(4) NOT NULL default '0',
  `t_project_name` text NOT NULL,
  `t_project_start` date default NULL,
  `t_project_end` date default NULL,
  `t_project_text` text NOT NULL,
  `t_project_qredit_dictionary` text NOT NULL,
  `t_project_register` datetime NOT NULL,
  `t_project_update` datetime NOT NULL,
  `t_user_id` mediumint(8) unsigned NOT NULL default '0',
  `t_organization_id` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`t_project_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_project_bilingual_root`
--

DROP TABLE IF EXISTS `t_project_bilingual_root`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_project_bilingual_root` (
  `t_bilingual_root_id` smallint(5) unsigned NOT NULL default '0',
  `t_project_id` mediumint(8) unsigned NOT NULL default '0',
  `t_user_id` mediumint(8) unsigned NOT NULL default '0',
  `t_project_bilingual_root_type` tinyint(4) unsigned NOT NULL default '0',
  PRIMARY KEY  (`t_bilingual_root_id`,`t_project_id`),
  KEY `t_user_id` (`t_user_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_project_data`
--

DROP TABLE IF EXISTS `t_project_data`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_project_data` (
  `t_data_id` mediumint(8) unsigned NOT NULL default '0',
  `t_project_id` mediumint(8) unsigned NOT NULL default '0',
  `t_user_id` mediumint(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (`t_data_id`,`t_project_id`),
  KEY `t_user_id` (`t_user_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_project_lang`
--

DROP TABLE IF EXISTS `t_project_lang`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_project_lang` (
  `t_project_lang_s` char(2) NOT NULL default 'en',
  `t_project_lang_t` char(2) NOT NULL default 'ja',
  `t_project_id` mediumint(8) unsigned NOT NULL default '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_project_term_root`
--

DROP TABLE IF EXISTS `t_project_term_root`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_project_term_root` (
  `t_term_root_id` mediumint(8) unsigned NOT NULL default '0',
  `t_project_id` mediumint(8) unsigned NOT NULL default '0',
  `t_user_id` mediumint(8) unsigned NOT NULL default '0',
  `t_project_term_root_type` tinyint(4) unsigned NOT NULL default '0',
  PRIMARY KEY  (`t_term_root_id`,`t_project_id`),
  KEY `t_user_id` (`t_user_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_project_user`
--

DROP TABLE IF EXISTS `t_project_user`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_project_user` (
  `t_project_user_role` smallint(5) unsigned NOT NULL default '0',
  `t_project_id` mediumint(8) unsigned NOT NULL default '0',
  `t_user_id` mediumint(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (`t_project_user_role`,`t_project_id`,`t_user_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_tag`
--

DROP TABLE IF EXISTS `t_tag`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_tag` (
  `t_tag_id` mediumint(8) unsigned NOT NULL auto_increment,
  `t_tag_text` varchar(256) NOT NULL default '',
  PRIMARY KEY  (`t_tag_id`),
  KEY `t_tag_text` (`t_tag_text`(10))
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_tag_dictionary`
--

DROP TABLE IF EXISTS `t_tag_dictionary`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_tag_dictionary` (
  `t_tag_id` mediumint(8) unsigned NOT NULL default '0',
  `t_dictionary_id` mediumint(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (`t_tag_id`,`t_dictionary_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_tag_document`
--

DROP TABLE IF EXISTS `t_tag_document`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_tag_document` (
  `t_tag_id` mediumint(8) unsigned NOT NULL default '0',
  `t_document_id` mediumint(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (`t_document_id`,`t_tag_id`),
  KEY `t_tag_id` (`t_tag_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_tag_project`
--

DROP TABLE IF EXISTS `t_tag_project`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_tag_project` (
  `t_tag_id` mediumint(8) unsigned NOT NULL default '0',
  `t_project_id` mediumint(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (`t_tag_id`,`t_project_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_tag_term`
--

DROP TABLE IF EXISTS `t_tag_term`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_tag_term` (
  `t_tag_id` mediumint(8) unsigned NOT NULL default '0',
  `t_term_id` bigint(20) unsigned NOT NULL default '0',
  PRIMARY KEY  (`t_tag_id`,`t_term_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_tag_user`
--

DROP TABLE IF EXISTS `t_tag_user`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_tag_user` (
  `t_tag_id` mediumint(8) unsigned NOT NULL default '0',
  `t_user_id` mediumint(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (`t_tag_id`,`t_user_id`),
  KEY `t_user_id` (`t_user_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_task`
--

DROP TABLE IF EXISTS `t_task`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_task` (
  `t_task_id` mediumint(8) unsigned NOT NULL auto_increment,
  `t_task_state` tinyint(4) NOT NULL default '0',
  `t_task_type` tinyint(3) unsigned NOT NULL default '0',
  `t_task_data` mediumtext NOT NULL,
  `t_task_start` date NOT NULL,
  `t_task_end` date NOT NULL,
  `t_workflow_id` mediumint(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (`t_task_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_task_actor`
--

DROP TABLE IF EXISTS `t_task_actor`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_task_actor` (
  `t_task_id` mediumint(8) unsigned NOT NULL default '0',
  `t_task_role` smallint(5) unsigned NOT NULL default '0',
  `t_task_actor_type` smallint(5) unsigned NOT NULL default '0',
  `t_user_id` mediumint(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (`t_task_id`,`t_task_role`,`t_user_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_task_bilingual_root`
--

DROP TABLE IF EXISTS `t_task_bilingual_root`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_task_bilingual_root` (
  `t_task_id` mediumint(8) unsigned NOT NULL default '0',
  `t_bilingual_root_id` mediumint(8) unsigned NOT NULL default '0',
  `t_task_props` char(50) NOT NULL default '',
  PRIMARY KEY  (`t_task_id`,`t_bilingual_root_id`,`t_task_props`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_task_data`
--

DROP TABLE IF EXISTS `t_task_data`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_task_data` (
  `t_task_id` mediumint(8) unsigned NOT NULL default '0',
  `t_data_id` mediumint(8) unsigned NOT NULL default '0',
  `t_task_props` char(50) NOT NULL default '',
  PRIMARY KEY  (`t_task_id`,`t_data_id`,`t_task_props`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_task_document`
--

DROP TABLE IF EXISTS `t_task_document`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_task_document` (
  `t_task_id` mediumint(8) unsigned NOT NULL default '0',
  `t_document_id` mediumint(8) unsigned NOT NULL default '0',
  `t_task_props` char(50) NOT NULL default '',
  PRIMARY KEY  (`t_task_id`,`t_document_id`,`t_task_props`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_task_term_root`
--

DROP TABLE IF EXISTS `t_task_term_root`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_task_term_root` (
  `t_task_id` mediumint(8) unsigned NOT NULL default '0',
  `t_term_root_id` mediumint(8) unsigned NOT NULL default '0',
  `t_task_props` char(50) NOT NULL default '',
  PRIMARY KEY  (`t_task_id`,`t_term_root_id`,`t_task_props`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_term`
--

DROP TABLE IF EXISTS `t_term`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_term` (
  `t_term_id` int(10) unsigned NOT NULL auto_increment,
  `t_term_text_s` varchar(255) NOT NULL default '',
  `t_term_text_t` varchar(255) NOT NULL default '',
  `t_term_root_id` mediumint(8) unsigned default NULL,
  `t_user_id` mediumint(8) unsigned NOT NULL,
  PRIMARY KEY  (`t_term_id`),
  UNIQUE KEY `t_term_text` (`t_term_text_s`,`t_term_text_t`,`t_term_root_id`),
  KEY `t_term_text_s` (`t_term_text_s`(10)),
  KEY `t_term_text_t` (`t_term_text_t`(10)),
  KEY `idx_term_root_user` (`t_term_root_id`,`t_user_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_term_root`
--

DROP TABLE IF EXISTS `t_term_root`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_term_root` (
  `t_term_root_id` mediumint(8) unsigned NOT NULL auto_increment,
  `t_term_root_state` tinyint(4) NOT NULL default '0',
  `t_term_root_public` tinyint(4) NOT NULL default '0',
  `t_term_root_name` varchar(255) NOT NULL default '',
  `t_term_root_lang_s` char(5) NOT NULL,
  `t_term_root_lang_t` char(5) NOT NULL,
  `t_term_root_update` datetime NOT NULL,
  `t_project_id` mediumint(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (`t_term_root_id`),
  KEY `t_term_root_state` (`t_term_root_state`),
  KEY `t_term_root_public` (`t_term_root_public`),
  KEY `t_term_root_update` (`t_term_root_update`),
  KEY `t_project_id` (`t_project_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_user`
--

DROP TABLE IF EXISTS `t_user`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_user` (
  `t_user_id` mediumint(8) unsigned NOT NULL auto_increment,
  `t_user_name` char(24) NOT NULL default '',
  `t_user_state` tinyint(4) NOT NULL default '0',
  `t_user_type` tinyint(3) unsigned NOT NULL default '3',
  `t_user_password` char(80) NOT NULL,
  `t_user_question` tinyint(4) NOT NULL default '-1',
  `t_user_answer` char(80) NOT NULL default '',
  `t_user_disp_lang` char(2) NOT NULL default 'ja',
  `t_user_login` tinyint(3) unsigned NOT NULL default '0',
  `t_user_warn_non_active` tinyint(3) unsigned NOT NULL default '0',
  `t_user_system_text` mediumtext NOT NULL,
  `t_user_text` mediumtext NOT NULL,
  `t_user_twitter` char(16) NOT NULL default '',
  `t_user_qredit_dictionary` bigint(20) unsigned NOT NULL default '0',
  `t_user_dictionary` bigint(20) unsigned NOT NULL,
  `t_user_qredit_display` char(6) NOT NULL default 'left',
  `t_user_qredit_width` smallint(5) unsigned NOT NULL default '0',
  `t_user_qredit_scroll` char(6) NOT NULL default 'both',
  `t_user_qredit_lookup` char(6) NOT NULL default 'inside',
  `t_user_qredit_action` char(8) NOT NULL default 'paste',
  `t_user_qredit_tag` char(6) NOT NULL default 'off',
  `t_user_session_id` text NOT NULL,
  `t_user_register` datetime default NULL,
  `t_organization_id` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`t_user_id`),
  UNIQUE KEY `t_user_name` (`t_user_name`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_workflow`
--

DROP TABLE IF EXISTS `t_workflow`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_workflow` (
  `t_workflow_id` mediumint(8) unsigned NOT NULL auto_increment,
  `t_workflow_state` tinyint(4) NOT NULL default '0',
  `t_workflow_name` text NOT NULL,
  `t_workflow_text` text NOT NULL,
  `t_workflow_task_type` text NOT NULL,
  `t_project_id` mediumint(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (`t_workflow_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping routines for database 'edudb'
--
/*!50003 DROP FUNCTION IF EXISTS `get_bbs_id_by_project_id` */;
--
-- WARNING: old server version. The following dump may be incomplete.
--
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/  /*!50003 FUNCTION `get_bbs_id_by_project_id`(_t_project_id mediumint unsigned) RETURNS mediumint(8) unsigned
    DETERMINISTIC
begin
return (select t_bbs_id from t_bbs where t_project_id = _t_project_id limit 1);
end */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 DROP FUNCTION IF EXISTS `get_bilingual_root_name` */;
--
-- WARNING: old server version. The following dump may be incomplete.
--
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/  /*!50003 FUNCTION `get_bilingual_root_name`(_t_bilingual_root_id smallint unsigned) RETURNS varchar(255) CHARSET utf8
    DETERMINISTIC
begin
return (select t_bilingual_root_name from t_bilingual_root where t_bilingual_root_id = _t_bilingual_root_id limit 1);
end */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 DROP FUNCTION IF EXISTS `get_bilingual_root_public` */;
--
-- WARNING: old server version. The following dump may be incomplete.
--
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/  /*!50003 FUNCTION `get_bilingual_root_public`(_t_bilingual_root_id smallint unsigned) RETURNS tinyint(4)
    DETERMINISTIC
begin
return (select t_bilingual_root_public from t_bilingual_root where t_bilingual_root_id = _t_bilingual_root_id limit 1);
end */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 DROP FUNCTION IF EXISTS `get_data_title` */;
--
-- WARNING: old server version. The following dump may be incomplete.
--
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/  /*!50003 FUNCTION `get_data_title`(_t_data_id smallint unsigned) RETURNS varchar(255) CHARSET utf8
    DETERMINISTIC
begin
return (select t_data_title from t_data where t_data_id = _t_data_id limit 1);
end */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 DROP FUNCTION IF EXISTS `get_document_title` */;
--
-- WARNING: old server version. The following dump may be incomplete.
--
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/  /*!50003 FUNCTION `get_document_title`(_t_document_id mediumint unsigned) RETURNS varchar(255) CHARSET utf8
    DETERMINISTIC
begin
return (select t_document_title from t_document where t_document_id = _t_document_id limit 1);
end */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 DROP FUNCTION IF EXISTS `get_exterm_state_by_term_root_id` */;
--
-- WARNING: old server version. The following dump may be incomplete.
--
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/  /*!50003 FUNCTION `get_exterm_state_by_term_root_id`(_t_term_root_id mediumint unsigned) RETURNS tinyint(4)
    DETERMINISTIC
begin
return (select t_exterm_state from t_exterm where t_exterm_complete_term_root_id = _t_term_root_id limit 1);
end */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 DROP FUNCTION IF EXISTS `get_last_login_date_by_user_id` */;
--
-- WARNING: old server version. The following dump may be incomplete.
--
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/  /*!50003 FUNCTION `get_last_login_date_by_user_id`(_t_user_id mediumint unsigned) RETURNS timestamp
    DETERMINISTIC
begin
return (select MAX(t_login_date) from t_login group by t_user_id having t_user_id=_t_user_id);
end */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 DROP FUNCTION IF EXISTS `get_max_bbs_post_no_by_bbs_id` */;
--
-- WARNING: old server version. The following dump may be incomplete.
--
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/  /*!50003 FUNCTION `get_max_bbs_post_no_by_bbs_id`(_t_bbs_id mediumint unsigned) RETURNS smallint(6)
    DETERMINISTIC
begin
return (select max(t_bbs_post_no) from t_bbs_post where t_bbs_id = _t_bbs_id);
end */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 DROP FUNCTION IF EXISTS `get_organization_id_by_user_id` */;
--
-- WARNING: old server version. The following dump may be incomplete.
--
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/  /*!50003 FUNCTION `get_organization_id_by_user_id`(`_t_user_id` MEDIUMINT UNSIGNED) RETURNS mediumint(8) unsigned
    DETERMINISTIC
begin
return (select t_organization_id from t_user where t_user_id=_t_user_id limit 1);
end */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 DROP FUNCTION IF EXISTS `get_organization_name` */;
--
-- WARNING: old server version. The following dump may be incomplete.
--
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/  /*!50003 FUNCTION `get_organization_name`(_t_organization_id mediumint unsigned) RETURNS char(50) CHARSET utf8
    DETERMINISTIC
begin
return (select t_organization_name from t_organization where t_organization_id = _t_organization_id limit 1);
end */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 DROP FUNCTION IF EXISTS `get_organization_user_count` */;
--
-- WARNING: old server version. The following dump may be incomplete.
--
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/  /*!50003 FUNCTION `get_organization_user_count`(_t_organization_id mediumint unsigned) RETURNS int(11)
    DETERMINISTIC
begin
return (select count(t_user_id) from t_user where t_organization_id = _t_organization_id);
end */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 DROP FUNCTION IF EXISTS `get_project_bilingual_root_type` */;
--
-- WARNING: old server version. The following dump may be incomplete.
--
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/  /*!50003 FUNCTION `get_project_bilingual_root_type`(`_t_project_id` MEDIUMINT UNSIGNED, `_t_bilingual_root_id` MEDIUMINT UNSIGNED) RETURNS tinyint(4)
    DETERMINISTIC
begin 
return (select t_project_bilingual_root_type from t_project_bilingual_root where t_project_id = _t_project_id and t_bilingual_root_id = _t_bilingual_root_id); 
end */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 DROP FUNCTION IF EXISTS `get_project_id_by_bbs_id` */;
--
-- WARNING: old server version. The following dump may be incomplete.
--
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/  /*!50003 FUNCTION `get_project_id_by_bbs_id`(_t_bbs_id mediumint unsigned) RETURNS mediumint(8) unsigned
    DETERMINISTIC
begin
return (select t_project_id from t_bbs where t_bbs_id = _t_bbs_id limit 1);
end */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 DROP FUNCTION IF EXISTS `get_project_id_by_bilingual_root_id` */;
--
-- WARNING: old server version. The following dump may be incomplete.
--
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/  /*!50003 FUNCTION `get_project_id_by_bilingual_root_id`(`_t_bilingual_root_id` MEDIUMINT UNSIGNED) RETURNS mediumint(8) unsigned
    DETERMINISTIC
begin
return (select t_project_id from t_bilingual_root where t_bilingual_root_id=_t_bilingual_root_id limit 1);
end */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 DROP FUNCTION IF EXISTS `get_project_id_by_data_id` */;
--
-- WARNING: old server version. The following dump may be incomplete.
--
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/  /*!50003 FUNCTION `get_project_id_by_data_id`(_t_data_id mediumint unsigned) RETURNS mediumint(8) unsigned
    DETERMINISTIC
begin
return (select t_project_id from t_data where t_data_id=_t_data_id limit 1);
end */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 DROP FUNCTION IF EXISTS `get_project_id_by_term_root_id` */;
--
-- WARNING: old server version. The following dump may be incomplete.
--
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/  /*!50003 FUNCTION `get_project_id_by_term_root_id`(`_t_term_root_id` MEDIUMINT UNSIGNED) RETURNS mediumint(8) unsigned
    DETERMINISTIC
begin
return (select t_project_id from t_term_root where t_term_root_id=_t_term_root_id limit 1);
end */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 DROP FUNCTION IF EXISTS `get_project_id_by_workflow_id` */;
--
-- WARNING: old server version. The following dump may be incomplete.
--
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/  /*!50003 FUNCTION `get_project_id_by_workflow_id`(_t_workflow_id mediumint unsigned) RETURNS mediumint(8) unsigned
    DETERMINISTIC
begin
return (select t_project_id from t_workflow where t_workflow_id = _t_workflow_id limit 1);
end */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 DROP FUNCTION IF EXISTS `get_project_name` */;
--
-- WARNING: old server version. The following dump may be incomplete.
--
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/  /*!50003 FUNCTION `get_project_name`(_t_project_id mediumint unsigned) RETURNS text CHARSET utf8
    DETERMINISTIC
begin
return (select t_project_name from t_project where t_project_id = _t_project_id limit 1);
end */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 DROP FUNCTION IF EXISTS `get_project_name_by_bbs_id` */;
--
-- WARNING: old server version. The following dump may be incomplete.
--
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/  /*!50003 FUNCTION `get_project_name_by_bbs_id`(_t_bbs_id mediumint unsigned) RETURNS text CHARSET utf8
    DETERMINISTIC
begin
return (select t_project_name from t_project where t_project_id = get_project_id_by_bbs_id(_t_bbs_id) limit 1);
end */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 DROP FUNCTION IF EXISTS `get_project_name_by_workflow_id` */;
--
-- WARNING: old server version. The following dump may be incomplete.
--
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/  /*!50003 FUNCTION `get_project_name_by_workflow_id`(_t_workflow_id mediumint unsigned) RETURNS text CHARSET utf8
    DETERMINISTIC
begin
return (select t_project_name from t_project where t_project_id = get_project_id_by_workflow_id(_t_workflow_id) limit 1);
end */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 DROP FUNCTION IF EXISTS `get_project_organization_id` */;
--
-- WARNING: old server version. The following dump may be incomplete.
--
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/  /*!50003 FUNCTION `get_project_organization_id`(_t_project_id mediumint unsigned) RETURNS smallint(5) unsigned
    DETERMINISTIC
begin
return (select t_organization_id from t_project where t_project_id = _t_project_id limit 1);
end */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 DROP FUNCTION IF EXISTS `get_project_start` */;
--
-- WARNING: old server version. The following dump may be incomplete.
--
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/  /*!50003 FUNCTION `get_project_start`(_t_project_id mediumint unsigned) RETURNS datetime
    DETERMINISTIC
begin
return (SELECT t_project_start FROM t_project WHERE t_project_id=_t_project_id);
end */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 DROP FUNCTION IF EXISTS `get_project_term_root_type` */;
--
-- WARNING: old server version. The following dump may be incomplete.
--
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/  /*!50003 FUNCTION `get_project_term_root_type`(`_t_project_id` MEDIUMINT UNSIGNED, `_t_term_root_id` MEDIUMINT UNSIGNED) RETURNS tinyint(4)
    DETERMINISTIC
begin 
return (select t_project_term_root_type from t_project_term_root where t_project_id = _t_project_id and t_term_root_id = _t_term_root_id); 
end */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 DROP FUNCTION IF EXISTS `get_task_state` */;
--
-- WARNING: old server version. The following dump may be incomplete.
--
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/  /*!50003 FUNCTION `get_task_state`(_t_task_id mediumint unsigned) RETURNS tinyint(4)
    DETERMINISTIC
begin
return (select t_task_state from t_task where t_task_id = _t_task_id limit 1);
end */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 DROP FUNCTION IF EXISTS `get_task_type` */;
--
-- WARNING: old server version. The following dump may be incomplete.
--
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/  /*!50003 FUNCTION `get_task_type`(_t_task_id mediumint unsigned) RETURNS tinyint(4)
    DETERMINISTIC
begin
return (select t_task_type from t_task where t_task_id = _t_task_id limit 1);
end */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 DROP FUNCTION IF EXISTS `get_term_root_name` */;
--
-- WARNING: old server version. The following dump may be incomplete.
--
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/  /*!50003 FUNCTION `get_term_root_name`(_t_term_root_id mediumint unsigned) RETURNS varchar(255) CHARSET utf8
    DETERMINISTIC
begin
return (select t_term_root_name from t_term_root where t_term_root_id = _t_term_root_id limit 1);
end */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 DROP FUNCTION IF EXISTS `get_term_root_public` */;
--
-- WARNING: old server version. The following dump may be incomplete.
--
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/  /*!50003 FUNCTION `get_term_root_public`(_t_term_root_id mediumint unsigned) RETURNS tinyint(4)
    DETERMINISTIC
begin
return (select t_term_root_public from t_term_root where t_term_root_id = _t_term_root_id limit 1);
end */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 DROP FUNCTION IF EXISTS `get_user_dictionary` */;
--
-- WARNING: old server version. The following dump may be incomplete.
--
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/  /*!50003 FUNCTION `get_user_dictionary`(_t_user_id mediumint unsigned) RETURNS bigint(20) unsigned
    DETERMINISTIC
begin
return (select t_user_dictionary from t_user where t_user_id = _t_user_id limit 1);
end */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 DROP FUNCTION IF EXISTS `get_user_id_by_project_id` */;
--
-- WARNING: old server version. The following dump may be incomplete.
--
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/  /*!50003 FUNCTION `get_user_id_by_project_id`(`_t_project_id` MEDIUMINT UNSIGNED) RETURNS mediumint(8) unsigned
    DETERMINISTIC
begin
return (select t_user_id from t_project where t_project_id=_t_project_id limit 1);
end */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 DROP FUNCTION IF EXISTS `get_user_id_by_session` */;
--
-- WARNING: old server version. The following dump may be incomplete.
--
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/  /*!50003 FUNCTION `get_user_id_by_session`(_t_user_session_id text) RETURNS mediumint(8) unsigned
    DETERMINISTIC
begin
return (select t_user_id from t_user where t_user_session_id = _t_user_session_id and t_user_session_id <> '' limit 1);
end */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 DROP FUNCTION IF EXISTS `get_user_name` */;
--
-- WARNING: old server version. The following dump may be incomplete.
--
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/  /*!50003 FUNCTION `get_user_name`(_t_user_id mediumint unsigned) RETURNS char(24) CHARSET utf8
    DETERMINISTIC
begin
return (select t_user_name from t_user where t_user_id = _t_user_id limit 1);
end */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 DROP FUNCTION IF EXISTS `get_user_state` */;
--
-- WARNING: old server version. The following dump may be incomplete.
--
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/  /*!50003 FUNCTION `get_user_state`(_t_user_id mediumint unsigned) RETURNS tinyint(4)
    DETERMINISTIC
begin
return (select t_user_state from t_user where t_user_id = _t_user_id limit 1);
end */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 DROP FUNCTION IF EXISTS `get_user_type` */;
--
-- WARNING: old server version. The following dump may be incomplete.
--
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/  /*!50003 FUNCTION `get_user_type`(_t_user_id mediumint unsigned) RETURNS tinyint(3) unsigned
    DETERMINISTIC
begin
return (select t_user_type from t_user where t_user_id = _t_user_id limit 1);
end */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 DROP FUNCTION IF EXISTS `get_workflow_id_by_project_id` */;
--
-- WARNING: old server version. The following dump may be incomplete.
--
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/  /*!50003 FUNCTION `get_workflow_id_by_project_id`(_t_project_id mediumint unsigned) RETURNS mediumint(8) unsigned
    DETERMINISTIC
begin
return (select t_workflow_id from t_workflow where t_project_id = _t_project_id limit 1);
end */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 DROP FUNCTION IF EXISTS `get_workflow_id_by_task_id` */;
--
-- WARNING: old server version. The following dump may be incomplete.
--
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/  /*!50003 FUNCTION `get_workflow_id_by_task_id`(_t_task_id mediumint unsigned) RETURNS mediumint(8) unsigned
    DETERMINISTIC
begin
return (select t_workflow_id from t_task where t_task_id = _t_task_id limit 1);
end */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 DROP FUNCTION IF EXISTS `is_bbs_post_target` */;
--
-- WARNING: old server version. The following dump may be incomplete.
--
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/  /*!50003 FUNCTION `is_bbs_post_target`(`_t_bbs_id` MEDIUMINT UNSIGNED, `_t_bbs_post_no` MEDIUMINT UNSIGNED, `_t_user_id` MEDIUMINT UNSIGNED) RETURNS tinyint(4)
    DETERMINISTIC
begin
return exists (select t_user_id from t_bbs_post_target where t_bbs_id = _t_bbs_id and t_bbs_post_no = _t_bbs_post_no and ((t_user_id = _t_user_id) or (t_user_id = 0 and is_project_member(get_project_id_by_bbs_id(t_bbs_id), _t_user_id))));
end */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 DROP FUNCTION IF EXISTS `is_project_data` */;
--
-- WARNING: old server version. The following dump may be incomplete.
--
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/  /*!50003 FUNCTION `is_project_data`(_t_project_id mediumint unsigned, _t_data_id smallint unsigned) RETURNS tinyint(4)
    DETERMINISTIC
begin
return exists (select t_data_id from t_project_data where t_project_id = _t_project_id and t_data_id = _t_data_id);
end */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 DROP FUNCTION IF EXISTS `is_project_member` */;
--
-- WARNING: old server version. The following dump may be incomplete.
--
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/  /*!50003 FUNCTION `is_project_member`(`_t_project_id` MEDIUMINT UNSIGNED, `_t_user_id` MEDIUMINT UNSIGNED) RETURNS tinyint(4)
    DETERMINISTIC
begin
return exists (select t_user_id from t_project_user where t_project_id = _t_project_id and t_user_id = _t_user_id);

end */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 DROP FUNCTION IF EXISTS `is_task_user` */;
--
-- WARNING: old server version. The following dump may be incomplete.
--
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/  /*!50003 FUNCTION `is_task_user`(_t_task_id mediumint unsigned, _t_user_id mediumint unsigned) RETURNS tinyint(4)
    DETERMINISTIC
begin
return exists (select t_user_id from t_task_actor where t_task_id = _t_task_id and t_user_id = _t_user_id and t_task_actor_type = 0);
end */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 DROP PROCEDURE IF EXISTS `get_user_qredit` */;
--
-- WARNING: old server version. The following dump may be incomplete.
--
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/  /*!50003 PROCEDURE `get_user_qredit`(IN `_t_user_id` MEDIUMINT UNSIGNED, IN `_t_project_id` MEDIUMINT UNSIGNED)
begin
declare project_dictionary varchar(64);
(select LPAD(t_project_qredit_dictionary, 63, '-') INTO project_dictionary from t_project where t_project_id = _t_project_id limit 1);
set project_dictionary = IFNULL( project_dictionary, REPEAT('-',63) );
(select ((t_user_qredit_dictionary | CONV(REPLACE(project_dictionary, '-', 0), 2, 10)) & CONV(REPLACE(project_dictionary, '-', 1), 2, 10)) as dictionary, t_user_qredit_display as display, t_user_qredit_width as width, t_user_qredit_scroll as scroll, t_user_qredit_lookup as lookup, t_user_qredit_action as action, t_user_qredit_tag as tag from t_user where t_user_id = _t_user_id limit 1);
end */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 DROP PROCEDURE IF EXISTS `select_project_bilingual` */;
--
-- WARNING: old server version. The following dump may be incomplete.
--
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/  /*!50003 PROCEDURE `select_project_bilingual`(IN `_t_project_id` MEDIUMINT UNSIGNED, IN `_t_bilingual` CHAR(255))
begin 
select * from t_bilingual where t_bilingual_text_s = _t_bilingual and t_bilingual_root_id in (select t_bilingual_root_id from t_project_bilingual_root where t_project_id = _t_project_id and t_project_bilingual_root_type = 0); 
end */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 DROP PROCEDURE IF EXISTS `select_project_term` */;
--
-- WARNING: old server version. The following dump may be incomplete.
--
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/  /*!50003 PROCEDURE `select_project_term`(IN `_t_project_id` MEDIUMINT UNSIGNED, IN `_t_term` CHAR(255))
begin 
select * from t_term where t_term_text_s = _t_term and t_term_root_id in (select t_term_root_id from t_project_term_root where t_project_id = _t_project_id and t_project_term_root_type = 0); 
end */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2016-02-01 13:37:01
