<?php require_once("common/Common.php"); ?>
<?php require_once("class/DocTmx.php"); ?>
<?php require_once("class/Graph.php"); ?>
<?php require_once("class/Twitter.php"); ?>
<?php
//--------------------------------------------------------------------
// explain  : 
// argument : 
//--------------------------------------------------------------------
//----------------------------
// define
//----------------------------
//----------------------------
// variable
//----------------------------
// word key
$wk = "WORD_P_APP_BBS_CONTROLLER";
// result
$result = RES_OK;
// data
$data = "";
$isSystemBbs = FALSE;
$arrAppended = NULL;
// html

//----------------------------
// request parameter
//----------------------------
$qToken            = isset($_REQUEST["q_token"])           ? $_REQUEST["q_token"]           : REQ_NON;
$qMode             = isset($_REQUEST["q_mode"])            ? $_REQUEST["q_mode"]            : REQ_NON;
$qID               = isset($_REQUEST["q_id"])              ? $_REQUEST["q_id"]              : REQ_NON;
$qPostNo           = isset($_REQUEST["q_post_no"])         ? $_REQUEST["q_post_no"]         : REQ_NON;

$qParentNo         = isset($_REQUEST["q_parent_no"])       ? $_REQUEST["q_parent_no"]       : REQ_NON;
$qStage            = isset($_REQUEST["q_stage"])           ? $_REQUEST["q_stage"]           : REQ_NON;
$qType             = isset($_REQUEST["q_type"])            ? $_REQUEST["q_type"]            : REQ_NON;
$qRole             = isset($_REQUEST["q_role"])            ? $_REQUEST["q_role"]            : REQ_NON;
$qArrTarget        = isset($_REQUEST["q_target"])          ? $_REQUEST["q_target"]          : REQ_NON;
$qArrTermRoot      = isset($_REQUEST["q_term_root"])       ? $_REQUEST["q_term_root"]       : REQ_NON;
$qArrBilingualRoot = isset($_REQUEST["q_bilingual_root"])  ? $_REQUEST["q_bilingual_root"]  : REQ_NON;
$qArrData          = isset($_REQUEST["q_data"])            ? $_REQUEST["q_data"]            : REQ_NON;
$qTitle            = isset($_REQUEST["q_title"])           ? $_REQUEST["q_title"]           : REQ_NON;
$qText             = isset($_REQUEST["q_text"])            ? $_REQUEST["q_text"]            : REQ_NON;
$qDoc              = isset($_REQUEST["q_document"])        ? $_REQUEST["q_document"]        : REQ_NON;
$qDocSelect        = isset($_REQUEST["q_document_select"]) ? $_REQUEST["q_document_select"] : REQ_NON;
$qProjectID        = isset($_REQUEST["q_project_id"])      ? $_REQUEST["q_project_id"]      : REQ_NON;
$qTaskID           = isset($_REQUEST["q_task_id"])         ? $_REQUEST["q_task_id"]         : REQ_NON;

//----------------------------
// judge post
//----------------------------
$isPost = ($qToken !== REQ_NON);

//----------------------------
// change types
//----------------------------
Util::setType($qToken,     "string");
Util::setType($qMode,      "int");
Util::setType($qID,        "int");
Util::setType($qPostNo,    "int");

Util::setType($qParentNo,  "int");
Util::setType($qStage,     "int");
Util::setType($qType,      "int");
Util::setType($qRole,      "int");
Util::setType($qArrTarget, "string");
//Util::setType($qArrTermRoot, "string");
//Util::setType($qArrBilingualRoot, "string");
//Util::setType($qArrData, "string");
Util::setType($qTitle,     "string");
Util::setType($qText,      "string");
Util::setType($qDoc,       "string");
Util::setType($qDocSelect, "string");
Util::setType($qProjectID, "int");
Util::setType($qTaskID,    "int");

//----------------------------
// Auth-Before validate
//----------------------------
if ( $result === RES_OK ){
	if ( ! Validate::inArray($qMode, $G_APP_BBS_CONTROLLER_MODE_TABLE) ){
		$result = RES_NG;
		$gResult->push("{$WORD($wk, 1)}");
	}
	if ( $qMode === APP_BBS_CONTROLLER_MODE_POSTFRM ){
		// 入力フォームの表示の時だけ、ProjectIDからBbsIDの取得をさせる
		if ( (! Validate::isNumeric($qID) || $qID === INIT_ID) && Validate::isNumeric($qProjectID) ){
			$objDAOBbs = DAO::instance("bbs");
			$resDAOBbs = $objDAOBbs->get(NULL, $qProjectID);
			if ( $resDAOBbs["result"] === RES_OK ){
				$qID = $resDAOBbs["data"][0]["t_bbs_id"];
			}
		} else if ( Validate::isNumeric($qID) && ! Validate::isNumeric($qProjectID) ){
			$objDAOBbs = DAO::instance("bbs");
			$resDAOBbs = $objDAOBbs->get($qID);
			if ( $resDAOBbs["result"] === RES_OK ){
				$qProjectID = $resDAOBbs["data"][0]["t_project_id"];
			}
		}
	}
	if ( ! Validate::isNumeric($qID) ){
		$result = RES_NG;
		$gResult->push("{$WORD($wk, 2)}");
	}
	if ( ! Validate::isNumeric($qPostNo) ){
		$result = RES_NG;
		$gResult->push("{$WORD($wk, 3)}");
	}
	if ( $qMode === APP_BBS_CONTROLLER_MODE_POSTSET ){
		if ( ! Validate::isToken($qToken, "q_token_bbs", FALSE) ){
			$result = RES_NG;
			$gResult->push("{$WORD($wk, 4)}");
		}
	} else if ( $qMode === APP_BBS_CONTROLLER_MODE_ADDITION || $qMode === APP_BBS_CONTROLLER_MODE_DELETE ){
		if ( ! Validate::isToken($qToken, "token_common") ){
			$result = RES_NG;
			$gResult->push("{$WORD($wk, 5)}");
		}
	}
}

//----------------------------
// Auth
//----------------------------
if ( $result === RES_OK ){
	$auth = Auth::instance("bbs");
	switch ( $qMode ){
		case APP_BBS_CONTROLLER_MODE_POSTDOC:
			if( ! $auth->readItem($qPostNo, $qID, $qProjectID)){
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 6)}");
			}
			break;
		case APP_BBS_CONTROLLER_MODE_POSTFRM:
		case APP_BBS_CONTROLLER_MODE_POSTSET:
			if( ! $auth->writeItem($qPostNo, $qID, $qProjectID)){
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 7)}");
			}
			break;
		case APP_BBS_CONTROLLER_MODE_ADDITION:
			if ( ! $auth->additionItem($qPostNo, $qID, $qProjectID) ){
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 8)}");
			}
			break;
		case APP_BBS_CONTROLLER_MODE_DELETE:
			if ( ! $auth->removeItem($qPostNo, $qID, $qProjectID) ){
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 9)}");
			}
			break;
	}
}

//----------------------------
// Auth-After validate
//----------------------------
if ( $result === RES_OK ){
	$isSystemBbs = ( $qProjectID === DAO::T_BBS_PROJECT_ID_SYSTEM );
	switch ( $qMode ){
		case APP_BBS_CONTROLLER_MODE_POSTSET:
			if ( $isSystemBbs ){
				$qStage     = NULL;
				$qType      = NULL;
				$qRole      = NULL;
				$qArrTarget = NULL;
				$qObject    = NULL;
				if ( ! Validate::isString($qText) ){
					$result = RES_NG;
					$gResult->push("{$WORD($wk, 10)}");
				}
			} else {
				if ( ! Validate::isNumeric($qStage) ){
					$result = RES_NG;
					$gResult->push("{$WORD($wk, 11)}");
				}
				if ( ! Validate::isNumeric($qType) ){
					$result = RES_NG;
					$gResult->push("{$WORD($wk, 12)}");
				}
				if ( ! Validate::isNumeric($qRole) ){
					$result = RES_NG;
					$gResult->push("{$WORD($wk, 13)}");
				}
				if ( ! Validate::isString($qText) ){
					$result = RES_NG;
					$gResult->push("{$WORD($wk, 14)}");
				}
				if ( ! Validate::isArray($qArrTarget) || count($qArrTarget) == 0 ){
					$result = RES_NG;
					$gResult->push("{$WORD($wk, 15)}");
				}
			}
			break;
		case APP_BBS_CONTROLLER_MODE_ADDITION:
			if ( ! Validate::isString($qText) ){
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 16)}");
			}
			break;
	}
}

//----------------------------
// function
//----------------------------
function highlight( $text, $poslen ){
	list($pos, $len) = explode("-", $poslen);
	
	$preText = mb_substr($text, 0, $pos);
	$selText = mb_substr($text, $pos, $len);
	$sufText = mb_substr($text, $pos+$len);
	
	$hPreText = Util::esc($preText);
	$hSelText = "<span class=\"highlight\">".Util::esc($selText)."</span>";
	$hSufText = Util::esc($sufText);
	
	return $hPreText.$hSelText.$hSufText;
}

function xml2table( $xml, $arrSelectInfo ){
	$html = "";
	
	$objDocTmx = new DocTmx();
	if ( ! $objDocTmx->load($xml) ){
		Util::printLog("load xml failed.");
		return FALSE;
	}
		
	// スキーマチェック
	if ( ! $objDocTmx->validate() ) {
		Util::printLog("validate xml schema failed.");
		return FALSE;
	}
	
	$arrAlignSelectInfo = array();
	foreach ($arrSelectInfo as $selectInfo){
		$arr = explode("-", $selectInfo);
		if ( count($arr) === 4 ){
			list($repid, $lang, $pos, $len) = explode("-", $selectInfo);
			$arrAlignSelectInfo[$repid][$lang] = "{$pos}-{$len}";
		}
	}
	
	$arrSentence = $objDocTmx->getSentence(TRUE);
	
	foreach ( $arrSentence as $sentence ){
		$repID      = isset($sentence["@repid"])      ? $sentence["@repid"]      : "";
		$source     = isset($sentence["source_text"]) ? $sentence["source_text"] : "";
		$target     = isset($sentence["target_text"]) ? $sentence["target_text"] : "";
		$sourceLang = isset($sentence["source_lang"]) ? $sentence["source_lang"] : "";
		$targetLang = isset($sentence["target_lang"]) ? $sentence["target_lang"] : "";
		
		if ( isset($arrAlignSelectInfo[$repID][$sourceLang]) ){
			$hSource = highlight($source, $arrAlignSelectInfo[$repID][$sourceLang]);
		} else {
			$hSource = Util::esc($source);
		}
		if ( isset($arrAlignSelectInfo[$repID][$targetLang]) ){
			$hTarget = highlight($target, $arrAlignSelectInfo[$repID][$targetLang]);
		} else {
			$hTarget = Util::esc($target);
		}
		
$html .= <<< HTML
		<tr>
			<td>{$hSource}</td>
			<td>{$hTarget}</td>
		</tr>
HTML;
	}
	
$html = <<< HTML
	<table class="table table-striped" style="table-layout:fixed">
		<tbody>
			{$html}
		</tbody>
	</table>
HTML;
	
	return $html;
}

//----------------------------
// process
//----------------------------
if ( $result === RES_OK ){
	DAO::begin();
	
	$objDAOBbs           = DAO::instance("bbs");
	$objDAOBbsPost       = DAO::instance("bbs_post");
	$objDAOBbsPostTarget = DAO::instance("bbs_post_target");
	$objDAOProjectUser   = DAO::instance("project_user");
	$objDAOTask          = DAO::instance("task");
	$objDAOUser          = DAO::instance("user");
	$objDAOBbsPostTermRoot      = DAO::instance("bbs_post_term_root", Term::KIND_TERM);
	$objDAOBbsPostBilingualRoot = DAO::instance("bbs_post_term_root", Term::KIND_BILINGUAL);
	$objDAOBbsPostData          = DAO::instance("bbs_post_data");
	
	if ( $isSystemBbs ){
		$objViewBbsPost      = View::instance("system_bbs_post");
	} else {
		$objViewBbsPost      = View::instance("bbs_post");
	}
	
	if ( $result === RES_OK ){
		if ( ! Validate::isNumeric($qID) ){
			$objDAOBbs->setAuth($auth);
			$resDAOBbs = $objDAOBbs->get(NULL, $qProjectID);
			$result = $resDAOBbs["result"];
			if ( $result === RES_OK ){
				$dataBbs = $resDAOBbs["data"][0];
				$qID = $dataBbs["t_bbs_id"];
			} else {
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 17)}");
			}
		}
	}
	
	if ( $result === RES_OK ){
		switch ( $qMode ){
			case APP_BBS_CONTROLLER_MODE_POSTDOC:
				if ( $result === RES_OK ){
					$resDAOBbsPost = $objDAOBbsPost->get($qPostNo, $qID);
					$result = $resDAOBbsPost["result"];
					if ( $result === RES_OK ){
						$dataBbsPost = $resDAOBbsPost["data"][0];
						$doc = $dataBbsPost["t_bbs_post_document"];
						$sel = $dataBbsPost["t_bbs_post_document_select"];
						if ( ($data = xml2Table($doc, explode(",", $sel))) === FALSE ){
							$result = RES_NG;
							$gResult->push("{$WORD($wk, 18)}");
						}
					} else {
						$result = RES_NG;
						$gResult->push("{$WORD($wk, 19)}");
					}
				}
				break;
			case APP_BBS_CONTROLLER_MODE_POSTFRM:
				$arrControl = array();
				if ( $isSystemBbs ){
					$qTitle     = $objDAOBbsPost->getInit("t_bbs_post_title");
					$qText      = $objDAOBbsPost->getInit("t_bbs_post_text");
					
					// 返答元 --------------------
					if ( $result === RES_OK ){
						if ( $qParentNo !== DAO::T_BBS_POST_PARENT_NO_NON ){
							$resDAOBbsPost = $objDAOBbsPost->get($qParentNo, $qID);
							$result = $resDAOBbsPost["result"];
							
							if ( $result === RES_OK ){
								$qTitle = "Re:" . $resDAOBbsPost["data"][0]["t_bbs_post_title"];
								
								$hParent = $objViewBbsPost->post(TRUE, $resDAOBbsPost["data"][0], NULL, NULL, FALSE, FALSE);
							} else {
								$result = RES_NG;
								$gResult->push("{$WORD($wk, 20)}");
							}
						}
					}
					
					if ( $result === RES_OK ){
						// フォーム(返答元)
						if ( $qParentNo !== DAO::T_BBS_POST_PARENT_NO_NON ){
							$arrControl[] = array(
								"id"   => NULL,
								"name" => "{$WORD($wk, 21)}",
								"form" => $hParent,
							);
						}
					}
				} else {
					$objProject = new Project($qProjectID);
					
					$qStage     = $objDAOBbsPost->getInit("t_bbs_post_stage");
					$qType      = $objDAOBbsPost->getInit("t_bbs_post_type");
					$qRole      = $objDAOBbsPost->getInit("t_bbs_post_role");
					$qArrTarget = array();
					$qObject    = $objDAOBbsPost->getInit("t_bbs_post_object");
					$qTitle     = $objDAOBbsPost->getInit("t_bbs_post_title");
					$qText      = $objDAOBbsPost->getInit("t_bbs_post_text");
					$qDoc       = Validate::isString($qDoc)       ? $qDoc       : $objDAOBbsPost->getInit("t_bbs_post_document");
					$qDocSelect = Validate::isString($qDocSelect) ? $qDocSelect : $objDAOBbsPost->getInit("t_bbs_post_document_select");
					
					// プロジェクトデータ取得 --------------------
					if ( $result === RES_OK ){
						if ( ($arrAppended = $objProject->getAppended()) === FALSE ){
							$result = RES_NG;
							$gResult->push("{$WORD($wk, 22)}");
						}
					}
					
					// タスクデータ取得 --------------------
					if ( $result === RES_OK ){
						if ( $qTaskID !== NULL && Validate::isNumeric($qTaskID) ){
							$resDAOTask = $objDAOTask->get($qTaskID);
							$result     = $resDAOTask["result"];
							
							if ($result === RES_OK ){
								$data = $resDAOTask["data"][0];
								$taskType = $data["t_task_type"];
								$qStage = Task::SETTING_TABLE($taskType, "stage");
								$arrTaskActor = Task::getTaskActor($qTaskID);
								foreach ( $arrTaskActor as $role => $arrUserID ){
									foreach ( $arrUserID as $userID => $arr ){
										if ( $userID === User::get("id") ){
											if ( ! in_array($qRole, Task::ROLE_TABLE()) ){
												$qRole = $role;
											}
										} else {
											$qArrTarget[] = $userID."_".$role;
										}
									}
								}
							} else {
								$result = RES_NG;
								$gResult->push("{$WORD($wk, 23)}");
							}
						}
					}
					
					// 返答元 --------------------
					if ( $result === RES_OK ){
						if ( $qParentNo !== DAO::T_BBS_POST_PARENT_NO_NON ){
							$resDAOBbsPost = $objDAOBbsPost->get($qParentNo, $qID);
							$result = $resDAOBbsPost["result"];
							
							if ( $result === RES_OK ){
								// 返答元の相手を取得
								$resDAOBbsPostTarget = $objDAOBbsPostTarget->get($qParentNo, $qID);
								$result = $resDAOBbsPostTarget["result"];
							}
							
							if ( $result === RES_OK ){
								$data = $resDAOBbsPost["data"][0];
								$qStage = $data["t_bbs_post_stage"];
								$qType  = $data["t_bbs_post_type"];
								$qArrTarget = array( $data["t_user_id"]."_".$data["t_bbs_post_role"] );
								$qTitle = "Re:" . $data["t_bbs_post_title"];
								
								foreach ( $resDAOBbsPostTarget["data"] as $targetData ){
									if ( $targetData["t_user_id"] === User::get("id") ){
										$qRole = $targetData["t_bbs_post_target_role"];
										break;
									}
								}
								foreach ( $resDAOBbsPostTarget["data"] as $targetData ){
									if ( $targetData["t_user_id"] !== User::get("id") ){
										$qArrTarget[] = $targetData["t_user_id"]."_".$targetData["t_bbs_post_target_role"];
									}
								}
								
								$hParent = $objViewBbsPost->item($data, $arrAppended);
							} else {
								$result = RES_NG;
								$gResult->push("{$WORD($wk, 24)}");
							}
						}
					}
					
					// 役割取得 --------------------
					if ( $result === RES_OK ){
						$resDAOProjectUser = $objDAOProjectUser->get($qProjectID, User::get("id"));
						$result = $resDAOProjectUser["result"];
						
						if ( $result === RES_OK ){
							foreach ( $resDAOProjectUser["data"] as $dataProjectUser ){
								$projectUserRole = $dataProjectUser["t_project_user_role"];
								
								$arrRole[$projectUserRole] = Task::ROLE_TABLE($projectUserRole);
							}
						} else {
							$result = RES_NG;
							$gResult->push("{$WORD($wk, 25)}");
						}
					}
					
					// 役割(相手)取得 ----------------
					if ( $result === RES_OK ){
						$resDAOProjectUser = $objDAOProjectUser->get($qProjectID);
						$result = $resDAOProjectUser["result"];
						
						if ( $result === RES_OK ){
							$hTarget = $objViewBbsPost->target($resDAOProjectUser["data"], $qArrTarget);
						} else {
							$result = RES_NG;
							$gResult->push("{$WORD($wk, 26)}");
						}
					}
					
					// オブジェクト --------------------
					if ( $result === RES_OK ){
						$arrTermRoot = array();
						if ( is_array($qArrTermRoot) ){
							foreach ( $qArrTermRoot as $id ){
								if ( ($name = DAO::storedFunction("get_term_root_name", $id)) !== FALSE ){
									$arrTermRoot[$id] = $name;
								}
							}
						}
						$arrBilingualRoot = array();
						if ( is_array($qArrBilingualRoot) ){
							foreach ( $qArrBilingualRoot as $id ){
								if ( ($name = DAO::storedFunction("get_bilingual_root_name", $id)) !== FALSE ){
									$arrBilingualRoot[$id] = $name;
								}
							}
						}
						$arrData = array();
						if ( is_array($qArrData) ){
							foreach ( $qArrData as $id ){
								if ( ($name = DAO::storedFunction("get_data_title", $id)) !== FALSE ){
									$arrData[$id] = $name;
								}
							}
						}
						if ($result === RES_OK ){
							$hObject = $objViewBbsPost->object($arrTermRoot, $arrBilingualRoot, $arrData, $arrAppended);
						}
					}
					
					if ( $result === RES_OK ){
						// フォーム(返答元)
						if ( $qParentNo !== DAO::T_BBS_POST_PARENT_NO_NON ){
							$arrControl[] = array(
								"id"   => NULL,
								"name" => "{$WORD($wk, 27)}",
								"form" => $hParent,
							);
						}
						// フォーム(ステージ)
						$arrStage = DAO::T_BBS_POST_STAGE_TABLE();
						$arrControl[] = array(
							"id"   => "q_stage",
							"name" => "{$WORD($wk, 28)}",
							"form" => array(
								Printer::select("q_stage", "q_stage", $arrStage, $qStage),
							),
						);
						// フォーム(タイプ)
						$arrControl[] = array(
							"id"   => "q_type",
							"name" => "{$WORD($wk, 29)}",
							"form" => array(
								Printer::select("q_type", "q_type", DAO::T_BBS_POST_TYPE_TABLE(), $qType),
							),
						);
						// フォーム(役割)
						$arrControl[] = array(
							"id"   => "q_role",
							"name" => "{$WORD($wk, 30)}",
							"form" => array(
								Printer::select("q_role", "q_role", $arrRole, $qRole),
								//Printer::radioButtons("q_role", $arrRole, $qRole, "btn-default"),
							),
						);
						// フォーム(相手)
						$arrControl[] = array(
							"id"   => "q_target",
							"name" => "{$WORD($wk, 31)}",
							"form" => $hTarget,
							"required" => TRUE,
						);
						// フォーム(オブジェクト)
						$arrControl[] = array(
							"id"   => "q_object",
							"name" => "{$WORD($wk, 32)}",
							"form" => $hObject,
						);
						// フォーム(文書)
						if ( Validate::isString($qDoc) && Validate::isString($qDocSelect) ){
							if ( ($data = xml2Table($qDoc, explode(",", $qDocSelect))) === FALSE ){
								$result = RES_NG;
								$gResult->push("{$WORD($wk, 33)}");
							}
							if ( $result === RES_OK ){
								// フォーム(文書)
								$arrControl[] = array(
									"id"   => "q_document",
									"name" => "{$WORD($wk, 34)}",
									"form" => array(
										Printer::link("{$WORD($wk, 35)}", "btn btn-default", NULL, NULL, NULL, "minhon.bbs.post.showDocumentDialog($(\"#document_table\").html());"),
										Printer::input("hidden", "q_document",        "q_document",        $qDoc),
										Printer::input("hidden", "q_document_select", "q_document_select", $qDocSelect),
										"<div id=\"document_table\" style=\"display: none;\">{$data}</div>",
									),
								);
							}
						}
					}
				}
					
				if ( $result === RES_OK ){
					// フォーム(タイトル)
					$arrControl[] = array(
						"id"   => "q_title",
						"name" => "{$WORD($wk, 36)}",
						"form" => Printer::input("text", "q_title", "q_title", $qTitle, NULL, array("placeholder" => "{$WORD($wk, 37)}")),
					);
					// フォーム(内容)
					$arrControl[] = array(
						"id"   => "q_text",
						"name" => "{$WORD($wk, 38)}",
						"form" => array(
							Printer::textarea("q_text", "q_text", $qText),
						),
						"required" => TRUE,
						"fullsize" => TRUE,
					);
					// フォーム(プロジェクトid)
					$arrControl[] = array(
						"id"   => NULL,
						"name" => NULL,
						"form" => Printer::input("hidden", "q_project_id", "q_project_id", $qProjectID),
					);
					// フォーム(id)
					$arrControl[] = array(
						"id"   => NULL,
						"name" => NULL,
						"form" => Printer::input("hidden", "q_id", "q_id", $qID),
					);
					// フォーム(返答元no)
					$arrControl[] = array(
						"id"   => NULL,
						"name" => NULL,
						"form" => Printer::input("hidden", "q_parent_no", "q_parent_no", $qParentNo),
					);
					// フォーム(no)
					$arrControl[] = array(
						"id"   => NULL,
						"name" => NULL,
						"form" => Printer::input("hidden", "q_post_no", "q_post_no", $qPostNo),
					);
					// フォーム(token)
					$arrControl[] = array(
						"id"   => NULL,
						"name" => NULL,
						"form" => Printer::input("hidden", "q_token", "q_token", Util::token("q_token_bbs")),
					);
					$data = Printer::form("form_bbs", "form_bbs", "", "post", $arrControl);
				}
				break;
			case APP_BBS_CONTROLLER_MODE_POSTSET:
				// 投稿 -----------------
				if ( $result === RES_OK ){
					$resDAOBbsPost = $objDAOBbsPost->register($qParentNo, $qStage, $qType, $qRole, NULL, $qTitle, $qText, $qDoc, $qDocSelect, $qID, User::get("id"));
					$result = $resDAOBbsPost["result"];
					
					if ( $result === RES_OK ){
						$qPostNo = $resDAOBbsPost["id"];
					}
				}
				
				if ( ! $isSystemBbs ){
					// ターゲットの登録 ---------------------
					if ( $result === RES_OK ){
						if ( in_array(View_bbs_post::USER_ID_ALL_USER, $qArrTarget) ){
							//all-user
							$resDAOBbsPostTarget = $objDAOBbsPostTarget->register($qPostNo, $qID, array(View_bbs_post::USER_ID_ALL_USER."_0"));
							$result = $resDAOBbsPostTarget["result"];
						} else {
							$resDAOBbsPostTarget = $objDAOBbsPostTarget->register($qPostNo, $qID, $qArrTarget);
							$result = $resDAOBbsPostTarget["result"];
						}
					}
					
					// オブジェクトの登録 ---------------------
					if ( $result === RES_OK ){
						$resDAOBbsPostTermRoot = $objDAOBbsPostTermRoot->delete($qPostNo, $qID);
						if ( ($result = $resDAOBbsPostTermRoot["result"]) === RES_OK ){
							if ( is_array($qArrTermRoot) ){
								$resDAOBbsPostTermRoot = $objDAOBbsPostTermRoot->register($qPostNo, $qID, $qArrTermRoot);
								$result = $resDAOBbsPostTermRoot["result"];
							}
						}
					}
					if ( $result === RES_OK ){
						$resDAOBbsPostBilingualRoot = $objDAOBbsPostBilingualRoot->delete($qPostNo, $qID);
						if ( ($result = $resDAOBbsPostBilingualRoot["result"]) === RES_OK ){
							if ( is_array($qArrBilingualRoot) ){
								$resDAOBbsPostBilingualRoot = $objDAOBbsPostBilingualRoot->register($qPostNo, $qID, $qArrBilingualRoot);
								$result = $resDAOBbsPostBilingualRoot["result"];
							}
						}
					}
					if ( $result === RES_OK ){
						$resDAOBbsPostData = $objDAOBbsPostData->delete($qPostNo, $qID);
						if ( ($result = $resDAOBbsPostData["result"]) === RES_OK ){
							if ( is_array($qArrData) ){
								$resDAOBbsPostData = $objDAOBbsPostData->register($qPostNo, $qID, $qArrData);
								$result = $resDAOBbsPostData["result"];
							}
						}
					}
					
					// 統計更新 ------------------------
					if ( $result === RES_OK ){
						$graph = new Graph(Graph::KIND_TRANSITION, $qProjectID, $qStage);
						if ( $graph->createImage() === FALSE ){
							$graph->deleteImage();
						}
					}
				}
				
				if ( $result === RES_OK ){
					$gResult->push("{$WORD($wk, 39)}");
				} else {
					$gResult->push("{$WORD($wk, 40)}");
				}

				// twitter
				if ( $result === RES_OK ){
					$arrSendUser = array();
					if ( ! $isSystemBbs ){
						if ( in_array(View_bbs_post::USER_ID_ALL_USER, $qArrTarget) ){
							// プロジェクト参加者全員へ
							$resDAOProjectUser = $objDAOProjectUser->get($qProjectID);
							if ( $resDAOProjectUser["result"] === RES_OK ){
								foreach ( $resDAOProjectUser["data"] as $dataProjectUser ){
									$userID = $dataProjectUser["t_user_id"];
									$arrSendUser[$userID] = "";
								}
							}
						} else {
							foreach ( $qArrTarget as $target ){
								list($userID, $role) = explode("_", $target);
								$arrSendUser[$userID] = "";
							}
						}
					}
					if( count($arrSendUser) > 0 ){
						$resDAOUser = $objDAOUser->get(array_keys($arrSendUser));
						if ( $resDAOUser["result"] === RES_OK && $resDAOUser["count"] > 0 ){
							foreach ( $resDAOUser["data"] as $dataUser ){
								$account = $dataUser["t_user_twitter"];
								if ( Validate::isString($account) ){
									Twitter::tweet("@{$account} You got a message! ".date("Y-m-d H:i:s"));
								}
							}
						}
					}
				}
				
				break;
			case APP_BBS_CONTROLLER_MODE_ADDITION:
				if ( $result === RES_OK ){
					$resDAOBbsPost = $objDAOBbsPost->addition($qPostNo, $qText, $qID, User::get("id"));
					$result = $resDAOBbsPost["result"];
					
					if ( $result === RES_OK ){
						$gResult->push("{$WORD($wk, 41)}");
					} else {
						$gResult->push("{$WORD($wk, 42)}");
					}
				}
				
				break;
			case APP_BBS_CONTROLLER_MODE_DELETE:
				// 存在確認したのち削除 --------------------------
				if ( $result === RES_OK ){
					$res = $objDAOBbsPost->get($qPostNo, $qID);
					if ( $res["result"] === RES_OK ){
						$resDAOBbsPost = $objDAOBbsPost->hide($qPostNo, $qID);
						$result = $resDAOBbsPost["result"];
					} else {
						$res = $objDAOBbsPost->getAdditionText($qPostNo, $qID);
						if ( $res["result"] === RES_OK ){
							$resDAOBbsPost = $objDAOBbsPost->hide($qPostNo, $qID);
							$result = $resDAOBbsPost["result"];
						} else {
							$result = RES_NG;
							$gResult->push("{$WORD($wk, 43)}");
						}
					}
				}
				
				break;
		}
	}
	
	DAO::end($result);
	
	if ( $result === RES_NG ){
		if ( $qMode === APP_BBS_CONTROLLER_MODE_ADDITION || $qMode === APP_BBS_CONTROLLER_MODE_DELETE ){
			$data["token"] = Util::token("token_common");
		}
	}
}

$res["result"]  = $result;
$res["message"] = $gResult->string(FALSE, $result);
$res["data"]    = $data;

echo json_encode($res);
