<?php require_once("common/Common.php"); ?>
<?php
//--------------------------------------------------------------------
// explain  : タスク
// argument : 
//--------------------------------------------------------------------
//----------------------------
// define
//----------------------------
//----------------------------
// variable
//----------------------------
// word key
$wk = "WORD_P_APP_TASK_CHART_CONTROLLER";
// result
$result = RES_OK;
// data
$arrRes = NULL;
$projectStartDate = "";
$projectEndDate = "";
$hState = "";
$hPrepend = "";
$arrControl = array();
$arrAction  = array();
// html

//----------------------------
// request parameter
//----------------------------
$qProjectID = isset($_SESSION["project_id"]) ? $_SESSION["project_id"] : REQ_NON;

$qMode            = isset($_REQUEST["q_mode"])              ? $_REQUEST["q_mode"]              : REQ_NON;
$qWorkflowID      = isset($_REQUEST["q_workflow_id"])       ? $_REQUEST["q_workflow_id"]       : REQ_NON;
$qTaskID          = isset($_REQUEST["q_task_id"])           ? $_REQUEST["q_task_id"]           : REQ_NON;
$qUserID          = isset($_REQUEST["q_user_id"])           ? $_REQUEST["q_user_id"]           : REQ_NON;
$qDocumentID      = isset($_REQUEST["q_document_id"])       ? $_REQUEST["q_document_id"]       : REQ_NON;
$qTermRootID      = isset($_REQUEST["q_term_root_id"])      ? $_REQUEST["q_term_root_id"]      : REQ_NON;
$qBilingualRootID = isset($_REQUEST["q_bilingual_root_id"]) ? $_REQUEST["q_bilingual_root_id"] : REQ_NON;
$qFixParameter    = isset($_REQUEST["q_fix_parameter"])     ? $_REQUEST["q_fix_parameter"]     : array();
$qIsGrouping      = isset($_REQUEST["q_is_grouping"])       ? $_REQUEST["q_is_grouping"]       : REQ_NON;

//----------------------------
// judge post
//----------------------------

//----------------------------
// set types
//----------------------------
/*
$qUserID          = strpos($qUserID, ",") !== FALSE          ? explode(",", $qUserID)          : $qUserID;
$qDocumentID      = strpos($qDocumentID, ",") !== FALSE      ? explode(",", $qDocumentID)      : $qDocumentID;
$qTermRootID      = strpos($qTermRootID, ",") !== FALSE      ? explode(",", $qTermRootID)      : $qTermRootID;
$qBilingualRootID = strpos($qBilingualRootID, ",") !== FALSE ? explode(",", $qBilingualRootID) : $qBilingualRootID;
 */
$qUserID          = is_array($qUserID) ? $qUserID : explode(",", $qUserID);
$qDocumentID      = is_array($qDocumentID) ? $qDocumentID : explode(",", $qDocumentID);
$qTermRootID      = is_array($qTermRootID) ? $qTermRootID : explode(",", $qTermRootID);
$qBilingualRootID = is_array($qBilingualRootID) ? $qBilingualRootID : explode(",", $qBilingualRootID);
$qFixUserID          = isset($qFixParameter["q_user_id"])           ? explode(",", $qFixParameter["q_user_id"])           : array();
$qFixDocumentID      = isset($qFixParameter["q_document_id"])       ? explode(",", $qFixParameter["q_document_id"])       : array();
$qFixTermRootID      = isset($qFixParameter["q_term_root_id"])      ? explode(",", $qFixParameter["q_term_root_id"])      : array();
$qFixBilingualRootID = isset($qFixParameter["q_bilingual_root_id"]) ? explode(",", $qFixParameter["q_bilingual_root_id"]) : array();

Util::setType($qMode,            "int");
Util::setType($qProjectID,       "int");
Util::setType($qWorkflowID,      "int");
Util::setType($qTaskID,          "int");
Util::setType($qUserID,          "int");
Util::setType($qDocumentID,      "int");
Util::setType($qTermRootID,      "int");
Util::setType($qBilingualRootID, "int");
Util::setType($qFixUserID,          "int");
Util::setType($qFixDocumentID,      "int");
Util::setType($qFixTermRootID,      "int");
Util::setType($qFixBilingualRootID, "int");
Util::setType($qIsGrouping,         "int");

//----------------------------
// Auth-Before validate
//----------------------------
if ( $result === RES_OK ){
	if ( ! Validate::isNumeric($qMode) || ! Validate::inArray($qMode, $G_APP_TASK_CHART_CONTROLLER_MODE_TABLE) ){
		$result = RES_NG;
		$gResult->push("{$WORD($wk, 1)}");
	}
	if ( ! Validate::isNumeric($qProjectID) ){
		$result = RES_NG;
		$gResult->push("{$WORD($wk, 2)}");
	}
	if ( ! Validate::isNumeric($qWorkflowID) ){
		$result = RES_NG;
		$gResult->push("{$WORD($wk, 3)}");
	}
}

//----------------------------
// Auth
//----------------------------
if ( $result === RES_OK ){
	$auth = Auth::instance("task");
	if ( ! $auth->readList($qProjectID) ){
		$result = RES_NG;
		$gResult->push("{$WORD($wk, 4)}");
	}
}

//----------------------------
// Auth-After validate
//----------------------------
if ( $result === RES_OK ){
	if ( ! Validate::isNumeric($qTaskID) ){
		$qTaskID = INIT_ID;
	}
	if ( ! Validate::isArray($qUserID) ){
		$qUserID = array();
	}
	if ( ! Validate::isArray($qDocumentID) ){
		$qDocumentID = array();
	}
	if ( ! Validate::isArray($qTermRootID) ){
		$qTermRootID = array();
	}
	if ( ! Validate::isArray($qBilingualRootID) ){
		$qBilingualRootID = array();
	}
	if ( ! Validate::inArray($qIsGrouping, $G_ONOFF_TABLE) ){
		$qIsGrouping = OFF;
	}
}

//----------------------------
// function
//----------------------------
/*
 * ユーザー
 * 
 * $arrLowerPriority = array()
 *   $arrLowerPriority[] = $userID
 *   指定されたユーザーを後ろに持っていく。
 */
function getHeaderUser($isFilterLink, $taskID, &$isIncludeMe, $arrLowerPriority = NULL){
	global $WORD;
	$wk = "WORD_P_APP_TASK_CHART_CONTROLLER";
	
	$isIncludeMe = FALSE;
	
	if ( ($arrTaskActor = Task::getTaskActor($taskID)) === FALSE ){
		return FALSE;
	}
	
	$html = "";
	
	$arrTaskUser = array();
	foreach ( $arrTaskActor as $role => $arrUser ){
		foreach ( $arrUser as $userID => $dataUser ){
			$hUserName = Util::esc($dataUser["t_user_name"]);
			if ( $userID === User::get("id") ){
				$isIncludeMe = TRUE;
			}
			$arrTaskUser[$userID] = $hUserName;
		}
	}
	if ( is_array($arrLowerPriority) ){
		foreach ( $arrLowerPriority as $userID ){
			if ( isset($arrTaskUser[$userID]) ){
				// 一度削除してから、最後尾につける
				$hUserName = $arrTaskUser[$userID];
				unset($arrTaskUser[$userID]);
				$arrTaskUser[$userID] = $hUserName;
			}
		}
	}
	if ( count($arrTaskUser) === 0 ){
		$hIcon = Printer::icon("icon-user", "#DDD");
	} else {
		$arrPopover = array();
		foreach ( $arrTaskUser as $id => $user ){
			if ( ! empty($html) ){
				$html .= ", ";
			}
			if ( $isFilterLink ){
				$link = "minhon.task.chart.onClickTaskFilter('user', [{$id}], event)";
				$html .= Printer::link($user, NULL, NULL, NULL, NULL, $link, array(
					"data-toggle"    => "tooltip",
					"data-placement" => "top",
					"title"          => $user,
					"data-container" => "div.ganttview",
				));
				$arrPopover[] = Printer::link($user, NULL, "icon-user", NULL, NULL, $link);
			} else {
				$html .= Printer::tooltip($user, $user);
				$arrPopover[] = Printer::icon("icon-user", NULL, $user);
			}
		}
		$hIcon = Printer::icon("icon-user");
			$hIcon = Printer::link($hIcon, NULL, NULL, NULL, NULL, NULL, array(
				"data-toggle" => "popover",
				"data-placement" => "top",
				"data-content" => Printer::uList($arrPopover, FALSE),
				"title" => "{$WORD($wk, 5)}",
				"data-html" => "true",
				"data-container" => "div.ganttview",
				"data-trigger" => "manual",
			), FALSE);
	}
	
	$html = "<span>{$hIcon}{$html}</span>";
	
	return trim($html);
}

/*
 * 文書
 * 
 */
function getHeaderDocument($isFilterLink, $taskID, $arrLowerPriority = NULL){
	global $WORD;
	$wk = "WORD_P_APP_TASK_CHART_CONTROLLER";
	
	if ( ($arrTaskDocument = Task::getTaskDocument($taskID)) === FALSE ){
		return FALSE;
	}
	if ( is_array($arrLowerPriority) ){
		foreach ( $arrLowerPriority as $documentID ){
			if ( isset($arrTaskDocument[$documentID]) ){
				// 一度削除してから、最後尾につける
				$hDocumentTitle = $arrTaskDocument[$documentID];
				unset($arrTaskDocument[$documentID]);
				$arrTaskDocument[$documentID] = $hDocumentTitle;
			}
		}
	}
	
	$html = "";
	
	if ( count($arrTaskDocument) === 0 ){
		$hIcon = Printer::icon("icon-file", "#DDD");
	} else {
		$arrPopover = array();
		foreach ( $arrTaskDocument as $id => $documentTitle ){
			if ( ! empty($html) ){
				$html .= ", ";
			}
			if ( $isFilterLink ){
				$link = "minhon.task.chart.onClickTaskFilter('document', [{$id}], event)";
				$html .= Printer::link($documentTitle, NULL, NULL, NULL, NULL, $link, array(
					"data-toggle"    => "tooltip",
					"data-placement" => "top",
					"title"          => $documentTitle,
					"data-container" => "div.ganttview",
				));
				$arrPopover[] = Printer::link($documentTitle, NULL, "icon-file", NULL, NULL, $link);
			} else {
				$html .= Printer::tooltip($documentTitle, $documentTitle);
				$arrPopover[] = Printer::icon("icon-file", NULL, $documentTitle);
			}
		}
		$hIcon = Printer::icon("icon-file");
			$hIcon = Printer::link($hIcon, NULL, NULL, NULL, NULL, NULL, array(
				"data-toggle" => "popover",
				"data-placement" => "top",
				"data-content" => Printer::uList($arrPopover, FALSE),
				"title" => "{$WORD($wk, 6)}",
				"data-html" => "true",
				"data-container" => "div.ganttview",
				"data-trigger" => "manual",
			), FALSE);
	}
	
	$html = "<span>{$hIcon}{$html}</span>";
	
	return trim($html);
}

function getTaskBlock($row, $taskID, &$startDate, &$endDate){
	// 実績
	if ( ($arrTaskActual = Task::getTaskActual($taskID)) === FALSE ){
		return FALSE;
	}
	
	$timeStartDate = strtotime($startDate);
	$timeEndDate   = strtotime("+1day", strtotime($endDate));
	
	$arrBlock = array();
	
	// タスクに登録された予定
	$arrBlock[] = array(
		"start" => date("Y/m/d H:i:s", $timeStartDate),
		"end"   => date("Y/m/d H:i:s", $timeEndDate),
		"attr"  => array(
			"id"    => "block-plan-".$row,
			"class" => "ganttview-block-plan",
		),
	);
	
	// タスクの実績
	$prevDate  = $timeStartDate;
	$prevState = DAO::T_TASK_STATE_NORMAL;
	foreach ( $arrTaskActual as $dataActual ){
		$date  = strtotime($dataActual["date"]);
		$state = $dataActual["state"];
		
		if ( $date < $prevDate ){
			// 初回、$taskStartより小さい場合、 $taskStart-$dateの線は左向きになるため表示させない
			continue;
		}
		$arrBlock[] = array(
			"start" => date("Y/m/d H:i:s", $prevDate),
			"end"   => date("Y/m/d H:i:s", $date),
			"attr"  => array(
				"class"           => "ganttview-block-actual",
				"data-task-state" => DAO::T_TASK_STATE_ATTR_TABLE($prevState),
			),
		);
		$prevDate  = $date;
		$prevState = $state;
	}
	switch ( $prevState ){
		case DAO::T_TASK_STATE_NORMAL:
		case DAO::T_TASK_STATE_CARIED:
			$arrBlock[] = array(
				"start" => date("Y/m/d H:i:s", $prevDate),
				"end"   => date("Y/m/d H:i:s"),
				"attr"  => array(
					"class"           => "ganttview-block-actual",
					"data-task-state" => DAO::T_TASK_STATE_ATTR_TABLE($prevState),
				),
			);
			break;
		case DAO::T_TASK_STATE_FINISH:
			if ( $prevDate < $timeEndDate ){
				$arrBlock[] = array(
					"start" => date("Y/m/d H:i:s", $prevDate),
					"end"   => date("Y/m/d H:i:s", $timeEndDate),
					"attr"  => array(
						"class"           => "ganttview-block-actual",
						"data-task-state" => DAO::T_TASK_STATE_ATTR_TABLE($prevState),
					),
				);
			}
			break;
	}
	
	foreach ( $arrBlock as $dataBlock ){
		$start = strtotime($dataBlock["start"]);
		$end   = strtotime($dataBlock["end"]);
		if ( $timeStartDate < $start ){
			$timeStartDate = $start;
		}
		if ( $timeEndDate < $end ){
			$timeEndDate = $end;
		}
	}
	$startDate = date("Y/m/d H:i:s", $timeStartDate);
	$endDate   = date("Y/m/d H:i:s", $timeEndDate);
	
	return $arrBlock;
}

/*
 * タスク
 * 
 */
function getTask(&$row, $dataTask, $arrActor = NULL, $arrAppended = NULL, $arrLowerPriorityUser = NULL, $arrLowerPriorityDocument = NULL){
	global $WORD;
	$wk = "WORD_P_APP_TASK_CHART_CONTROLLER";
	
	$taskType  = $dataTask["t_task_type"];
	$taskName  = Task::TYPE_TABLE($taskType);
	$taskID    = $dataTask["t_task_id"];
	$taskState = $dataTask["t_task_state"];
	$taskStart = (strcmp($dataTask["t_task_start"], INIT_DATE) === 0) ? "" : $dataTask["t_task_start"];
	$taskEnd   = (strcmp($dataTask["t_task_end"],   INIT_DATE) === 0) ? "" : $dataTask["t_task_end"];
	
	// ユーザー
	$isIncludeMe = FALSE;
	if ( ($hIconUser = getHeaderUser(TRUE, $taskID, $isIncludeMe, $arrLowerPriorityUser)) === FALSE ){
		return FALSE;
	}
	// 文書
	if ( ($hIconDocument = getHeaderDocument(TRUE, $taskID, $arrLowerPriorityDocument)) === FALSE ){
		return FALSE;
	}
	
	// ブロック(予定と実績)
	if ( ($arrBlock = getTaskBlock($row+1, $taskID, $taskStart, $taskEnd)) === FALSE ){
		return FALSE;
	}
	
	$row++;
	
	// タスク名
	if ( is_array($taskID) || is_null($arrActor) || is_null($arrAppended) ){
		$hTaskName = Printer::icon("icon-ok")." ".Util::esc($taskName);
	} else {
		if ( ($requireMessage = Task::checkTaskObject($taskID, $taskType, $arrActor, $arrAppended)) !== TRUE ){
			$hTaskName = Printer::tooltip(Printer::iconWarning("")." ".Util::esc($taskName), $requireMessage, NULL, NULL, FALSE);
		} else {
			$hTaskName = Printer::icon("icon-ok")." ".Util::esc($taskName);
		}
	}
	
$html = <<< HTML
	<div class="ganttview-vtheader-task-title">{$hTaskName}</div>
	<div class="ganttview-vtheader-task">
		{$hIconUser}{$hIconDocument}
	</div>
HTML;
	
	$item = array(
		"class"     => "ganttview-vtheader-series",
		"name"      => $taskName,
		"id"        => $row,
		"type"      => $taskType,
		"start"     => $taskStart,
		"end"       => $taskEnd,
		"header"    => $html,
		"seriesAttr" => array(
			"id"           => "row-".$row,
		),
		"block"     => $arrBlock,
		"isCharge"  => $isIncludeMe,
	);
	if ( is_array($taskID) ){
		if ( count($taskID) > 1 ){
			$item = array_merge($item, array(
				"taskIDs"   => $taskIDs,
				"blockText" => count($taskID)." Tasks",
			));
		} else {
			$item = array_merge($item, array(
				"taskID"    => $taskID[0],
				"blockText" => "1 Task",
			));
		}
	} else {
		$item = array_merge($item, array(
			"taskID"    => $taskID,
			//"blockText" => "" // 日数が自動で入る
		));
	}
		
	
	return $item;
}

/*
 * 並び替え
 * 
 */
function sortStartEnd($a, $b){
	// startDateが小さい方を前に配置
	if ( isset($a["startDate"]) && isset($b["startDate"]) ){
		if ( $a["startDate"] < $b["startDate"] ){
			return -1;
		} else if ( $a["startDate"] > $b["startDate"] ){
			return 1;
		}
	}
	// endDateが小さい方を前に配置
	if ( isset($a["endDate"]) && isset($b["endDate"]) ){
		if ( $a["endDate"] < $b["endDate"] ){
			return -1;
		} else if ( $a["endDate"] > $b["endDate"] ){
			return 1;
		}
	}
	// indexが小さい方を前に配置
	if ( isset($a["index"]) && isset($b["index"]) ){
		if ( $a["index"] <= $b["index"] ){
			return -1;
		} else {
			return 1;
		}
	}
	
	return 0;
}

//----------------------------
// process
//----------------------------
if ( $result == RES_OK ){
	$objDAOWorkflow          = DAO::instance("workflow");
	$objDAOProject           = DAO::instance("project");
	$objDAOTask              = DAO::instance("task");
	$objDAOTaskActor         = DAO::instance("task_actor");
	$objDAOTaskDocument      = DAO::instance("task_document");
	$objDAOTaskTermRoot      = DAO::instance("task_term_root", Term::KIND_TERM);
	$objDAOTaskBilingualRoot = DAO::instance("task_term_root", Term::KIND_BILINGUAL);
	$objDAOUser          = DAO::instance("user");
	$objDAODocument      = DAO::instance("document");
	$objDAOTermRoot      = DAO::instance("term_root", Term::KIND_TERM);
	$objDAOBilingualRoot = DAO::instance("term_root", Term::KIND_BILINGUAL);
	
	$objViewTask        = View::instance("task");

	if ( $result === RES_OK ){
		$resDAOProject = $objDAOProject->get($qProjectID);
		if ( $resDAOProject["result"] === RES_OK ){
			$dataProject = $resDAOProject["data"][0];
			$projectStartDate = $dataProject["t_project_start"];
			$projectEndDate   = $dataProject["t_project_end"];
			
			$objProject = new Project($qProjectID);
		} else {
			$result = RES_NG;
			$gResult->push("{$WORD($wk, 7)}");
		}
	}
	
	// ユーザー役割一覧 --------------------
	if ( $result === RES_OK ){
		if ( ($arrActor = $objProject->getUser()) === FALSE ){
			$result = RES_NG;
			$gResult->push("{$WORD($wk, 8)}");
		}
	}
	// プロジェクトデータ一覧 --------------------
	if ( $result === RES_OK ){
		if ( ($arrAppended = $objProject->getAppended()) === FALSE ){
			$result = RES_NG;
			$gResult->push("{$WORD($wk, 9)}");
		}
	}
	
	if ( $result === RES_OK ){
		$arrDiff = array(0, "", "0"); //不要な値
		$qUserID          = array_diff(array_unique(array_merge($qUserID, $qFixUserID)), $arrDiff);
		$qDocumentID      = array_diff(array_unique(array_merge($qDocumentID, $qFixDocumentID)), $arrDiff);
		$qTermRootID      = array_diff(array_unique(array_merge($qTermRootID, $qFixTermRootID)), $arrDiff);
		$qBilingualRootID = array_diff(array_unique(array_merge($qBilingualRootID, $qFixBilingualRootID)), $arrDiff);
		
		$filterTaskID = NULL;
		
		$arrLowerPriorityUser = NULL;
		$arrLowerPriorityDocument = NULL;
		
		//------------------------------------
		// modeの指定
		//------------------------------------
		if ( $qMode === APP_TASK_CHART_CONTROLLER_MODE_DETAIL ){
			if ( is_array($qUserID) && count($qUserID) > 0 ){
				$qMode = APP_TASK_CHART_CONTROLLER_MODE_DETAIL_USER;
			} else if ( is_array($qDocumentID) && count($qDocumentID) > 0 ){
				$qMode = APP_TASK_CHART_CONTROLLER_MODE_DETAIL_DOCUMENT;
			} else {
				$qMode = APP_TASK_CHART_CONTROLLER_MODE_DETAIL_TASK;
			}
		}
		
		//------------------------------------
		// ユーザーからタスクを取得
		//------------------------------------
		if ( $result === RES_OK && count($qUserID) > 0 ){
			$resDAOTaskActor = $objDAOTaskActor->getSimpleTaskGroup($qUserID, NULL, DAO::T_TASK_ACTOR_TYPE_ACTOR); // 担当になっているタスク（接触者は除外）
			if ( ($result = $resDAOTaskActor["result"]) === RES_OK ){
				$arr = array();
				foreach ( $resDAOTaskActor["data"] as $dataTaskActor ){
					$arr[] = $dataTaskActor["t_task_id"];
				}
				$arr = array_unique($arr);
				if ( is_array($filterTaskID) ){
					$filterTaskID = array_intersect($arr, $filterTaskID); // 重複している値を返す
					$filterTaskID = is_null($filterTaskID) ? array() : $filterTaskID;
				} else {
					$filterTaskID = $arr;
				}
				// 検索フォーム
				$resDAOUser = $objDAOUser->get($qUserID);
				if ( ($result = $resDAOUser["result"]) === RES_OK ){
					$arrUserControl = array();
					foreach ( $resDAOUser["data"] as $dataUser ){
						$dataUserID   = $dataUser["t_user_id"];
						$dataUserName = $dataUser["t_user_name"];
						$dataUserType = $dataUser["t_user_type"];
						if ( in_array($dataUserID, $qFixUserID) ){
							continue;
						}
						$userColor    = DAO::T_USER_TYPE_COLOR_TABLE($dataUserType);
						$arrUserControl[] = Printer::link($dataUserName, "btn btn-default", "icon-user", $userColor, NULL, "minhon.task.chart.onClickTaskFilterRemoveButton(this, event);", array("data-user-id" => $dataUserID, "data-ellipsis" => 20));
						// 表ヘッダーのユーザー表示させる優先度を落とす
						$arrLowerPriorityUser[] = $dataUserID;
					}
					if ( count($arrUserControl) > 0 ){
						$arrControl[] = array(
							"id"   => "q_user_id",
							"name" => "{$WORD($wk, 10)}",
							"form" => $arrUserControl,
						);
					}
				} else {
					$result = RES_NG;
					$gResult->push("{$WORD($wk, 11)}");
				}
			} else if ( $result === RES_NO_DATA ){
				$result = RES_OK;
				$filterTaskID = array(0);
			} else {
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 12)}");
			}
		}
		
		//------------------------------------
		// 文書からタスクを取得
		//------------------------------------
		if ( $result === RES_OK && count($qDocumentID) > 0 ){
			$resDAOTaskDocument = $objDAOTaskDocument->getSimpleTaskGroup($qDocumentID);
			if ( ($result = $resDAOTaskDocument["result"]) === RES_OK ){
				$arr = array();
				foreach ( $resDAOTaskDocument["data"] as $dataTaskDocument ){
					$arr[] = $dataTaskDocument["t_task_id"];
				}
				$arr = array_unique($arr);
				if ( is_array($filterTaskID) ){
					$filterTaskID = array_intersect($arr, $filterTaskID);
					$filterTaskID = is_null($filterTaskID) ? array() : $filterTaskID;
				} else {
					$filterTaskID = $arr;
				}
				// 検索フォーム
				$resDAODocument = $objDAODocument->get($qDocumentID, array_keys(DAO::T_DOCUMENT_STATE_VALID_TABLE()));
				if ( ($result = $resDAODocument["result"]) === RES_OK ){
					$arrDocumentControl = array();
					foreach ( $resDAODocument["data"] as $dataDocument ){
						$dataDocumentID    = $dataDocument["t_document_id"];
						$dataDocumentTitle = $dataDocument["t_document_title"];
						if ( in_array($dataDocumentID, $qFixDocumentID) ){
							continue;
						}
						$arrDocumentControl[] = Printer::link($dataDocumentTitle, "btn btn-default", "icon-file", "inherit", NULL, "minhon.task.chart.onClickTaskFilterRemoveButton(this, event);", array("data-document-id" => $dataDocumentID, "data-ellipsis" => 20));
						// 表ヘッダーの文書表示させる優先度を落とす
						$arrLowerPriorityDocument[] = $dataDocumentID;
					}
					if ( count($arrDocumentControl) > 0 ){
						$arrControl[] = array(
							"id"   => "q_document_id",
							"name" => "{$WORD($wk, 13)}",
							"form" => $arrDocumentControl,
						);
					}
				} else {
					$result = RES_NG;
					$gResult->push("{$WORD($wk, 14)}");
				}
			} else if ( $result === RES_NO_DATA ){
				$result = RES_OK;
				$filterTaskID = array(0);
			} else {
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 15)}");
			}
		}
		
		//------------------------------------
		// 用語集からタスクを取得
		//------------------------------------
		if ( $result === RES_OK && count($qTermRootID) > 0 ){
			$resDAOTaskTermRoot = $objDAOTaskTermRoot->getSimpleTaskGroup($qTermRootID);
			if ( ($result = $resDAOTaskTermRoot["result"]) === RES_OK ){
				$arr = array();
				foreach ( $resDAOTaskTermRoot["data"] as $dataTaskTermRoot ){
					$arr[] = $dataTaskTermRoot["t_task_id"];
				}
				$arr = array_unique($arr);
				if ( is_array($filterTaskID) ){
					$filterTaskID = array_intersect($arr, $filterTaskID);
					$filterTaskID = is_null($filterTaskID) ? array() : $filterTaskID;
				} else {
					$filterTaskID = $arr;
				}
				// 検索フォーム
				$resDAOTermRoot = $objDAOTermRoot->get($qTermRootID, DAO::T_TERM_ROOT_STATE_NORMAL);
				if ( ($result = $resDAOTermRoot["result"]) === RES_OK ){
					$arrTermRootControl = array();
					foreach ( $resDAOTermRoot["data"] as $dataTermRoot ){
						$dataTermRootID   = $dataTermRoot["t_term_root_id"];
						$dataTermRootName = $dataTermRoot["t_term_root_name"];
						if ( in_array($dataTermRootID, $qFixTermRootID) ){
							continue;
						}
						$arrTermRootControl[] = Printer::link($dataTermRootName, "btn btn-default", "icon-book", "inherit", NULL, "minhon.task.chart.onClickTaskFilterRemoveButton(this, event);", array("data-term-root-id" => $dataTermRootID, "data-ellipsis" => 20));
					}
					if ( count($arrTermRootControl) > 0 ){
						$arrControl[] = array(
							"id"   => "q_term_root_id",
							"name" => "{$WORD($wk, 16)}",
							"form" => $arrTermRootControl,
						);
					}
				} else {
					$result = RES_NG;
					$gResult->push("{$WORD($wk, 17)}");
				}
			} else if ( $result === RES_NO_DATA ){
				$result = RES_OK;
				$filterTaskID = array(0);
			} else {
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 18)}");
			}
		}
		
		//------------------------------------
		// 翻訳メモリからタスクを取得
		//------------------------------------
		if ( $result === RES_OK && count($qBilingualRootID) > 0 ){
			$resDAOTaskBilingualRoot = $objDAOTaskBilingualRoot->getSimpleTaskGroup($qBilingualRootID);
			if ( ($result = $resDAOTaskBilingualRoot["result"]) === RES_OK ){
				$arr = array();
				foreach ( $resDAOTaskBilingualRoot["data"] as $dataTaskBilingualRoot ){
					$arr[] = $dataTaskBilingualRoot["t_task_id"];
				}
				$arr = array_unique($arr);
				if ( is_array($filterTaskID) ){
					$filterTaskID = array_intersect($arr, $filterTaskID);
					$filterTaskID = is_null($filterTaskID) ? array() : $filterTaskID;
				} else {
					$filterTaskID = $arr;
				}
				// 検索フォーム
				$resDAOBilingualRoot = $objDAOBilingualRoot->get($qBilingualRootID, DAO::T_TERM_ROOT_STATE_NORMAL);
				if ( ($result = $resDAOBilingualRoot["result"]) === RES_OK ){
					$arrBilingualRootControl = array();
					foreach ( $resDAOBilingualRoot["data"] as $dataBilingualRoot ){
						$dataBilingualRootID   = $dataBilingualRoot["t_bilingual_root_id"];
						$dataBilingualRootName = $dataBilingualRoot["t_bilingual_root_name"];
						if ( in_array($dataBilingualRootID, $qFixBilingualRootID) ){
							continue;
						}
						$arrBilingualRootControl[] = Printer::link($dataBilingualRootName, "btn btn-default", "icon-book", "inherit", NULL, "minhon.task.chart.onClickTaskFilterRemoveButton(this, event);", array("data-bilingual-root-id" => $dataBilingualRootID, "data-ellipsis" => 20));
					}
					if ( count($arrBilingualRootControl) > 0 ){
						$arrControl[] = array(
							"id"   => "q_bilingual_root_id",
							"name" => "{$WORD($wk, 19)}",
							"form" => $arrBilingualRootControl,
						);
					}
				} else {
					$result = RES_NG;
					$gResult->push("{$WORD($wk, 20)}");
				}
			} else if ( $result === RES_NO_DATA ){
				$result = RES_OK;
				$filterTaskID = array(0);
			} else {
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 21)}");
			}
		}
		
		//====================
		// 取得
		//====================
		if ( $result === RES_OK ){
			$row = 0;
			
			switch ( $qMode ){
				// ****************************
				//  詳細 タスクグループごと
				// ****************************
				case APP_TASK_CHART_CONTROLLER_MODE_DETAIL_TASK:
					$arrTypeGroup = array();
					foreach ( Task::SETTING_TABLE() as $type => $value ){
						$group = Task::SETTING_TABLE($type, "group");
						$arrTypeGroup[$group][] = $type;
					}
					
					$objDAOTask->setAuth($auth);
					foreach ( $arrTypeGroup as $typeGroup => $arrType ){
						$groupName = Task::TYPE_GROUP_TABLE($typeGroup);
						$hGroupName = Util::esc($groupName);
						
						$resDAOTask = $objDAOTask->get($filterTaskID, NULL, $arrType, NULL, NULL, $qWorkflowID);
						if ( $resDAOTask["result"] === RES_NG ){
							$result = RES_NG;
							$gResult->push("{$WORD($wk, 22)}");
						}
						
						$arrItem = array();
						if ( $result === RES_OK ){
							if ( $qIsGrouping === ON ){
								$arrTask = array();
								foreach ( $resDAOTask["data"] as $data ){
									$taskID   = $data["t_task_id"];
									$taskType = $data["t_task_type"];
									$taskState = $data["t_task_state"];
									$taskStart = (strcmp($data["t_task_start"], INIT_DATE) === 0) ? PHP_INT_MAX : strtotime($data["t_task_start"]);
									$taskEnd   = (strcmp($data["t_task_end"],   INIT_DATE) === 0) ? 0           : strtotime($data["t_task_end"]);
									
									if ( ! isset($arrTask[$taskType]) ){
										$arrTask[$taskType] = array();
									}
									if ( isset($arrTask[$taskType]["state"]) ){
										if ( $arrTask[$taskType]["state"] === DAO::T_TASK_STATE_CARIED || $taskState === DAO::T_TASK_STATE_CARIED ){
											$taskState = DAO::T_TASK_STATE_CARIED;
										} else if ( $arrTask[$taskType]["state"] === DAO::T_TASK_STATE_NORMAL || $taskState === DAO::T_TASK_STATE_NORMAL ){
											$taskState = DAO::T_TASK_STATE_NORMAL;
										} else { // if ( $arrTask[$taskType]["state"] === DAO::T_TASK_STATE_FINISH || $taskState === DAO::T_TASK_STATE_FINISH )
											$taskState = DAO::T_TASK_STATE_FINISH;
										}
									}
									if ( isset($arrTask[$taskType]["start"]) ){
										$taskStart = min($taskStart, $arrTask[$taskType]["start"]);
									}
									if ( isset($arrTask[$taskType]["end"]) ){
										$taskEnd = max($taskEnd, $arrTask[$taskType]["end"]);
									}
									
									$arrTask[$taskType]["t_task_id"][]  = $taskID;
									$arrTask[$taskType]["t_task_type"]  = $taskType;
									$arrTask[$taskType]["t_task_state"] = $taskState;
									$arrTask[$taskType]["t_task_start"] = $taskStart;
									$arrTask[$taskType]["t_task_end"]   = $taskEnd;
								}
								// 日付型から Y/m/d(MySQLの日付型)に直す
								foreach ( $arrTask as &$ $dataTask ){
									$taskStart = date("Y/m/d", $dataTask["t_task_start"]);
									$taskEnd   = date("Y/m/d", $dataTask["t_task_end"]);
								}
							} else {
								$arrTask = $resDAOTask["data"];
							}
							
							foreach ( $arrTask as $dataTask ){
								if ( ($item = getTask($row, $dataTask, $arrActor, $arrAppended, $arrLowerPriorityUser, $arrLowerPriorityDocument)) === FALSE ){
									$result = RES_NG;
									break;
								}
								$arrItem[] = $item;
							}
						}
						
						if ( $result !== RES_OK ){
							break;
						}
						if ( count($arrItem) > 0 ){
							$arrRes[] = array(
								"name"   => $hGroupName,
								"series" => $arrItem,
							);
						}
					}
					break;
					
				// ****************************
				// * 
				// ****************************
				//  詳細 担当者ごと
				case APP_TASK_CHART_CONTROLLER_MODE_DETAIL_USER:
				//  詳細 文書ごと
				case APP_TASK_CHART_CONTROLLER_MODE_DETAIL_DOCUMENT:
					$arrGroup = array();
					
					$objDAOTask->setAuth($auth);
					$arrTaskOrder = array(
						"t_task_start" => DAO::ASC,
						"t_task_end"   => DAO::ASC,
						"t_task_type"  => array_keys(Task::TYPE_TABLE()),
					);
					
					// 未処理のタスク
					// (基本的には担当者は存在するが、途中で参加者から外れた場合など)
					$arrRestTaskID = $filterTaskID;
					if ( ! is_array($arrRestTaskID) ){
						$resDAOTask = $objDAOTask->get(NULL, NULL, NULL, NULL, NULL, $qWorkflowID);
						if ( $resDAOTask["result"] === RES_NG ){
							$result = RES_NG;
							$gResult->push("{$WORD($wk, 23)}");
						} else {
							$arr = array();
							foreach ( $resDAOTask["data"] as $dataTask ){
								$arr[] = $dataTask["t_task_id"];
							}
							$arr = array_unique($arr);
							$arrRestTaskID = $arr;
						}
					}
					$arrRestTaskID = array_fill_keys($arrRestTaskID, ""); // キーとする(後で削除しやすいように)
					
					$arrGroup = array();
					switch ( $qMode ){
						case APP_TASK_CHART_CONTROLLER_MODE_DETAIL_USER:
							// 担当者になっているタスク(接触者は除く)
							$resDAOTaskActor = $objDAOTaskActor->get($filterTaskID, $qUserID, NULL, DAO::T_TASK_ACTOR_TYPE_ACTOR, $qWorkflowID, array("t_user_name" => DAO::ASC));
							if ( $resDAOTaskActor["result"] === RES_OK ){
								foreach ( $resDAOTaskActor["data"] as $dataTaskActor ){
									$userID = $dataTaskActor["t_user_id"];
									$taskID = $dataTaskActor["t_task_id"];
									$arrGroup[$userID][] = $taskID;
								}
							} else if ( $resDAOTaskActor["result"] === RES_NG ){
								$result = RES_NG;
								$gResult->push("{$WORD($wk, 24)}");
							}
							break;
						case APP_TASK_CHART_CONTROLLER_MODE_DETAIL_DOCUMENT:
							$resDAOTaskDocument = $objDAOTaskDocument->get($filterTaskID, $qDocumentID, $qWorkflowID, array_keys(DAO::T_DOCUMENT_STATE_VALID_TABLE()), array("t_document_title" => DAO::ASC));
							if ( $resDAOTaskDocument["result"] === RES_OK ){
								foreach ( $resDAOTaskDocument["data"] as $dataTaskDocument ){
									$documentID = $dataTaskDocument["t_document_id"];
									$taskID = $dataTaskDocument["t_task_id"];
									$arrGroup[$documentID][] = $taskID;
								}
							} else if ( $resDAOTaskDocument["result"] === RES_NG ){
								$result = RES_NG;
								$gResult->push("{$WORD($wk, 25)}");
							}
							break;
					}
					
					if ( $result === RES_OK && count($arrGroup) > 0 ){
						foreach ( $arrGroup as $key => $arrTaskID ){
							$arrTaskID = array_unique($arrTaskID);
							foreach ( $arrTaskID as $taskID ){
								unset($arrRestTaskID[$taskID]);
							}
							
							$resDAOTask = $objDAOTask->get($arrTaskID, NULL, NULL, NULL, NULL, $qWorkflowID, NULL, $arrTaskOrder);
							if ( ($result = $resDAOTask["result"]) === RES_NG ){
								$gResult->push("{$WORD($wk, 26)}");
								break;
							}
							
							$arrBufLowerPriorityUser     = is_array($arrLowerPriorityUser)     ? $arrLowerPriorityUser     : array();
							$arrBufLowerPriorityDocument = is_array($arrLowerPriorityDocument) ? $arrLowerPriorityDocument : array();
							switch ( $qMode ){
								case APP_TASK_CHART_CONTROLLER_MODE_DETAIL_USER:
									array_unshift($arrBufLowerPriorityUser, $key);
									break;
								case APP_TASK_CHART_CONTROLLER_MODE_DETAIL_DOCUMENT:
									array_unshift($arrBufLowerPriorityDocument, $key);
									break;
							}
							
							
							$arrItem = array();
							$startDate = PHP_INT_MAX;
							$endDate   = 0;
							if ( $result === RES_OK ){
								foreach ( $resDAOTask["data"] as $dataTask ){
									$taskStart = (strcmp($dataTask["t_task_start"], INIT_DATE) === 0) ? PHP_INT_MAX : strtotime($dataTask["t_task_start"]);
									$taskEnd   = (strcmp($dataTask["t_task_end"],   INIT_DATE) === 0) ? 0           : strtotime($dataTask["t_task_end"]);
									if ( $taskStart < $startDate ){
										$startDate = $taskStart;
									}
									if ( $taskEnd > $endDate ){
										$endDate = $taskEnd;
									}
									if ( ($item = getTask($row, $dataTask, $arrActor, $arrAppended, NULL/*$arrBufLowerPriorityUser*/, NULL/*$arrBufLowerPriorityDocument*/)) === FALSE ){
										$result = RES_NG;
										break;
									}
									$arrItem[] = $item;
								}
							}
							
							if ( $result !== RES_OK ){
								break;
							}
							if ( count($arrItem) > 0 ){
								switch ( $qMode ){
									case APP_TASK_CHART_CONTROLLER_MODE_DETAIL_USER:
										$userName = DAO::storedFunction("get_user_name", $key);
										$hName = Util::esc($userName);
										break;
									case APP_TASK_CHART_CONTROLLER_MODE_DETAIL_DOCUMENT:
										$documentTitle = DAO::storedFunction("get_document_title", $key);
										$hName = Util::esc($documentTitle);
										break;
								}
								$arrRes[] = array(
									"startDate" => $startDate,     // 並び替え用
									"endDate"   => $endDate,       // 並び替え用
									"index"     => count($arrRes), // 並び替え用
									"name"      => $hName,
									"series"    => $arrItem,
								);
							}
						}
						
						if ( count($arrRes) > 0 ){
							// 並び替え
							usort($arrRes, "sortStartEnd");
							// 並び替え用のデータを削除
							foreach ( $arrRes as &$data ){
								unset($data["startDate"]);
								unset($data["endDate"]);
								unset($data["index"]);
							}
						}
					}
					
					// 残りのタスク
					if ( count($arrRestTaskID) > 0 ){
						$resDAOTask = $objDAOTask->get(array_keys($arrRestTaskID), NULL, NULL, NULL, NULL, $qWorkflowID, NULL, $arrTaskOrder);
						if ( $resDAOTask["result"] === RES_NG ){
							$result = RES_NG;
							$gResult->push("{$WORD($wk, 27)}");
						} else if ( $resDAOTask["result"] === RES_OK ){
							$arrItem = array();
							foreach ( $resDAOTask["data"] as $dataTask ){
								if ( ($item = getTask($row, $dataTask, $arrActor, $arrAppended, $arrLowerPriorityUser, $arrLowerPriorityDocument)) === FALSE ){
									$result = RES_NG;
									break;
								}
								$arrItem[] = $item;
							}
							if ( count($arrItem) > 0 ){
								$arrRes[] = array(
									"name"   => "",
									"series" => $arrItem,
								);
							}
						}
					}
					
					break;
					
				// ****************************
				//  タスク割当て
				// ****************************
				case APP_TASK_CHART_CONTROLLER_MODE_ALLOCATE:
					$resDAOWorkflow = $objDAOWorkflow->get($qWorkflowID);
					if ( ($result = $resDAOWorkflow["result"]) === RES_OK ){
						$dataWorkflow = $resDAOWorkflow["data"][0];
						$arrTaskType = explode(",", $dataWorkflow["t_workflow_task_type"]);
						foreach ( $arrTaskType as $type ){
							if ( Validate::isNumeric($type) && Validate::inArray((int)$type, array_keys(Task::TYPE_TABLE())) ){
								$group = Task::SETTING_TABLE($type, "group");
								$arrTypeGroup[$group][] = $type;
							}
						}
						
						$objDAOTask->setAuth($auth);
						foreach ( $arrTypeGroup as $typeGroup => $arrType ){
							$groupName = Task::TYPE_GROUP_TABLE($typeGroup);
							$hGroupName = Util::esc($groupName);
							
							$arrItem = array();
							
							$hGroupTaskType = Util::esc(implode(",", $arrType));
							$firstTaskType = Util::esc(reset($arrType));
							$hGroupName = Printer::link($groupName, NULL, NULL, NULL, NULL, "minhon.task.chart.onClickTaskNew('{$firstTaskType}', '{$hGroupTaskType}');");
							
							foreach ( $arrType as $taskType ){
								$taskName = Task::TYPE_TABLE($taskType);
								$hTaskNewLink = Printer::link($taskName, NULL, NULL, NULL, NULL, "minhon.task.chart.onClickTaskNew('{$taskType}');");//$hTitle;//"<div>{$taskName}</div>";
								
								$resDAOTask = $objDAOTask->get($filterTaskID, NULL, $taskType, NULL, NULL, $qWorkflowID);
								if ( $resDAOTask["result"] === RES_OK ){
									foreach ( $resDAOTask["data"] as $data ){
										$data["t_task_start"] = (strcmp($data["t_task_start"], INIT_DATE) === 0) ? "" : $data["t_task_start"];
										$data["t_task_end"]   = (strcmp($data["t_task_end"],   INIT_DATE) === 0) ? "" : $data["t_task_end"];
										
										// ユーザー
										if ( ($hIconUser = getHeaderUser(FALSE, $data["t_task_id"], $isIncludeMe)) === FALSE ){
											$result = RES_NG;
											break;
										}
										// 文書
										if ( ($hIconDocument = getHeaderDocument(FALSE, $data["t_task_id"])) === FALSE ){
											$result = RES_NG;
											break;
										}
										// ブロック(予定と実績)
										if ( ($arrBlock = getTaskBlock($row+1, $data["t_task_id"], $data["t_task_start"], $data["t_task_end"])) === FALSE ){
											$arrBlock = NULL;
										}
$html = <<< HTML
										<div class="ganttview-vtheader-task">
											{$hIconUser}{$hIconDocument}
										</div>
HTML;
										
										$row++;
										$arrItem[] = array(
											"name"      => $taskName,
											"id"        => $row,
											"taskID"    => $data["t_task_id"],
											"type"      => $taskType,
											"start"     => $data["t_task_start"],
											"end"       => $data["t_task_end"],
											"header"    => $html,
											"headerReserve" => $hTaskNewLink,
											"seriesAttr" => array(
												"id"           => "row-".$row,
												"data-task-id" => $data["t_task_id"],
											),
											"block"     => $arrBlock,
											"isCharge"  => $isIncludeMe,
										);
										
										$hTaskNewLink = ""; // 初回のみ値を与える
									}
								} else if ( $resDAOTask["result"] === RES_NO_DATA ){
									$row++;
									$arrItem[] = array(
										"name"      => $taskName,
										"id"        => $row,
										"type"      => $taskType,
										"start"     => "",
										"end"       => "",
										"header"    => "",
										"headerReserve" => $hTaskNewLink,
										"isCharge"  => FALSE,
									);
								} else {
									$result = RES_NG;
									$gResult->push("{$WORD($wk, 28)}");
								}
							}
							
							if ( $result !== RES_OK ){
								break;
							}
							if ( count($arrItem) > 0 ){
								$arrRes[] = array(
									"name"   => $hGroupName,
									"series" => $arrItem,
								);
							}
						}
					}
					break;
			}
			
			if ( $result === RES_OK ){
				if ( count($arrRes) === 0 ){
					$result = RES_NO_DATA;
					$gResult->push("{$WORD($wk, 29)}");
				} else {
					//******************************
					// 状態
					//******************************
					$arrTaskStateHeader = array();
					foreach ( array_reverse(DAO::T_TASK_STATE_TABLE(), TRUE) as $state => $text ){
						$arrTaskStateHeader[$state] = $objViewTask->state($state, NULL, "task-state");
					}
					$hTaskStateHeader = implode("\r\n", $arrTaskStateHeader);
				
$hState = <<< HTML
					<span id="workflow_description">
						<span>{$WORD($wk, 30)}：</span>
						{$hTaskStateHeader}
					</span>
HTML;
					
					//******************************
					// 検索フォーム
					//******************************
					if ( count($arrControl) > 0 ){
						$arrHtml["form"] = Printer::form("form_workflow_search", "form_workflow_search", NULL, NULL, $arrControl, $arrAction);
						$hClearButton = Printer::link("{$WORD($wk, 31)}", "btn btn-danger", NULL, NULL, NULL, "minhon.task.chart.onClickTaskFilterClear();");
$hPrepend .= <<< HTML
						<div class="container">
							<div class="filter panel panel-default">
								<div class="panel-body">
									{$arrHtml["form"]}
								</div>
								<div class="panel-footer" style="text-align: right;">
									{$hClearButton}
								</div>
							</div>
						</div>
HTML;
					}
				}
			}
			
			if ( $result !== RES_NG ){
				$hCornerCell = "";
				switch ( $qMode ){
					case APP_TASK_CHART_CONTROLLER_MODE_DETAIL_TASK:
					case APP_TASK_CHART_CONTROLLER_MODE_DETAIL_USER:
					case APP_TASK_CHART_CONTROLLER_MODE_DETAIL_DOCUMENT:
						if ( count($qFixParameter) > 0 ){
							$hCornerCell = Printer::link("{$WORD($wk, 32)}", "", "icon-list-alt", NULL, "/content/workflow/detail.html?q_project_id={$qProjectID}&q_id={$qWorkflowID}");
						} else {
							$arrModeText = array(
								APP_TASK_CHART_CONTROLLER_MODE_DETAIL_TASK     => "{$WORD($wk, 33)}",
								APP_TASK_CHART_CONTROLLER_MODE_DETAIL_USER     => "{$WORD($wk, 34)}",
								APP_TASK_CHART_CONTROLLER_MODE_DETAIL_DOCUMENT => "{$WORD($wk, 35)}",
							);
							$arrVtHeader = array();
							foreach ( $arrModeText as $mode => $modeText ){
								$link = "minhon.task.chart.onClickTaskFilter('mode', {$mode}, event)";
								$icon = ($qMode === $mode) ? "icon-arrow-right" : "icon-none";
								$arrVtHeader[$mode] = Printer::link($modeText, NULL, $icon, NULL, NULL, $link);
							}
							$hCornerCell = Printer::buttonGroup($arrModeText[$qMode], $arrVtHeader, "default");
						}
						break;
					case APP_TASK_CHART_CONTROLLER_MODE_ALLOCATE:
						// 割当て中の時はメッセージを表示
$hCornerCell .= <<< HTML
						<div id="workflow_chart_message" class="bg-danger">
							<span>{$WORD($wk, 36)}</span>
						</div>
HTML;
						break;
				}
				
$hPrepend .= <<< HTML
				<div id="workflow_cornercell">
					{$hCornerCell}
				</div>
HTML;
			}
		}
	}
}

$message  = $gResult->string(FALSE, $result);
$hMessage = $gResult->string(TRUE, $result);
if ( strlen($message) > 0 ){
$hMessage = <<< HTML
	<div class="container">{$hMessage}</div>
HTML;
}

$res["result"]      = $result;
$res["message"]     = $message;
$res["messageHTML"] = $hMessage;
$res["data"]        = $arrRes;
$res["startDate"]   = $projectStartDate;
$res["endDate"]     = $projectEndDate;
$res["stateHTML"]   = $hState;
$res["prependHTML"]  = $hPrepend;

echo json_encode($res);
