<?php require_once("common/Common.php"); ?>
<?php
//--------------------------------------------------------------------
// explain  : タスク
// argument : 
//--------------------------------------------------------------------
//----------------------------
// define
//----------------------------
//----------------------------
// variable
//----------------------------
// word key
$wk = "WORD_P_APP_TASK_CONTROLLER";
// result
$result = RES_OK;
// data
$start = NULL;
$end   = NULL;
$resData = NULL;
$arrActor = array();
$arrDocument = array();
// html

//----------------------------
// request parameter
//----------------------------
$qProjectID = isset($_SESSION["project_id"]) ? $_SESSION["project_id"] : REQ_NON;

$qToken      = isset($_REQUEST["q_token"])       ? $_REQUEST["q_token"]       : REQ_NON;
$qMode       = isset($_REQUEST["q_mode"])        ? $_REQUEST["q_mode"]        : REQ_NON;
$qWorkflowID = isset($_REQUEST["q_workflow_id"]) ? $_REQUEST["q_workflow_id"] : REQ_NON;
$qTaskID     = isset($_REQUEST["q_task_id"])     ? $_REQUEST["q_task_id"]     : REQ_NON;
$qTaskIDs    = isset($_REQUEST["q_task_ids"])    ? $_REQUEST["q_task_ids"]    : REQ_NON;
$qDocumentID = isset($_REQUEST["q_document_id"]) ? $_REQUEST["q_document_id"] : REQ_NON;
$qState      = isset($_REQUEST["q_state"])       ? $_REQUEST["q_state"]       : REQ_NON;
$qRole       = isset($_REQUEST["q_role"])        ? $_REQUEST["q_role"]        : REQ_NON;
$qTaskType   = isset($_REQUEST["q_task_type"])   ? $_REQUEST["q_task_type"]   : REQ_NON;
$qTaskTypes  = isset($_REQUEST["q_task_types"])  ? $_REQUEST["q_task_types"]  : REQ_NON;

$qOption     = isset($_REQUEST["q_option"])      ? $_REQUEST["q_option"]      : REQ_NON;
$qTaskStart  = isset($_REQUEST["q_start"])       ? $_REQUEST["q_start"]       : REQ_NON;
$qTaskEnd    = isset($_REQUEST["q_end"])         ? $_REQUEST["q_end"]         : REQ_NON;
$qTaskActor  = isset($_REQUEST["q_actor"])       ? $_REQUEST["q_actor"]       : REQ_NON;
$qTaskObject = isset($_REQUEST["q_object"])      ? $_REQUEST["q_object"]      : REQ_NON;
$qTaskState  = isset($_REQUEST["q_state"])       ? $_REQUEST["q_state"]       : REQ_NON;

//----------------------------
// judge post
//----------------------------
$isPost = ($qToken !== REQ_NON);

//----------------------------
// set types
//----------------------------
Util::setType($qProjectID,  "int");
Util::setType($qToken,      "string");
Util::setType($qMode,       "int");
Util::setType($qWorkflowID, "int");
Util::setType($qTaskID,     "int");
Util::setType($qTaskIDs,    "int");
Util::setType($qDocumentID, "int");
Util::setType($qState,      "int");
Util::setType($qRole,       "int");
Util::setType($qTaskType,   "int");
Util::setType($qTaskTypes,  "string");
Util::setType($qTaskStart,  "string");
Util::setType($qTaskEnd,    "string");

//----------------------------
// Auth-Before validate
//----------------------------
if ( $result === RES_OK ){
	if ( ! Validate::inArray($qMode, $G_APP_TASK_CONTROLLER_MODE_TABLE) ){
		$result = RES_NG;
		$gResult->push("{$WORD($wk, 1)}");
	}
	if ( ! Validate::isNumeric($qProjectID) ){
		$result = RES_NG;
		$gResult->push("{$WORD($wk, 2)}");
	}
	if ( ! Validate::isNumeric($qTaskID) && (Validate::isArray($qTaskIDs) && Validate::isNumeric($qTaskIDs[0])) ){
		$qTaskID = $qTaskIDs[0];
	}
	switch ( $qMode ){
		case APP_TASK_CONTROLLER_MODE_GET_TASK_DETAIL:
		case APP_TASK_CONTROLLER_MODE_GET_TASK_EDIT:
		case APP_TASK_CONTROLLER_MODE_GET_TASKINFO:
		case APP_TASK_CONTROLLER_MODE_ACTION:
			if ( ! Validate::isNumeric($qTaskID) ){
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 3)}");
			}
			break;
		case APP_TASK_CONTROLLER_MODE_GET_TASK_NEW:
			if ( ! Validate::isNumeric($qWorkflowID) ){
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 4)}");
			}
			if ( ! Validate::isNumeric($qTaskType) ){
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 5)}");
			}
			break;
		case APP_TASK_CONTROLLER_MODE_SET_TASK_UPDATE:
			if ( ! Validate::isNumeric($qWorkflowID) ){
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 6)}");
			}
			if ( ! Validate::isNumeric($qTaskID) ){
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 7)}");
			}
			if ( ! Validate::isToken($qToken, "q_token", FALSE) ){
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 8)}");
			}
			if ( ! Validate::inKeyArray($qTaskState, DAO::T_TASK_STATE_TABLE()) ){
				$qTaskState = NULL;
			}
			break;
		case APP_TASK_CONTROLLER_MODE_SET_TASK_DELETE:
			if ( ! Validate::isNumeric($qTaskID) ){
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 9)}");
			}
			if ( ! Validate::isToken($qToken, "token_common", FALSE) ){
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 10)}");
			}
			break;
		case APP_TASK_CONTROLLER_MODE_SET_STATE:
			if ( ! Validate::isToken($qToken, "q_token", FALSE) && ! Validate::isToken($qToken, "q_token_qredit", FALSE) ){
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 11)}");
			}
			break;
		case APP_TASK_CONTROLLER_MODE_GET_TASKS_FROM_DOCUMENT:
			if ( ! Validate::isNumeric($qDocumentID) ){
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 12)}");
			}
			break;
	}
}

//----------------------------
// Auth
//----------------------------
if ( $result === RES_OK ){
	$auth = Auth::instance("task");
	switch ( $qMode ){
		case APP_TASK_CONTROLLER_MODE_GET_TASKS_FROM_DOCUMENT:
			if ( ! $auth->readList($qProjectID) ){
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 13)}");
			}
			break;
		case APP_TASK_CONTROLLER_MODE_GET_TASK_DETAIL:
		case APP_TASK_CONTROLLER_MODE_GET_TASKINFO:
		case APP_TASK_CONTROLLER_MODE_ACTION:
			if ( ! $auth->read($qTaskID, $qProjectID) ){
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 14)}");
			}
			break;
		case APP_TASK_CONTROLLER_MODE_GET_TASK_NEW:
			if ( ! $auth->write(INIT_ID, $qProjectID) ){
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 15)}");
			}
			break;
		case APP_TASK_CONTROLLER_MODE_GET_TASK_EDIT:
			if ( ! $auth->write($qTaskID, $qProjectID) ){
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 16)}");
			}
			break;
		case APP_TASK_CONTROLLER_MODE_SET_TASK_UPDATE:
			if ( ! $auth->write($qTaskID, $qProjectID) ){
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 17)}");
			} else if ( Validate::isNumeric($qTaskState) && ! $auth->write_isEditState($qTaskID, $qProjectID) ){
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 18)}");
			}
			break;
		case APP_TASK_CONTROLLER_MODE_SET_TASK_DELETE:
			if ( ! $auth->remove($qTaskID, $qProjectID) ){
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 19)}");
			}
			break;
		case APP_TASK_CONTROLLER_MODE_SET_STATE:
			if ( ! $auth->write_isState($qTaskID, $qProjectID) ){
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 20)}");
			}
			break;
	}
}

//----------------------------
// Auth-After validate
//----------------------------
if ( $result === RES_OK ){
	switch ( $qMode ){
		case APP_TASK_CONTROLLER_MODE_GET_TASK_DETAIL:
			break;
		case APP_TASK_CONTROLLER_MODE_GET_TASK_NEW:
			if ( ! Validate::inKeyArray($qTaskType, Task::TYPE_TABLE()) ){
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 21)}");
			}
			if ( ! Validate::isArray($qOption) ){
				$qOption = array();
			}
			break;
		case APP_TASK_CONTROLLER_MODE_GET_TASK_EDIT:
			break;
		case APP_TASK_CONTROLLER_MODE_SET_TASK_UPDATE:
			if ( ! Validate::inKeyArray($qTaskType, Task::TYPE_TABLE()) ){
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 22)}");
			}
			if ( ! Validate::isDate($qTaskStart) || ! Validate::isDate($qTaskEnd) ){
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 23)}");
			}
			if ( ! Validate::isDateFuture($qTaskEnd, $qTaskStart) ){
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 24)}");
			}
			if ( ! validate::isArray($qTaskActor) ){
				$qTaskActor = array();
			}
			if ( ! Validate::isArray($qTaskObject) ){
				$qTaskObject = array();
			}
			break;
		case APP_TASK_CONTROLLER_MODE_GET_TASKINFO:
			break;
		case APP_TASK_CONTROLLER_MODE_SET_STATE:
			if ( ! Validate::inKeyArray($qState, DAO::T_TASK_STATE_TABLE()) ){
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 25)}");
			}
			break;
		case APP_TASK_CONTROLLER_MODE_GET_TASKS_FROM_DOCUMENT:
			break;
	}
}


//----------------------------
// function
//----------------------------
function getTaskObjectID( $type, $obj, $arrProps ) {
	$arrRes = array();
	if ( ($idx = array_search(Task::PROPTYPE_TERM_ROOT_ALL, $arrProps)) !== FALSE ){
		$arrProps = array_unique(array_merge($arrProps, array(Task::PROPTYPE_TERM_ROOT_PROJECT, Task::PROPTYPE_TERM_ROOT_REFERENCE)));
	}
	if ( ($idx = array_search(Task::PROPTYPE_BILINGUAL_ROOT_ALL, $arrProps)) !== FALSE ){
		$arrProps = array_unique(array_merge($arrProps, array(Task::PROPTYPE_BILINGUAL_ROOT_PROJECT, Task::PROPTYPE_BILINGUAL_ROOT_REFERENCE)));
	}
	if ( ($idx = array_search(Task::PROPTYPE_DATA_ALL, $arrProps)) !== FALSE ){
		$arrProps = array_unique(array_merge($arrProps, array(Task::PROPTYPE_DATA_BRIEF, Task::PROPTYPE_DATA_DELIVERABLE, Task::PROPTYPE_DATA_RESEARCH_RESULTS, Task::PROPTYPE_DATA_OTHERS)));
	}
	
	$setting = Task::SETTING_TABLE($type);
	$arrTaskProps = array_merge($setting["input"], $setting["output"]);
	foreach ( $arrTaskProps as $name => $dataTaskProps ){
		if ( in_array($dataTaskProps["type"], $arrProps) ) {
			if ( isset($obj[$name]) ){
				if ( is_array($obj[$name]) ){
					if ( ! isset($arrRes[$name]) ){
						$arrRes[$name] = array();
					}
					$arrRes[$name] = Util::array_push_array($arrRes[$name], $obj[$name]);
				} else {
					$arrRes[$name] = $obj[$name];
				}
			}
		}
	}
	
	return $arrRes;
}


//----------------------------
// process
//----------------------------
if ( $result == RES_OK ){
	$objDAOTask              = DAO::instance("task");
	$objDAOTaskActor         = DAO::instance("task_actor");
	$objDAOTaskDocument      = DAO::instance("task_document");
	$objDAOTaskTermRoot      = DAO::instance("task_term_root", Term::KIND_TERM);
	$objDAOTaskBilingualRoot = DAO::instance("task_term_root", Term::KIND_BILINGUAL);
	$objDAOTaskData          = DAO::instance("task_data");
	$objDAOProject           = DAO::instance("project");
	$objDAODocument          = DAO::instance("document");
	$objViewTask             = View::instance("task");
	
	$objProject = new Project($qProjectID);
	
	if ( $result === RES_OK ){
		switch ( $qMode ){
			case APP_TASK_CONTROLLER_MODE_GET_TASK_DETAIL:
			case APP_TASK_CONTROLLER_MODE_GET_TASK_NEW:
			case APP_TASK_CONTROLLER_MODE_GET_TASK_EDIT:
				// ユーザー役割一覧 --------------------
				if ( $result === RES_OK ){
					if ( ($arrActor = $objProject->getUser()) === FALSE ){
						$result = RES_NG;
						$gResult->push("{$WORD($wk, 26)}");
					}
				}
				
				// プロジェクトデータ一覧 --------------------
				if ( $result === RES_OK ){
					if ( ($arrAppended = $objProject->getAppended()) === FALSE ){
						$result = RES_NG;
						$gResult->push("{$WORD($wk, 27)}");
					}
				}
				
				// フォーム --------------------
				if ( $result === RES_OK ){
					if ( $qMode === APP_TASK_CONTROLLER_MODE_GET_TASK_DETAIL ){
						$objDAOTask->setAuth($auth);
						$resDAOTask = $objDAOTask->get($qTaskID);
						
						if ( ($result = $resDAOTask["result"]) === RES_OK ){
							// 詳細
							$resData = array(
								"title"  => "{$WORD($wk, 28)}",
								"dialog" => $objViewTask->detail($resDAOTask["data"][0], $arrActor, $arrAppended, $qTaskIDs),
							);
						}
					} else if ( $qMode === APP_TASK_CONTROLLER_MODE_GET_TASK_NEW ){
						$resDAOProject = $objDAOProject->get($qProjectID);
						if ( ($result = $resDAOProject["result"]) === RES_OK ){
							if ( ! Validate::isDate($qTaskStart) && ! Validate::isDate($qTaskEnd) ){
								$qTaskStart = $resDAOProject["data"][0]["t_project_start"];
							}
						} else {
							$result = RES_NG;
							$gResult->push("{$WORD($wk, 29)}");
						}
						
						if ( $result === RES_OK ){
							if ( ($disabledDocument = $objProject->getDisabledDocument(NULL, $qTaskType)) === FALSE ){
								$result = RES_NG;
								$gResult->push("{$WORD($wk, 30)}");
							} else {
								$arrAppended["disabled-document"] = $disabledDocument;
							}
						}
						
						if ( $result === RES_OK ){
							if ( Validate::isString($qTaskTypes) ){
								$arrTaskType = explode(",", $qTaskTypes);
								if ( ! in_array($qTaskType, $arrTaskType) ){
									$arrTaskType = NULL;
								}
							} else {
								$arrTaskType = NULL;
							}
						}
						
						if ( $result === RES_OK ){
							$arrSelectActor  = array();
							$arrSelectObject = array();
							$dataTask = array(
								"t_task_id"     => INIT_ID,
								"t_task_state"  => DAO::T_TASK_STATE_NORMAL,
								"t_task_type"   => $qTaskType,
								"t_task_start"  => $qTaskStart,
								"t_task_end"    => $qTaskEnd,
								"t_workflow_id" => $qWorkflowID,
								"t_project_id"  => $qProjectID,
							);
							if ( is_array($qOption) && count($qOption) > 0 ){
								foreach ( $qOption as $key => $value ){
									if ( strcmp($key, "q_start") === 0 ){
										$dataTask["t_task_start"] = $value;
									} else if ( strcmp($key, "q_end") === 0 ){
										$dataTask["t_task_end"] = $value;
									} else if ( strcmp(substr($key, 0, 8), "q_object") === 0 ){
										foreach ( $value as $props => $arrObjectID ){
											$arrIDName = array_fill_keys($arrObjectID, "");
											if ( Task::isPropTypeDocument(NULL, $qTaskType, $props) ){
												foreach ( $arrIDName as $id => &$text ){
													$text = DAO::storedFunction("get_document_title", $id);
												}
											} else if ( Task::isPropTypeTermRoot(NULL, $qTaskType, $props) ){
												foreach ( $arrIDName as $id => &$text ){
													$text = DAO::storedFunction("get_term_root_name", $id);
												}
											} else if ( Task::isPropTypeBilingualRoot(NULL, $qTaskType, $props) ){
												foreach ( $arrIDName as $id => &$text ){
													$text = DAO::storedFunction("get_bilingual_root_name", $id);
												}
											} else if ( Task::isPropTypeData(NULL, $qTaskType, $props) ){
												foreach ( $arrIDName as $id => &$text ){
													$text = DAO::storedFunction("get_data_title", $id);
												}
											} else {
												continue;
											}
											
											$arrSelectObject[$props] = $arrIDName;
										}
									} else if ( strcmp(substr($key, 0, 7), "q_actor") === 0 ){
										$arrUserList = array();
										foreach ( $value as $role => $arrUser ){
											$arrUserList = array_merge($arrUserList, $arrUser);
										}
										$arrUserList = array_unique($arrUserList);
										if ( count($arrUserList) > 0 ){
											$objDAOUser = DAO::instance("user");
											$resDAOUser = $objDAOUser->get($arrUserList);
											$arrUserData = array();
											if ( $resDAOUser["result"] === RES_OK ){
												foreach ( $resDAOUser["data"] as $dataUser ){
													$arrUserData[$dataUser["t_user_id"]] = $dataUser;
												}
											}
											foreach ( $value as $role => $arrUser ){
												foreach ( $arrUser as $userID ){
													$arrSelectActor[$role][$userID] = $arrUserData[$userID];
												}
											}
										}
									}
								}
							}
							
							// 新規登録
							$resData = array(
								"title"  => "{$WORD($wk, 31)}",
								"dialog" => $objViewTask->edit($dataTask, $arrTaskType, $arrActor, $arrAppended, $arrSelectActor, $arrSelectActor, $arrSelectObject, TRUE),
							);
						}
					} else if ( $qMode === APP_TASK_CONTROLLER_MODE_GET_TASK_EDIT ){
						$objDAOTask->setAuth($auth);
						$resDAOTask = $objDAOTask->get($qTaskID);
						if ( ($result = $resDAOTask["result"]) === RES_OK ){
							$dataTask = $resDAOTask["data"][0];
						}
						
						if ( $result === RES_OK ){
							if ( ($disabledDocument = $objProject->getDisabledDocument($qTaskID, $dataTask["t_task_type"])) === FALSE ){
								$result = RES_NG;
								$gResult->push("{$WORD($wk, 32)}");
							} else {
								$arrAppended["disabled-document"] = $disabledDocument;
							}
						}
						
						if ( $result === RES_OK ){
							if ( ($arrTaskActor = Task::getTaskActor($dataTask["t_task_id"])) === FALSE ){
								$arrTaskActor = NULL;
							}
							if ( ($arrTaskContact = Task::getTaskContact($dataTask["t_task_id"])) === FALSE ){
								$arrTaskContact = NULL;
							}
							if ( ($arrTaskObject = Task::convertTaskObject($dataTask["t_task_id"], $dataTask["t_task_type"], $dataTask["t_task_data"])) === FALSE ){
								$arrTaskObject = NULL;
							}
							
							// 詳細
							$resData = array(
								"title"  => "{$WORD($wk, 33)}",
								"dialog" => $objViewTask->edit($resDAOTask["data"][0], NULL, $arrActor, $arrAppended, $arrTaskActor, $arrTaskContact, $arrTaskObject),
							);
						}
					}
				}
				break;
			case APP_TASK_CONTROLLER_MODE_SET_TASK_UPDATE:
				DAO::begin();
				
				// data生成 --------------------
				$qTaskData = Task::getTaskDOMData($qTaskType, $qTaskObject);
				if ( $result === RES_OK ){
					$resDAOTask = $objDAOTask->register($qTaskID, $qTaskState, $qTaskType, $qTaskData, $qTaskStart, $qTaskEnd, $qWorkflowID, User::get("id"), User::get("organization_id"));
					if ( ($result = $resDAOTask["result"]) === RES_OK ){
						$taskID = $resDAOTask["id"];
					}
				}
				
				// 役割
				if ( $result === RES_OK ){
					$resDAOTaskActor = $objDAOTaskActor->register($taskID, $qTaskType, $qTaskActor);
					$result = $resDAOTaskActor["result"];
				}
				
				// 文書
				if ( $result === RES_OK ){
					$resDAOTaskDocument = $objDAOTaskDocument->delete($taskID);
					if ( ($result = $resDAOTaskDocument["result"]) === RES_OK ){
						$documentList = getTaskObjectID($qTaskType, $qTaskObject, array(Task::PROPTYPE_DOCUMENT));
						foreach ( $documentList as $propsName => $arrDocumentID ){
							$resDAOTaskDocument = $objDAOTaskDocument->register($taskID, $propsName, $arrDocumentID);
							if ( ($result = $resDAOTaskDocument["result"]) !== RES_OK ){
								break;
							}
						}
					}
				}
				// 用語集
				if ( $result === RES_OK ){
					$resDAOTaskTerm = $objDAOTaskTermRoot->delete($taskID);
					if ( ($result = $resDAOTaskTerm["result"]) === RES_OK ){
						$termList = getTaskObjectID($qTaskType, $qTaskObject, array(Task::PROPTYPE_TERM_ROOT_ALL));
						foreach ( $termList as $propsName => $arrTermID ){
							$resDAOTaskTerm = $objDAOTaskTermRoot->register($taskID, $propsName, $arrTermID);
							if ( ($result = $resDAOTaskTerm["result"]) !== RES_OK ){
								break;
							}
						}
					}
				}
				// 対訳集
				if ( $result === RES_OK ){
					$resDAOTaskBilingual = $objDAOTaskBilingualRoot->delete($taskID);
					if ( ($result = $resDAOTaskBilingual["result"]) === RES_OK ){
						$bilingualList = getTaskObjectID($qTaskType, $qTaskObject, array(Task::PROPTYPE_BILINGUAL_ROOT_ALL));
						foreach ( $bilingualList as $propsName => $arrBilingualID ){
							$resDAOTaskBilingual = $objDAOTaskBilingualRoot->register($taskID, $propsName, $arrBilingualID);
							if ( ($result = $resDAOTaskBilingual["result"]) !== RES_OK ){
								break;
							}
						}
					}
				}
				// データ
				if ( $result === RES_OK ){
					$resDAOTaskData = $objDAOTaskData->delete($taskID);
					if ( ($result = $resDAOTaskData["result"]) === RES_OK ){
						$dataList = getTaskObjectID($qTaskType, $qTaskObject, array(Task::PROPTYPE_DATA_ALL));
						foreach ( $dataList as $propsName => $arrDataID ){
							$resDAOTaskData = $objDAOTaskData->register($taskID, $propsName, $arrDataID);
							if ( ($result = $resDAOTaskData["result"]) !== RES_OK ){
								break;
							}
						}
					}
				}
				
				if ( $result === RES_OK ){
					$gResult->push("{$WORD($wk, 34)}");
				} else {
					$gResult->push("{$WORD($wk, 35)}");
				}
				
				DAO::end($result);
				break;
			case APP_TASK_CONTROLLER_MODE_SET_TASK_DELETE:
				DAO::begin();
				
				// 削除 --------------------
				if ( $result === RES_OK ){
					$resDAOTask = $objDAOTask->delete($qTaskID);
					$result = $resDAOTask["result"];
				}
				
				DAO::end($result);
				break;
			case APP_TASK_CONTROLLER_MODE_GET_TASKINFO:
				$objDAOTask->setAuth($auth);
				$resDAOTask = $objDAOTask->get($qTaskID);
				$result = $resDAOTask["result"];

				if ( $result === RES_OK ){
					$resDAOTaskActor = $objDAOTaskActor->get($qTaskID, User::get("id"), $qRole, DAO::T_TASK_ACTOR_TYPE_ACTOR);
					$result = $resDAOTaskActor["result"];
				}
				
				if ( $result === RES_OK ){
					if ( $resDAOTaskActor["count"] === 1 ){
						$dataTask = $resDAOTask["data"][0];
						$resData = array(
							"type"        => $dataTask["t_task_type"],
							"name"        => Task::TYPE_TABLE($dataTask["t_task_type"]),
							"state"       => $dataTask["t_task_state"],
							"state_text"  => DAO::T_TASK_STATE_TABLE($dataTask["t_task_state"]),
							"qredit_mode" => "edit", //"compare",
							"message"     => "{$WORD($wk, 36, Task::ROLE_TABLE($qRole))}",
						);
						switch ( $dataTask["t_task_type"] ){
							case Task::TYPE_TRANSLATION_TRANSLATE: //翻訳
								if ( $dataTask["t_task_state"] === DAO::T_TASK_STATE_FINISH ){
									$resData["qredit_mode"] = "correct";
								} else {
									$resData["qredit_mode"] = "edit";
								}
								break;
							case Task::TYPE_TRANSLATION_REVISE: //改訂
							case Task::TYPE_TRANSLATION_REVIEW: //レビュー
							case Task::TYPE_TRANSLATION_PROOF_READ: //校正
								$resData["qredit_mode"] = "correct";
								break;
						}
					} else {
						// 役割が複数ある場合は、NO_DATAを返す
						$result = RES_NO_DATA;
					}
				} else {
					$result = RES_NG;
					$gResult->push("{$WORD($wk, 37)}");
				}
				break;
			case APP_TASK_CONTROLLER_MODE_SET_STATE:
				$resDAOTask = $objDAOTask->register($qTaskID, $qState, NULL, NULL, NULL, NULL, NULL, User::get("id"), User::get("organization_id"));
				$result = $resDAOTask["result"];
				
				if ( $result === RES_NG ){
					$gResult->push("{$WORD($wk, 38)}");
				}
				break;
			case APP_TASK_CONTROLLER_MODE_GET_TASKS_FROM_DOCUMENT:
				// 文書からタスクを取得 --------------------
				$resDAOTaskDocument = $objDAOTaskDocument->get(NULL, $qDocumentID);
				$result = $resDAOTaskDocument["result"];
				if ( $result === RES_OK ){
					foreach ( $resDAOTaskDocument["data"] as $dataTaskDocument ){
						$filterTaskID[] = $dataTaskDocument["t_task_id"];
					}
					$filterTaskID = array_unique($filterTaskID);
					if ( ! is_null($qTaskID) && in_array($qTaskID, $filterTaskID) ){
						$filterTaskID = $qTaskID;
					}
				}
				
				// タスクを取得 --------------------
				if ( $result === RES_OK ){
					$resDAOTask = $objDAOTask->get($filterTaskID);
					$result = $resDAOTask["result"];
				}
				
				// タスク役割を取得 --------------------
				if ( $result === RES_OK ){
					$resDAOTaskActor = $objDAOTaskActor->get($filterTaskID, User::get("id"), NULL, DAO::T_TASK_ACTOR_TYPE_ACTOR);
					$result = $resDAOTaskActor["result"];
				}
				
				if ( $result === RES_OK ){
					if ( $resDAOTaskActor["count"] === 1 ){
						$data = $resDAOTaskActor["data"][0];
						$resData = array(
							"taskID" => $data["t_task_id"],
							"role"   => $data["t_task_role"],
						);
						$result = RES_NO_DATA;
					} else {
						$resData = array(
							"title"  => "{$WORD($wk, 39)}",
							"dialog" => $objViewTask->selectTaskAndRole($resDAOTask["data"], $resDAOTaskActor["data"]),
						);
					}
				} else {
					$result = RES_NG;
					$gResult->push("{$WORD($wk, 40)}");
				}
				break;
			case APP_TASK_CONTROLLER_MODE_ACTION:
				// タスクを取得 --------------------
				if ( $result === RES_OK ){
					$resDAOTask = $objDAOTask->get($qTaskID);
					$result = $resDAOTask["result"];
					
					if ( $result === RES_OK ){
						$taskType      = $resDAOTask["data"][0]["t_task_type"];
						$taskTypeGroup = TASK::SETTING_TABLE($taskType, "group");
						$qWorkflowID = $resDAOTask["data"][0]["t_workflow_id"];
					}
				}
				
				// 使用文書を取得 --------------------
				if ( $result === RES_OK ){
					$resDAOTaskDocument = $objDAOTaskDocument->get($qTaskID);
					$arrDocumentID = array();
					if ( $resDAOTaskDocument["result"] === RES_OK ){
						foreach ( $resDAOTaskDocument["data"] as $dataTaskDocument ){
							$arrDocumentID[] = $dataTaskDocument["t_document_id"];
						}
					}
					$arrDocumentID = array_unique($arrDocumentID);
					
					if ( Validate::isNumeric($qDocumentID) && in_array($qDocumentID, $arrDocumentID) ){
						$arrDocumentID = array( $qDocumentID );
					}
				}
				
				// URLを取得 --------------------
				$url = "";
				$isPopup = FALSE;
				$isSelectDocument = FALSE;
				if ( $result === RES_OK ){
					switch ( $taskTypeGroup ){
						case TASK::TYPE_GROUP_BRIEF: // 要項
							$url = "/content/data/index.html?q_project_id={$qProjectID}";
							break;
						case TASK::TYPE_GROUP_WORKFLOW: // ワークフロー
							switch ( $taskType ){
								case TASK::TYPE_WORKFLOW_REGISTER_PARTICIPANTS: // 参加者登録
									$url = "/content/member/edit.html?q_project_id={$qProjectID}";
									break;
								case TASK::TYPE_WORKFLOW_REGISTER_DOCUMENTS: // 文書登録
									$url = "/content/document/edit.html?q_project_id={$qProjectID}";
									break;
								default:
									$url = "/content/task/edit.html?q_project_id={$qProjectID}&q_workflow_id={$qWorkflowID}";
									break;
							}
							break;
						case TASK::TYPE_GROUP_TERM: // 用語
							$url = "/content/exterm/index.html?q_kind=term&q_project_id={$qProjectID}";
							break;
						case TASK::TYPE_GROUP_TRANS: // 翻訳
							if ( count($arrDocumentID) === 1 ){
								$documentID = $arrDocumentID[0];
								switch ( $taskType ){
									case TASK::TYPE_TRANSLATION_RESEARCH: // 下調べ
										$url = "/content/document/detail.html?q_id={$documentID}";
										break;
									default:
										$document = new Document($documentID);
										$qrMode = $document->getQReditMode( User::get("id"), $qTaskID );
										if ( ($qreditInfo = $document->getQReditModeInfo($qrMode, $documentID, $qTaskID)) === FALSE ){
											$result = RES_NG;
											$gResult->push("{$WORD($wk, 41)}");
										} else {
											$url = $qreditInfo["url"];
											$isPopup = TRUE;
										}
										break;
								}
							} else if ( count($arrDocumentID) > 1 ){
								$isSelectDocument = TRUE;
							} else {
								$result = RES_NG;
								$gResult->push("{$WORD($wk, 42)}");
							}
							break;
						case TASK::TYPE_GROUP_TM: // TM
							$url = "/content/term_root/index.html?q_kind=bilingual&q_project_id={$qProjectID}";
							break;
						case TASK::TYPE_GROUP_MT: // MT
							if ( count($arrDocumentID) === 1 ){
								$documentID = $arrDocumentID[0];
								$url = "/content/document/detail.html?q_id={$documentID}";
							} else if ( count($arrDocumentID) > 1 ){
								$isSelectDocument = TRUE;
							} else {
								$result = RES_NG;
								$gResult->push("{$WORD($wk, 43)}");
							}
							break;
					}
				}
				
				// 文書選択ダイアログを取得 --------------------
				$html = "";
				if ( $isSelectDocument ){
					foreach ( $arrDocumentID as $documentID ){
						$resDAODocument = $objDAODocument->get($documentID, array_keys(DAO::T_DOCUMENT_STATE_VALID_TABLE()));
						if ( $resDAODocument["result"] !== RES_OK ){
							continue;
						}
						$dataDocument = $resDAODocument["data"][0];
						
						$documentID    = $dataDocument["t_document_id"];
						$documentTitle = $dataDocument["t_document_title"];
						$documentLangS = $dataDocument["t_document_lang_s"];
						$documentLangT = $dataDocument["t_document_lang_t"];
						
						// タイトル
						$hTitle = Printer::icon("icon-file", NULL, $documentTitle);
						// 言語方向
						$hLang = Printer::directLang($documentLangS, $documentLangT);
						// ボタン
						$hSelectButton = Printer::link("{$WORD($wk, 44)}", "btn btn-default", NULL, NULL, NULL, "minhon.task.onClickTask({$qTaskID}, {$documentID});");
						//  "/content/document/detail.html?q_id={$documentID}"
						
$html .= <<< HTML
						<tr>
							<td>{$hTitle}</td>
							<td>{$hLang}</td>
							<td class="col-tight danger">{$hSelectButton}</td>
						</tr>
HTML;
					}
					
$html = <<< HTML
					<div>
						<h5>{$WORD($wk, 45)}</h5>
						<table class="table table-striped">
							<thead>
								<tr>
									<th>{$WORD($wk, 46)}</th>
									<th>{$WORD($wk, 47)}</th>
									<th class="col-tight danger"></th>
								</tr>
							</thead>
							<tbody>
								{$html}
							</tbody>
						</table>
					</div>
HTML;
				}
				
				$resData = array(
					"url"    => $url,
					"popup"  => $isPopup,
					"dialog" => $html,
				);
				
				break;
			default:
				$result = RES_NG;
				break;
		}
	}
}

$res["result"]      = $result;
$res["message"]     = $gResult->string(FALSE, $result);
$res["data"]        = $resData;

echo json_encode($res);
