minhon.search = {
	initialize : function(){
		$(".toggle[href]").on("click", function(){
			var target = $(this).attr("href");
			$(target).toggle();
			return false;
		});
		$(".close[href]").on("click", function(){
			var target = $(this).attr("href");
			$(target).hide();
			return false;
		});
		
		$("a[data-set-score]").on("click", function(){
			var val = $(this).attr("data-set-score");
			$("#q_score").val(val);
		});
		
		if ( $.validator ){
			// メッセージ挿入箇所
			$.validator.setDefaults({
				errorPlacement : function(error, element){
					// 通常処理
					error.insertAfter(element);
					if ( element.parent().is(".input-group") ){
						error.insertAfter(element.parent());
					}
				}
			});
			
			// 新しい計算メソッド
			$.validator.addMethod('minStrict', function(value, el, param){
				return this.optional(el) || value > param;
			}, $.format(WORD_J_JS_MINHON_SEARCH_001));
			
			$("#form_search").validate({
				rules: {
					q_score : {
						required : true,
						number : true,
						minStrict : 0,
						max : 1.0
					}
				}
			});
		}
	},
	
	eod : null
}
