<?php
Class DAO_project_lang extends DAO {
	/***************************************************************
	 * 名前:__construct
	 * 説明:コンストラクタ
	 * 引数:
	 * 返値:
	****************************************************************/
	function __construct( $_tableName = "t_project_lang" ){
		$this->tableName = $_tableName;
	}
	
	/***************************************************************
	 * 名前:getInit
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function getInit( $field ){
		$arrValue = array(
			"t_project_lang_s" => LANG_S_INIT,
			"t_project_lang_t" => array(LANG_T_INIT),
		);
		
		return $arrValue[$field];
	}
	
	/***************************************************************
	 * 名前:get
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function get( $projectID = NULL, $arrOrder = NULL, $limit = NULL, $offset = NULL ){
		$res = NULL;
		
		// *フィールド
		$arrField = array(
			"t_project_lang_s",
			"t_project_lang_t",
			"t_project_id",
		);
		// *条件
		$arrCondition = $this->getCondition(array(
			"t_project_id" => $projectID,
		));
		// *並び順
		$arrOrder = $this->getOrderBy($arrOrder, array(
		));
		
		// *実行
		$res = $this->_select($arrField, $arrCondition, NULL, NULL, $arrOrder, $limit, $offset);
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:register
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function register( $projectID, $langS, $langT ){
		$res    = NULL;
		
		// *フィールド
		$arrValue = array(
			"t_project_lang_s" => $langS,
			"t_project_lang_t" => $langT,
			"t_project_id"     => $projectID,
		);
		// *実行
		$res = $this->_insert($arrValue, TRUE);
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:delete
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function delete( $projectID ){
		$res    = NULL;
		
		// *条件
		$arrCondition = $this->getCondition(array(
			"t_project_id" => $projectID,
		));
		// *実行
		$res = $this->_delete($arrCondition);
		
		return $res;
	}
}
