<?php
Class Help {
	const KIND_DOCUMENT            = "document";
	const KIND_MANAGE_ORGANIZATION = "manage_organization";
	const KIND_MANAGE_USER         = "manage_user";
	const KIND_MENU                = "menu";
	const KIND_MANUAL              = "manual";
	const KIND_PROJECT             = "project";
	const KIND_TERM_ROOT           = "term_root";
	const KIND_TERM                = "term";
	const KIND_BBS                 = "bbs";
	
	const PAGE_BBS_01       = "bbs_01";
	const PAGE_BBS_02       = "bbs_02";
	const PAGE_MEMBER       = "member";
	const PAGE_NORMAL       = "normal";
	const PAGE_PROJECT      = "project";
	const PAGE_REGISTER     = "register";
	const PAGE_ROLE         = "role";
	const PAGE_SHORT        = "short";
	const PAGE_TASK         = "task";
	const PAGE_TASK_TYPE    = "task_type";
	const PAGE_TYPE         = "type";
	const PAGE_UPDATE       = "update";
	const PAGE_WORKFLOW_01  = "workflow_01";
	const PAGE_WORKFLOW_02  = "workflow_02";
	const PAGE_DOCUMENT     = "document";
	
	/***************************************************************
	 * 名前:get
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	public static function get( $kind, $page ){
		global $WORD;
		
		$path = Setting::get("PATH_DATA_HELP") ."/". basename("{$kind}.{$page}.html");
		
		if ( file_exists($path) ){
			$arr = include($path);
			
			return $arr;
		}
		
		return FALSE;
	}
}
