<?php
Class Term {
	const KIND_TERM      = "term";
	const KIND_BILINGUAL = "bilingual";
	const KIND_FIX       = "fix";
	
	/***************************************************************
	 * 名前:KIND_TABLE
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	public static function KIND_TABLE( $kind = NULL, $isRootName = TRUE ){
		global $WORD;
		$wk = "WORD_P_CLASS_TERM";

		if ( $isRootName ){
			$arrKind = array(
				self::KIND_TERM      => "{$WORD($wk, 1)}",
				self::KIND_BILINGUAL => "{$WORD($wk, 2)}",
				self::KIND_FIX       => "{$WORD($wk, 3)}",
			);
		} else {
			$arrKind = array(
				self::KIND_TERM      => "{$WORD($wk, 4)}",
				self::KIND_BILINGUAL => "{$WORD($wk, 5)}",
				self::KIND_FIX       => "{$WORD($wk, 6)}",
			);
		}
		
		return is_null($kind) ? $arrKind : $arrKind[$kind];
	}
	
	/***************************************************************
	 * 名前:KIND_SUB_TABLE
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	public static function KIND_SUB_TABLE( $kind = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_TERM";
		
		$arrKind = array(
			self::KIND_TERM      => "{$WORD($wk, 7)}",
			self::KIND_BILINGUAL => "{$WORD($wk, 8)}",
			self::KIND_FIX       => "{$WORD($wk, 9)}",
		);
		
		return is_null($kind) ? $arrKind : $arrKind[$kind];
	}
	
}
