<?php
Class Translator {
	const TRANSLATOR_ENGINE_ID_GENERAL = 1; // NICT Translator (general)
	const TRANSLATOR_ENGINE_ID_GENEJDP = 2; // NICT Translator (jdepp)
	const TRANSLATOR_ENGINE_ID_GENEKNP = 3; // NICT Translator (knp)
	const TRANSLATOR_ENGINE_ID_GENELBP = 4; // NICT Translator (bp)
	const TRANSLATOR_ENGINE_ID_GENEZPR = 5; // NICT Translator (zpr)
	const TRANSLATOR_ENGINE_ID_GENERA2 = 6; // NICT Translator (general2)
	
	var $TRANSLATOR_ENGINE_TABLE = array();
	
	/***************************************************************
	 * 名前:Translator
	 * 説明:コンストラクタ
	 * 引数:
	 * 返値:
	****************************************************************/
	function Translator(){
		global $WORD;
		
		$wk = "WORD_P_APP_CLASS_TRANSLATOR";
		
		$this->TRANSLATOR_ENGINE_TABLE = array(
			Translator::TRANSLATOR_ENGINE_ID_GENERAL => array(
				"engine" => "general",
				"lang" => array( 
					array("source" => LANG_JA, "target" => LANG_EN),
					array("source" => LANG_JA, "target" => LANG_KO),
					array("source" => LANG_JA, "target" => LANG_CN),
					array("source" => LANG_JA, "target" => LANG_TW),
					array("source" => LANG_EN, "target" => LANG_JA),
					array("source" => LANG_CN, "target" => LANG_JA),
					array("source" => LANG_TW, "target" => LANG_JA),
					array("source" => LANG_KO, "target" => LANG_JA),
				),
				"title"   => "{$WORD($wk, 11)}",
				"explain" => "{$WORD($wk, 12)}",
			),
		);
	}
	
	
	/***************************************************************
	 * 名前:translate
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function translate( $engineID, $sLang, $tLang, $text, $arrSP ){
		$res = "";
		
		$arrQuery = array(
			"model" => $this->TRANSLATOR_ENGINE_TABLE[$engineID]["engine"],
			"slang" => $sLang,
			"tlang" => $tLang,
			"text"  => $text,
			"sp"    => $arrSP,
		);
		
		$url = Setting::get("URL_TRANSLATE_NICT") . "?" . http_build_query($arrQuery, "", "&");
		
		if ( ($text = Util::file_get_contents($url)) ){
			$text = preg_replace("/(\r\n|\r|\n)/", "\n", $text);
			$arrText = explode("\n", $text);
			
			foreach ( $arrText as $resText ){
				if ( preg_match("/^#/", $resText) ){
				
				} else if ( preg_match("/^EOR/", $resText) ){
				
				} else {
					if ( strcmp(trim($resText), "") != 0 ){
						$res = preg_replace("/ \|\|\| /", "", $resText);
					}
				}
			}
		} else {
			return FALSE;
		}
		
		return $res;
	}
}
