<?php require_once("class/DocTmx.php"); ?>
<?php
Class View_bbs_post extends View {
	const USER_ID_ALL_USER = 0;
	
	const VIEW_MODE_TABLE  = 0;
	const VIEW_MODE_THREAD = 1;
	public static function VIEW_MODE_TABLE( $key = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_BBS_POST";
		
		$arrTable = array(
			self::VIEW_MODE_TABLE  => "{$WORD($wk, 1)}",
			self::VIEW_MODE_THREAD => "{$WORD($wk, 2)}",
		);
		
		return is_null($key) ? $arrTable : $arrTable[$key];
	}
	
	const TAB_LIST = 0;
	const TAB_NEW  = 1;
	
	var $maxDepth = 0;
	
	/***************************************************************
	 * 名前:
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function tab( $tab, $auth, $projectID = 0, $id = 0 ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_BBS_POST";
		
		$html = FALSE;
		$query = array();
		
		switch ( $tab ){
			//------------------------
			// 掲示板一覧
			case self::TAB_LIST:
				$html = $this->tab_list( $auth, $projectID, $id );
				break;
			//------------------------
			// 投稿
			case self::TAB_NEW:
				if ( $auth->writeItem(INIT_ID, $id, $projectID) ){
					$html = Printer::link("{$WORD($wk, 3)}", NULL, "icon-plus", NULL, NULL, "minhon.bbs.post.postDialog(true, {$id}, null);");
				}
				break;
		}
		
		return $html;
	}
	
	/***************************************************************
	 * 名前:
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function tab_list( $auth, $projectID = 0, $id = 0, $selectViewMode = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_BBS_POST";
		
		$html = FALSE;
		if( ! $auth->read($id, $projectID) ){
			return $html;
		}
		
		$arrPullDown = array();
		
		// モード
		$arrSubMenu = array();
		foreach ( self::VIEW_MODE_TABLE() as $view => $text ){
			$arrSubMenu[$view] = Printer::link( $text, NULL, NULL, NULL, NULL, "minhon.bbs.onClickViewMode(this);", array("data-view-mode"=>$view));
		}
		$arrPullDown[1] = array(
			"title" => "{$WORD($wk, 4)} : ".self::VIEW_MODE_TABLE($selectViewMode),
			"item"  => $arrSubMenu,
		);
		
		$html = array(
			"title" => "{$WORD($wk, 5)}",
			"item"  => $arrPullDown,
		);
		
		return $html;
	}
	
	var $countUserRole      = array();
	var $countTermRoot      = array();
	var $countBilingualRoot = array();
	var $countData          = array();
	/***************************************************************
	 * 名前: table
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function __table( $isThread, $arrData, $searchValue = NULL, $query = NULL, $orderValue = NULL, $filterValue = NULL, $arrAppended = array(), $arrFilterUser = array(), $highlightUserId = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_BBS_POST";
		
		$arrProjectTermRoot      = isset($arrAppended["term"])      ? $arrAppended["term"]      : array();
		$arrProjectBilingualRoot = isset($arrAppended["bilingual"]) ? $arrAppended["bilingual"] : array();
		$arrProjectData          = isset($arrAppended["data"])      ? $arrAppended["data"]      : array();
		
		$this->countUserRole      = array();
		$this->countTermRoot      = array();
		$this->countBilingualRoot = array();
		$this->countData          = array();
		
		$html = "";
		if ( Validate::isArray($arrData) ){
			if ( $isThread ){
				$arrThreadData = $this->convertDataToThreadData($arrData);
				foreach ( $arrThreadData as $data ){
					$html .= $this->_tableRow($data["data"], $data["child"], $arrAppended, $highlightUserId);
				}
			} else {
				foreach ( $arrData as $data ){
					$html .= $this->_tableRow($data, NULL, $arrAppended, $highlightUserId);
				}
			}
		}
		
		// フィルタ結果が一つもヒットしなかった時に表示させるセル
		$alertNoData = Printer::alert(FALSE, "{$WORD($wk, 6)}");
$html .= <<< HTML
		<tr class="bbs-post-nodata">
			<td colspan="10">
				{$alertNoData}
			</td>
		</tr>
HTML;
		
		// タイトル
		$hHeaderTitle = $this->tableHeader("{$WORD($wk, 7)}", "icon-search", NULL, array(
			Printer::link("{$WORD($wk, 8)}", NULL, "icon-search", NULL, NULL, "minhon.bbs.onClickFilterTitle();"),
			Validate::isString($searchValue) ? Printer::link("{$WORD($wk, 9)}", NULL, "icon-none", NULL, NULL, "minhon.bbs.onClickFilterTitleClear();") : NULL,
		), $query, "q_keyword", DAO_bbs_post::ORDER_KEY_TITLE, array("class"=>"filter-title"));
		// ステージ
		$hHeaderStage = $this->tableHeaderQueryFilter("{$WORD($wk, 10)}", DAO::T_BBS_POST_STAGE_TABLE(), $query, "q_stage", DAO_bbs_post::ORDER_KEY_STAGE, array("class"=>"filter-stage"));
		// タイプ
		$hHeaderType = $this->tableHeaderQueryFilter("{$WORD($wk, 11)}", DAO::T_BBS_POST_TYPE_TABLE(), $query, "q_type", DAO_bbs_post::ORDER_KEY_TYPE, array("class"=>"filter-type"));
		// 投稿者
		$hHeaderUser = $this->tableHeader("{$WORD($wk, 12)}", "icon-filter", NULL, array(
			Printer::link("{$WORD($wk, 13)}", NULL, "icon-filter", NULL, NULL, "minhon.bbs.onClickFilterUser();"),
		), $query, "q_user_id", DAO_bbs_post::ORDER_KEY_USER, array("class"=>"filter-user"));
		// 相手
		$hHeaderTarget = $this->tableHeader("{$WORD($wk, 14)}");
		// 参照データ
		$hHeaderObject = $this->tableHeader("{$WORD($wk, 15)}", "icon-filter", NULL, array(
			Printer::link("{$WORD($wk, 16)}", NULL, "icon-filter", NULL, NULL, "minhon.bbs.onClickFilterObject();"),
		), $query, "q_object", NULL, array("class"=>"filter-object"));
		// 投稿日時
		$hHeaderRegister = $this->tableHeader("{$WORD($wk, 17)}", NULL, NULL, NULL, $query, NULL, DAO_bbs_post::ORDER_KEY_REGISTER);
		
		$tableClass = "table";
		if ( $isThread ){
			$tableClass .= " thread";
		}
$html = <<< HTML
		<table id="bbs-post-table" class="{$tableClass}">
			<thead>
				<th>{$hHeaderTitle}</th>
				<th class="col-tight">{$hHeaderStage}</th>
				<th class="col-tight">{$hHeaderType}</th>
				<th class="col-tight">{$hHeaderUser}</th>
				<th class="col-tight">{$hHeaderTarget}</th>
				<th colspan="4" class="col-tight">{$hHeaderObject}</th>
				<th class="col-tight">{$hHeaderRegister}</th>
			</thead>
			<tbody>
				{$html}
			</tbody>
		</table>
HTML;
		
		// ダイアログの表示
		$html .= $this->_dialogFilterTitle( $searchValue );
		$html .= $this->_dialogFilterUser( $filterValue, $arrFilterUser, NULL, $this->countUserRole );
		$html .= $this->_dialogFilterObject( $filterValue, $arrProjectTermRoot, $arrProjectBilingualRoot, $arrProjectData, $this->countTermRoot, $this->countBilingualRoot, $this->countData );
		
		// 追記テキストフォームの生成
		$html .= $this->_formAdditionText();
		
		return $html;
	}
	
	/***************************************************************
	 * 名前: _tableRow
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	private function _tableRow( $data, $arrChildData, $arrAppended, $highlightUserId, $threadNo = 0, $threadMargin = 0 ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_BBS_POST";
		
		$objDAOBbsPostTermRoot      = DAO::instance("bbs_post_term_root", Term::KIND_TERM);
		$objDAOBbsPostBilingualRoot = DAO::instance("bbs_post_term_root", Term::KIND_BILINGUAL);
		$objDAOBbsPostData          = DAO::instance("bbs_post_data");
		
		$arrTermRoot      = array();
		$arrBilingualRoot = array();
		$arrData          = array();
		$arrProjectTermRoot      = isset($arrAppended["term"])      ? $arrAppended["term"]      : array();
		$arrProjectBilingualRoot = isset($arrAppended["bilingual"]) ? $arrAppended["bilingual"] : array();
		$arrProjectData          = isset($arrAppended["data"])      ? $arrAppended["data"]      : array();
		
		$html = "";
		
		$no        = $data["t_bbs_post_no"];
		$state     = $data["t_bbs_post_state"];
		$bbsID     = $data["t_bbs_id"];
		$role      = $data["t_bbs_post_role"];
		
		if ( $state === DAO::T_BBS_POST_STATE_NORMAL ){
			// 役割
			if ( Validate::inKeyArray($role, Task::ROLE_TABLE()) ){
				$this->countUserRole[$role] = isset($this->countUserRole[$role]) ? $this->countUserRole[$role]+1 : 1;
			}
			
			// 用語集
			$resDAOBbsPostTermRoot = $objDAOBbsPostTermRoot->get($no, $bbsID);
			if ( $resDAOBbsPostTermRoot["result"] === RES_OK ){
				foreach ( $resDAOBbsPostTermRoot["data"] as $dataBbsPostTermRoot ){
					$id   = $dataBbsPostTermRoot["t_term_root_id"];
					$name = $dataBbsPostTermRoot["t_term_root_name"];
					if ( ! is_null($name) && isset($arrProjectTermRoot[$id]) ){
						$arrTermRoot[$id] = Util::esc($name);
						$this->countTermRoot[$id] = isset($this->countTermRoot[$id]) ? $this->countTermRoot[$id]+1 : 1;
					}
				}
			}
			
			// 翻訳メモリ
			$resDAOBbsPostBilingualRoot = $objDAOBbsPostBilingualRoot->get($no, $bbsID);
			if ( $resDAOBbsPostBilingualRoot["result"] === RES_OK ){
				foreach ( $resDAOBbsPostBilingualRoot["data"] as $dataBbsPostBilingualRoot ){
					$id   = $dataBbsPostBilingualRoot["t_term_root_id"];
					$name = $dataBbsPostBilingualRoot["t_term_root_name"];
					if ( ! is_null($name) && isset($arrProjectBilingualRoot[$id]) ){
						$arrBilingualRoot[$id] = Util::esc($name);
						$this->countBilingualRoot[$id] = isset($this->countBilingualRoot[$id]) ? $this->countBilingualRoot[$id]+1 : 1;
					}
				}
			}
			
			// データ
			$resDAOBbsPostData = $objDAOBbsPostData->get($no, $bbsID);
			if ( $resDAOBbsPostData["result"] === RES_OK ){
				foreach ( $resDAOBbsPostData["data"] as $dataBbsPostData ){
					$id   = $dataBbsPostData["t_data_id"];
					$name = $dataBbsPostData["t_data_title"];
					if ( ! is_null($name) && isset($arrProjectData) ){
						$arrData[$id] = Util::esc($name);
						$this->countData[$id] = isset($this->countData[$id]) ? $this->countData[$id]+1 : 1;
					}
				}
			}
		}
		
		if ( is_array($arrChildData) && ( $threadNo === 0 ) ){
			$threadNo = $no;
		}
		
		$html .= $this->_tableRowSimple($data, $arrTermRoot, $arrBilingualRoot, $arrData, $arrAppended, $highlightUserId, $threadNo, $threadMargin, count($arrChildData) > 0);
		$html .= $this->_tableRowDetail($data, $arrTermRoot, $arrBilingualRoot, $arrData, $arrAppended);
		
		if ( is_array($arrChildData) ){
			foreach ( $arrChildData as $childData ){
				$html .= $this->_tableRow( $childData["data"], $childData["child"], $arrAppended, $highlightUserId, $threadNo, $threadMargin+1 );
			}
		}
		
		return $html;
	}
	
	/***************************************************************
	 * 名前: _tableRowSimple
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	private function _tableRowSimple( $data, $arrTermRoot, $arrBilingualRoot, $arrData, $arrAppended, $highlightUserId = NULL, $threadNo = 0, $threadMargin = 0, $isExistChildData = FALSE ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_BBS_POST";
		
		$no        = $data["t_bbs_post_no"];
		$state     = $data["t_bbs_post_state"];
		$stage     = $data["t_bbs_post_stage"];
		$type      = $data["t_bbs_post_type"];
		$role      = $data["t_bbs_post_role"];
		$arrTarget = $data["t_bbs_post_target"];
		$object    = $data["t_bbs_post_object"];
		$title     = $data["t_bbs_post_title"];
		$text      = $data["t_bbs_post_text"];
		$document  = $data["t_bbs_post_document"];
		$register  = $data["t_bbs_post_register"];
		$bbsID     = $data["t_bbs_id"];
		$userID    = $data["t_user_id"];
		$userName  = $data["t_user_name"];
		$userType  = $data["t_user_type"];
		
		$arrAttrForFilter = array(
			"data-bbs-post-no" => $no,
		);
		
		// 番号
		$hNo = Util::esc($no);
		// Margin
		if ( $threadMargin > 0 ){
			$left = 15 + (20 * $threadMargin);
			if ( $this->maxDepth > (140 / 20) ){
				$left = (140 / $this->maxDepth) * $threadMargin;
			}
			$hMargin = "<span style='margin-left: {$left}px; width: 1px'></span>";
			$hArrowDown = "";
		} else {
			if ( $isExistChildData ) {
				$hMargin = "<span style='margin-left: 1px; width: 1px'></span>";
				$hArrowDown = "<a class=\"glyphicon glyphicon-chevron-down\" id=\"icon-arrow-down-{$hNo}\" data-thread-no=\"{$hNo}\"></a>";
			} else {
				$hMargin = "<span style='margin-left: 15px; width: 1px'></span>";
				$hArrowDown = "";
			}
		}
		
		if ( $state === DAO::T_BBS_POST_STATE_NORMAL ){
			$arrAttrForFilter += array(
				"data-stage"            => $stage,
				"data-type"             => $type,
				"data-user-id"          => $userID,
				"data-user-role"        => $role,
			);
			
			// タイトル
			$hTitle = Printer::icon("icon-comment", NULL, $title);
			if ( strlen($title) === 0 ){
				$hTitle = Printer::icon("icon-comment", NULL, mb_substr(Util::esc($text), 0, 20), "#AAA");
			}
			$hTitle = Printer::ellipsis($hTitle, 20, FALSE);
			// ステージ
			$hStage = Printer::label("label-default label-danger", DAO::T_BBS_POST_STAGE_TABLE($stage), array("data-bbs-post-stage"=>$stage));
			// タイプ
			$hType = Printer::label(NULL, DAO::T_BBS_POST_TYPE_TABLE($type), array("data-bbs-post-type"=>$type));
			// 投稿日時
			$hRegister = Printer::icon("icon-time", NULL, $register);
			// 投稿者
			$hUser = Printer::icon("icon-user", DAO::T_USER_TYPE_COLOR_TABLE($userType), $userName);
			if ( $userID === $highlightUserId ){
				$hUser = "<b>{$hUser}</b>";
			}
			if ( Validate::inKeyArray($role, Task::ROLE_TABLE()) ){
				$hUser .= Printer::label("label-default", Task::ROLE_TABLE($role), array("data-user-role"=>$role));
			}
			// 相手
			$hTarget = "";
			$hArrTarget = array();
			foreach ( $arrTarget as $targetUserID => $target ){
				if ( $targetUserID == self::USER_ID_ALL_USER ){
					// 全員
					$hTarget = "<b>".Printer::icon("icon-user", NULL, "{$WORD($wk, 18)}")."</b>";
					$hArrTarget = array();
					break;
				} else {
					$userType = $target["type"];
					$userName = $target["name"];
					
					$hTargetText = Printer::icon("icon-user", DAO::T_USER_TYPE_COLOR_TABLE($userType), $userName);
					if ( strlen($hTarget) === 0 ){
						$hTarget = $hTargetText;
					} else if ( $targetUserID === $highlightUserId ){
						$hTarget = $hTargetText;
					}
					if ( $targetUserID === $highlightUserId ){
						$hTarget = "<b>{$hTarget}</b>";
					}
					foreach ( $target["role"] as $role ){
						if ( ($roleText = Task::ROLE_TABLE($role) ) !== FALSE ){
							$hTargetText .= Printer::label("label-default", $roleText);
						}
					}
					$hArrTarget[$targetUserID] = $hTargetText;
				}
			}
			if ( count($hArrTarget) > 0 ){
				$hTarget = $this->_tableCellPopover($hTarget."<span> ...</span>" , "{$WORD($wk, 19)}", $hArrTarget, NULL, FALSE);
			}
			
			// オブジェクト
			$hObjectDocument      = Printer::icon("icon-file", "#DDD");
			$hObjectTermRoot      = Printer::icon("icon-book", "#DDD", "0", "#CCC");
			$hObjectBilingualRoot = Printer::icon("icon-book", "#DDD", "0", "#CCC");
			$hObjectData          = Printer::icon("icon-paperclip", "#DDD", "0", "#CCC");
			
			// 文書（QReditから選択して登録された場合に表示される）
			if ( strcmp(trim($document), "") !== 0 ){
				$objDocTmx = new DocTmx();
				if ( $objDocTmx->load($document) && $objDocTmx->validate() ){
					if ( is_null($documentTitle = $objDocTmx->getHeaderPropValue("source_title")) ){
						$documentTitle = "[DOCUMENT]";
					}
					$hObjectDocument = Printer::icon("icon-file");
					$hObjectDocument = $this->_tableCellPopover( $hObjectDocument, "{$WORD($wk, 20)}", $documentTitle);
				}
			}
			
			if ( count($arrTermRoot) > 0 ){
				$hObjectTermRoot = Printer::icon("icon-book", NULL, count($arrTermRoot));
				$hObjectTermRoot = $this->_tableCellPopover( $hObjectTermRoot, "{$WORD($wk, 21)}", $arrTermRoot);
			}
			if ( count($arrBilingualRoot) > 0 ){
				$hObjectBilingualRoot = Printer::icon("icon-book", NULL, count($arrBilingualRoot));
				$hObjectBilingualRoot = $this->_tableCellPopover( $hObjectBilingualRoot, "{$WORD($wk, 22)}", $arrBilingualRoot);
			}
			if ( count($arrData) > 0 ){
				$hObjectData = Printer::icon("icon-paperclip", NULL, count($arrData));
				$hObjectData = $this->_tableCellPopover( $hObjectData, "{$WORD($wk, 23)}", $arrData);
			}
			
			$arrAttrForFilter += array(
				"data-object-term"      => array_keys($arrTermRoot),
				"data-object-bilingual" => array_keys($arrBilingualRoot),
				"data-object-data"      => array_keys($arrData),
			);
			
$html = <<< HTML
			<td>{$hArrowDown}{$hMargin}{$hTitle}</td>
			<td class="col-tight">{$hStage}</td>
			<td class="col-tight">{$hType}</td>
			<td class="col-tight">{$hUser}</td>
			<td class="col-tight">{$hTarget}</td>
			<td class="col-tight">{$hObjectDocument}</td>
			<td class="col-tight">{$hObjectTermRoot}</td>
			<td class="col-tight">{$hObjectBilingualRoot}</td>
			<td class="col-tight">{$hObjectData}</td>
			<td class="col-tight">{$hRegister}</td>
HTML;
		} else {
			$hTitle = Printer::icon("icon-remove", "#A00", "{$WORD($wk, 24)}", "#A88");
$html = <<< HTML
			<td colspan="10">{$hMargin}{$hTitle}</td>
HTML;
		}
		
		if ( $threadNo > 0 ){
			$arrAttrForFilter["data-thread-no"] = $threadNo;
		}
		$attr = Printer::option($arrAttrForFilter);
		
$html = <<< HTML
		<tr id="bbs-post-row-{$hNo}" class="bbs-post-row" {$attr}>
			{$html}
		</tr>
HTML;
		
		return $html;
	}
	
	/***************************************************************
	 * 名前: _tableRowDetail
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	private function _tableRowDetail( $data, $arrTermRoot, $arrBilingualRoot, $arrData, $arrAppended ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_BBS_POST";
		
		$html = $this->_detail($data, $arrTermRoot, $arrBilingualRoot, $arrData, $arrAppended, TRUE);
		
		$no  = $data["t_bbs_post_no"];
		$hNo = Util::esc($no);
		
$html = <<< HTML
		<tr class="bbs-post-detail except-table-cell" data-bbs-post-no="{$hNo}">
			<td colspan="10">
				{$html}
			</td>
		</tr>
HTML;
		
		return $html;
	}
	
	/***************************************************************
	 * 名前: _detail
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	private function _detail( $data, $arrTermRoot, $arrBilingualRoot, $arrData, $arrAppended, $doCommand = TRUE ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_BBS_POST";
		
		$auth = Auth::instance("bbs");
		
		$html = "";
		
		$no        = $data["t_bbs_post_no"];
		$state     = $data["t_bbs_post_state"];
		$stage     = $data["t_bbs_post_stage"];
		$type      = $data["t_bbs_post_type"];
		$role      = $data["t_bbs_post_role"];
		$arrTarget = $data["t_bbs_post_target"];
		$object    = $data["t_bbs_post_object"];
		$title     = $data["t_bbs_post_title"];
		$text      = $data["t_bbs_post_text"];
		$document  = $data["t_bbs_post_document"];
		//$register  = $data["t_bbs_post_register"];
		$bbsID     = $data["t_bbs_id"];
		$userID    = $data["t_user_id"];
		$userName  = $data["t_user_name"];
		$userType  = $data["t_user_type"];
		$addition  = $data["t_bbs_post_addition"];
		
		if ( $state === DAO::T_BBS_POST_STATE_NORMAL ){
			// 番号
			$hNo = Util::esc($no);
			// タイトル
			$hTitle = Printer::ellipsis(Printer::icon("icon-comment", NULL, $title), 100, FALSE);
			// ステージ
			$hStage = Printer::label("label-default label-danger", DAO::T_BBS_POST_STAGE_TABLE($stage), array("data-bbs-post-stage"=>$stage));
			// タイプ
			$hType = Printer::label(NULL, DAO::T_BBS_POST_TYPE_TABLE($type), array("data-bbs-post-type"=>$type));
			// 投稿者
			$hUser = Printer::icon("icon-user", DAO::T_USER_TYPE_COLOR_TABLE($userType), $userName);
			if ( Validate::inKeyArray($role, Task::ROLE_TABLE()) ){
				$hUser .= Printer::label("label-default", Task::ROLE_TABLE($role), array("data-user-role"=>$role));
			}
			// 相手
			$hArrTarget = array();
			foreach ( $arrTarget as $userID => $target ){
				if ( $userID == self::USER_ID_ALL_USER ){
					// 全員
					$hArrTarget = array( Printer::icon("icon-user", NULL, "{$WORD($wk, 25)}") );
					break;
				} else {
					$userType = $target["type"];
					$userName = $target["name"];
					
					$hTargetText = Printer::icon("icon-user", DAO::T_USER_TYPE_COLOR_TABLE($userType), $userName);
					foreach ( $target["role"] as $role ){
						if ( ($roleText = Task::ROLE_TABLE($role) ) !== FALSE ){
							$hTargetText .= Printer::label("label-default", $roleText);
						}
					}
					$hArrTarget[$userID] = $hTargetText;
				}
			}
			$hTarget = implode(", ", $hArrTarget);
			
			//------------------------
			// ヘッダー部
			//------------------------
			$hBtn = "";
			if ( $doCommand ){
				if ( $auth->writeItem(INIT_ID, $bbsID) ){
					// 返答
					$hBtn .= Printer::link("{$WORD($wk, 26)}", "btn btn-primary btn-sm", "icon-comment", NULL, NULL, "minhon.bbs.post.postDialog(true, {$bbsID}, {$no})");
				}
				if ( $auth->additionItem($no, $bbsID) ){
					// 追記
					$hBtn .= Printer::link("{$WORD($wk, 27)}", "btn btn-default btn-sm", NULL, NULL, NULL, "minhon.bbs.onClickAddition({$bbsID}, {$no})");
				}
				if ( $auth->removeItem($no, $bbsID) ){
					// 削除
					$hBtn .= Printer::link("{$WORD($wk, 28)}", "btn btn-default btn-sm", "icon-remove", NULL, NULL, "minhon.bbs.onClickDelete({$bbsID}, {$no}, '{$WORD($wk, 29)}')");
				}
			}
			
$html .= <<< HTML
			<div class="bbs-post-header clearfix">
				<dl class="dl-horizontal pull-left">
					<dt>{$WORD($wk, 30)}</dt>
					<dd>{$hTitle}<span style="margin-left: 10px"></span>{$hStage}{$hType}</dd>
					<dt>{$WORD($wk, 31)}</dt>
					<dd>{$hUser}</dd>
					<dt>{$WORD($wk, 32)}</dt>
					<dd>{$hTarget}</dd>
				</dl>
				<div class="pull-right">{$hBtn}</div>
			</div>
HTML;
			
			//------------------------
			// ボディ部
			//------------------------
			// 本文
			$hText = Util::esc($text);
			$hText = preg_replace("/&gt;&gt;(\d+)/", "<a href=\"#bbs-post-row-$1\">&gt;&gt;$1</a>", $hText);
			$hText = nl2br($hText);
			
			// 追記テキスト
			$hAdditionText = "";
			if ( is_array($addition) && count($addition) > 0 ){
				foreach ( $addition as $dataBbsPostAddition ){
					$additionNo       = $dataBbsPostAddition["t_bbs_post_no"];
					$additionState    = $dataBbsPostAddition["t_bbs_post_state"];
					$additionText     = $dataBbsPostAddition["t_bbs_post_text"];
					$additionRegister = $dataBbsPostAddition["t_bbs_post_register"];
					$additionUserID   = $dataBbsPostAddition["t_user_id"];
					$additionUserName = $dataBbsPostAddition["t_user_name"];
					$additionUserType = $dataBbsPostAddition["t_user_type"];
					
					if ( $additionState === DAO::T_BBS_POST_STATE_NORMAL ){
						$hAdditionRegister = Util::esc($additionRegister);
						$hAddText = Util::esc($additionText);
						$hAddText = nl2br($hAddText);
						
						$hBtn = "";
						if ( $doCommand ){
							if ( $auth->removeItem($no, $bbsID) ){
								// 削除
								$hBtn .= Printer::link("{$WORD($wk, 33)}", "btn btn-default btn-sm", "icon-remove", NULL, NULL, "minhon.bbs.onClickDelete({$bbsID}, {$additionNo}, '{$WORD($wk, 34)}')");
							}
						}
						
$hAdditionText .= <<< HTML
						<div class="bbs-post-addition">
							<p>{$WORD($wk, 35)}: {$hAdditionRegister}</p>
							<div class="bbs-post-addition-text">
								{$hAddText}
								{$hBtn}
							</div>
						</div>
HTML;
					} else {
						$hAddText = Util::esc("{$WORD($wk, 36)}");
						
$hAdditionText .= <<< HTML
						<div class="bbs-post-addition" style="color: #888">
							{$hAddText}
						</div>
HTML;
					}
				}
			}
			
$html .= <<< HTML
			<div class="bbs-post-body">
				{$hText}
				{$hAdditionText}
			</div>
HTML;
			
			//------------------------
			// フッター部
			//------------------------
			// オブジェクト
			$hArrObjectLink = array();
			// 文書（QReditから選択して登録された場合に表示される）
			if ( strcmp(trim($document), "") !== 0 ){
				$objDocTmx = new DocTmx();
				if ( $objDocTmx->load($document) && $objDocTmx->validate() ){
					if ( is_null($documentTitle = $objDocTmx->getHeaderPropValue("source_title")) ){
						$documentTitle = "[DOCUMENT]";
					}
					$hArrObjectLink["{$WORD($wk, 37)}"] = Printer::link($documentTitle, NULL, "icon-file", NULL, NULL, "minhon.bbs.post.documentDialog({$bbsID}, {$no})");
				}
			}
			// 用語集
			if ( is_array($arrTermRoot) && count($arrTermRoot) > 0 ){
				$hArrObjectLink["{$WORD($wk, 38)}"] = $this->formTerm(FALSE, NULL, $arrAppended["term"], $arrTermRoot);
			}
			
			// 翻訳メモリ
			if ( is_array($arrBilingualRoot) && count($arrBilingualRoot) > 0 ){
				$hArrObjectLink["{$WORD($wk, 39)}"] = $this->formBilingual(FALSE, NULL, $arrAppended["bilingual"], $arrBilingualRoot);
			}
			
			// データ
			if ( is_array($arrData) && count($arrData) > 0 ){
				$hArrObjectLink["{$WORD($wk, 40)}"] = $this->formData(FALSE, NULL, $arrAppended["data"], $arrData);
			}
			
			// form
			if ( count($hArrObjectLink) > 0 ){
				$hObject = Printer::dlist($hArrObjectLink, array("class" => "dl-horizontal"), FALSE);
$html .= <<< HTML
				<div class="bbs-post-footer">
					<p style="font-weight: bold">{$WORD($wk, 41)}</p>
					{$hObject}
				</div>
HTML;
			}
			
		} else {
			//------------------------
			// ボディ部
			//------------------------
			// 本文
			$hText = Util::esc("{$WORD($wk, 42)}");
			
$html .= <<< HTML
			<div class="bbs-post-body">
				{$hText}
			</div>
HTML;
		}
		
$html = <<< HTML
		<div class="bbs-post-content">
			{$html}
		</div>
HTML;

		return $html;
	}
	
	
	/***************************************************************
	 * 名前: _dialogFilterTitle
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	private function _dialogFilterTitle( $keyword ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_BBS_POST";
		
		$html = "";
		
		$arrControl = array();
		$arrControl[] = array(
			"id" => NULL,
			"name" => "{$WORD($wk, 43)}",
			"form" => Printer::input("text", "q_keyword", "q_keyword", $keyword),
		);
		$form = Printer::formControl($arrControl, FALSE, TRUE);
		
$html = <<< HTML
		<div id="dialog_bbs_filter_title" class="dialog">
			<form>
				<table class="table except-table-cell">
					{$form}
				</table>
			</form>
		</div>
HTML;
		
		return $html;
	}
	
	/***************************************************************
	 * 名前: _dialogFilterUser
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	private function _dialogFilterUser( $filterValue, $arrUser, $arrCountUserID = NULL, $arrCountUserRole = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_BBS_POST";
		
		$html = "";
		
		$arrUserPopoverOption = array(
			"data-toggle"    => "popover",
			"data-trigger"   => "hover",
			"data-placement" => "top",
			"data-delay"     => '{"show":500, "hide":100}',
		);
		
		//------------------------
		// ユーザー
		//------------------------
		$arrAlphabetUser = array();
		foreach ( $arrUser as $dataUser ){
			$alphabet = substr($dataUser["t_user_name"], 0, 1);
			$arrAlphabetUser[$alphabet][$dataUser["t_user_name"]] = $dataUser;
		}
		
		$htmlUserTable = "";
		foreach ( $arrAlphabetUser as $alphabet => $arrGroupUser ){
			ksort($arrGroupUser);
			
			$htmlUser = "";
			foreach ( $arrGroupUser as $dataUser ){
				$id    = $dataUser["t_user_id"];
				$name  = $dataUser["t_user_name"];
				$type  = $dataUser["t_user_type"];
				
				$arrOption = array(
					"data-filter-name" => "q_user_id",
					"data-filter-value" => $id,
				);
				$activeClass = "";
				if ( is_array($filterValue) && isset($filterValue["q_user_id"]) && $filterValue["q_user_id"] === $id ){
					$activeClass = "active";
				}
				$color = DAO::T_USER_TYPE_COLOR_TABLE($type);
				$hType = DAO::T_USER_TYPE_TABLE($type);
				$hUser = Printer::icon("icon-user", $color, $name, "inherit");
				$hLinkUser = Printer::link($hUser, "btn btn-default btn-user btn-active-danger {$activeClass}", NULL, NULL, NULL, NULL, $arrOption, FALSE);
				
				$hPopoverOption = Printer::option($arrUserPopoverOption);
				$htmlUser .= "<span {$hPopoverOption} data-content='{$hType}'>{$hLinkUser}</span>";
			}
			
			$hAlphabet = Util::esc($alphabet);
			
$htmlUserTable .= <<< HTML
			<tr>
				<th>{$hAlphabet}</th>
				<td>{$htmlUser}</td>
			</tr>
HTML;
		}
		
		if ( strlen($htmlUserTable) > 0 ){
			$hInputSearch = Printer::input("text", NULL, NULL, NULL, "user-search", array("placeholder" => "{$WORD($wk, 44)}"));
			
$htmlUserTable = <<< HTML
			<div>
				{$hInputSearch}
				<table class="table table-user-search">
					<tbody>
						{$htmlUserTable}
					</tbody>
				</table>
			</div>
HTML;
		} else {
			$htmlUserTable = Printer::alert(TRUE, "{$WORD($wk, 45)}}");
		}
		
		//------------------------
		// 役割絞り込み
		//------------------------
		$arrRole = array();
		foreach ( Task::ROLE_TABLE() as $role => $text ){
			$arrOption = array(
				"data-filter-name" => "q_user_role",
				"data-filter-value" => $role,
			);
			$hText = Util::esc($text);
			if ( isset($arrCountUserRole[$role]) ){
				$hText .= " <span class=\"badge\">{$arrCountUserRole[$role]}</span>";
			} else {
				$arrOption["disabled"] = "disabled";
			}
			$activeClass = "";
			if ( is_array($filterValue) && isset($filterValue["q_user_role"]) && $filterValue["q_user_role"] === $role ){
				$activeClass = "active";
			}
			$arrRole[$role] = Printer::link($hText, "btn btn-default btn-active-danger {$activeClass}", NULL, NULL, NULL, NULL, $arrOption, FALSE);
		}
		$htmlRole = "<div class=\"btn-line-group\">".implode("\n", $arrRole)."</div>";
		
		//----------------------
		// form
		//----------------------
		$arrControl = array();
		$arrControl[] = array(
			"id" => NULL,
			"name" => "{$WORD($wk, 46)}",
			"form" => $htmlUserTable,
		);
		$arrControl[] = array(
			"id" => NULL,
			"name" => "{$WORD($wk, 47)}",
			"form" => $htmlRole,
		);
		
		$form = Printer::formControl($arrControl, FALSE, TRUE);
$html = <<< HTML
		<div id="dialog_bbs_filter_user" class="dialog">
			<form>
				<table class="table except-table-cell">
					{$form}
				</table>
			</form>
		</div>
HTML;
		
		return $html;
	}
	
	/***************************************************************
	 * 名前: _dialogFilterObject
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	private function _dialogFilterObject( $filterValue, $arrTermRoot, $arrBilingualRoot, $arrData, $arrCountTermRoot = NULL, $arrCountBilingualRoot = NULL, $arrCountData = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_BBS_POST";
		
		$html = "";
		
		//-------------------------------
		// 用語集絞り込み
		//-------------------------------
		$arrFilterTermRoot = array();
		foreach ( $arrTermRoot as $id => $text ){
			$arrOption = array(
				"data-filter-name"  => "q_object_term",
				"data-filter-value" => $id,
			);
			$hText = Printer::ellipsis($text, 20);
			if ( isset($arrCountTermRoot[$id]) ){
				$hText .= " <span class=\"badge\">{$arrCountTermRoot[$id]}</span>";
			} else {
				$arrOption["disabled"] = "disabled";
			}
			$activeClass = "";
			if ( is_array($filterValue) && isset($filterValue["q_object_term"]) && $filterValue["q_object_term"] === $id ){
				$activeClass = "active";
			}
			$arrFilterTermRoot[$id] = Printer::link($hText, "btn btn-default btn-active-danger {$activeClass}", NULL, NULL, NULL, NULL, $arrOption, FALSE);
		}
		if ( count($arrFilterTermRoot) > 0 ){
			$htmlFilterTermRoot = "<div class=\"btn-line-group\">".implode("\n", $arrFilterTermRoot)."</div>";
		} else {
			$htmlFilterTermRoot = Printer::alert(TRUE, "{$WORD($wk, 48)}");
		}
		
		//-------------------------------
		// 翻訳メモリ絞り込み
		//-------------------------------
		$arrFilterBilingualRoot = array();
		foreach ( $arrBilingualRoot as $id => $text ){
			$arrOption = array(
				"data-filter-name"  => "q_object_bilingual",
				"data-filter-value" => $id,
			);
			$hText = Printer::ellipsis($text, 20);
			if ( isset($arrCountBilingualRoot[$id]) ){
				$hText .= " <span class=\"badge\">{$arrCountBilingualRoot[$id]}</span>";
			} else {
				$arrOption["disabled"] = "disabled";
			}
			$activeClass = "";
			if ( is_array($filterValue) && isset($filterValue["q_object_bilingual"]) && $filterValue["q_object_bilingual"] === $id ){
				$activeClass = "active";
			}
			$arrFilterBilingualRoot[$id] = Printer::link($hText, "btn btn-default btn-active-danger {$activeClass}", NULL, NULL, NULL, NULL, $arrOption, FALSE);
		}
		if ( count($arrFilterBilingualRoot) > 0 ){
			$htmlFilterBilingualRoot = "<div class=\"btn-line-group\">".implode("\n", $arrFilterBilingualRoot)."</div>";
		} else {
			$htmlFilterBilingualRoot = Printer::alert(TRUE, "{$WORD($wk, 49)}");
		}
		
		//-------------------------------
		// データ絞り込み
		//-------------------------------
		$arrFilterData = array();
		foreach ( $arrData as $id => $text ){
			$arrOption = array(
				"data-filter-name"  => "q_object_data",
				"data-filter-value" => $id,
			);
			$hText = Printer::ellipsis($text, 20);
			if ( isset($arrCountData[$id]) ){
				$hText .= " <span class=\"badge\">{$arrCountData[$id]}</span>";
			} else {
				$arrOption["disabled"] = "disabled";
			}
			$activeClass = "";
			if ( is_array($filterValue) && isset($filterValue["q_object_data"]) && $filterValue["q_object_data"] === $id ){
				$activeClass = "active";
			}
			$arrFilterData[$id] = Printer::link($hText, "btn btn-default btn-active-danger {$activeClass}", NULL, NULL, NULL, NULL, $arrOption, FALSE);
		}
		if ( count($arrFilterData) > 0 ){
			$htmlFilterData = "<div class=\"btn-line-group\">".implode("\n", $arrFilterData)."</div>";
		} else {
			$htmlFilterData = Printer::alert(TRUE, "{$WORD($wk, 50)}");
		}
		
		//-------------------------------
		// form
		//-------------------------------
		$arrControl = array();
		$arrControl[] = array(
			"id" => NULL,
			"name" => "{$WORD($wk, 51)}",
			"form" => $htmlFilterTermRoot,
		);
		$arrControl[] = array(
			"id" => NULL,
			"name" => "{$WORD($wk, 52)}",
			"form" => $htmlFilterBilingualRoot,
		);
		$arrControl[] = array(
			"id" => NULL,
			"name" => "{$WORD($wk, 53)}",
			"form" => $htmlFilterData,
		);
		$form = Printer::formControl($arrControl, FALSE, TRUE);
		
$html = <<< HTML
		<div id="dialog_bbs_filter_object" class="dialog">
			<form>
				<table class="table except-table-cell">
					{$form}
				</table>
			</form>
		</div>
HTML;
		
		return $html;
	}
	
	/***************************************************************
	 * 名前: _formAdditionText
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	private function _formAdditionText( $text = "" ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_BBS_POST";
		
		$html = "";
		
		$arrAction = array();
		$arrAction[] = Printer::input("submit", NULL, NULL, "OK", "btn btn-primary");
		$arrAction[] = Printer::link("Cancel", "btn btn-default", NULL, NULL, NULL, "minhon.bbs.onClickAdditionCancel()");
		$arrControl = array();
		$arrControl[] = array(
			"id"   => NULL,
			"name" => NULL,
			"form" => Printer::input("hidden", NULL, "q_id", ""),
		);
		$arrControl[] = array(
			"id" => NULL,
			"name" => "{$WORD($wk, 54)}",
			"form" => Printer::textarea("q_addition_text", "q_addition_text", $text),
		);
		$form = Printer::form(NULL, NULL, NULL, "post", $arrControl, $arrAction, NULL, FALSE);
		
$html = <<< HTML
		<div id="form_bbs_post_addition">
			{$form}
		</div>
HTML;

		return $html;
	}
	
	/***************************************************************
	 * 名前: _tableCellPopover
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	private function _tableCellPopover( $content, $popoverTitle, $popoverContent, $arrOption = NULL, $isEsc = TRUE ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_BBS_POST";
		
		if ( is_array($popoverContent) ){
			if ( $isEsc ){
				foreach ( $popoverContent as &$line ){
					$line = "<li>".Util::esc($line)."</li>";
				}
				$popoverContent = "<ul class=\"list-unstyled\">".implode("", $popoverContent)."</ul>";
			} else {
				$popoverContent = implode("<br/>", $popoverContent);
			}
		}
		$defaultOption = array(
			"data-html"      => "true",
			"data-toggle"    => "popover",
			"data-placement" => "top",
			"data-trigger"   => "hover",
			"title"          => $popoverTitle,
			"data-content"   => $popoverContent,
		);
		if ( ! is_array($arrOption) ){
			$arrOption = array();
		}
		$arrOption = array_merge($arrOption, $defaultOption);
		
		$hOption = Printer::option($arrOption);
		$html = "<span {$hOption}>{$content}</span>";
		
		return $html;
	}
	
	/***************************************************************
	 * 名前: convertDataToThreadData
	 * 説明:
	 * 引数:
	 * 返値:
	 ****************************************************************/
	private function convertDataToThreadData($arrData, $parentNo = 0, $depth = 0 ){
		$result = array();
		if ( $depth === 0 ){
			$this->maxDepth = 0; // 初期化
		}
		foreach ( $arrData as &$data ){
			$no     = $data["t_bbs_post_no"];
			$parent = $data["t_bbs_post_parent_no"];
			if ( $parentNo === $parent ){
				// 返答取得
				$child = $this->convertDataToThreadData($arrData, $no, $depth+1);
				// 
				$result[$no] = array(
					"data"    => $data,
					"child"   => $child,
				);
				unset($data);
			}
		}
		if ( count($result) > 0 && $depth > $this->maxDepth ){
			$this->maxDepth = $depth;
		}
		return $result;
	}
	
	/***************************************************************
	 * 名前: item
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function item( $data, $arrAppended ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_BBS_POST";
		
		$objDAOBbsPostTermRoot      = DAO::instance("bbs_post_term_root", Term::KIND_TERM);
		$objDAOBbsPostBilingualRoot = DAO::instance("bbs_post_term_root", Term::KIND_BILINGUAL);
		$objDAOBbsPostData          = DAO::instance("bbs_post_data");
		
		$html = "";
		
		$no        = $data["t_bbs_post_no"];
		$bbsID     = $data["t_bbs_id"];
		
		$arrProjectTermRoot      = isset($arrAppended["term"])      ? $arrAppended["term"]      : array();
		$arrProjectBilingualRoot = isset($arrAppended["bilingual"]) ? $arrAppended["bilingual"] : array();
		$arrProjectData          = isset($arrAppended["data"])      ? $arrAppended["data"]      : array();
		
		$html = "";
		
		// 用語集
		$arrTermRoot = array();
		$resDAOBbsPostTermRoot = $objDAOBbsPostTermRoot->get($no, $bbsID);
		if ( $resDAOBbsPostTermRoot["result"] === RES_OK ){
			foreach ( $resDAOBbsPostTermRoot["data"] as $dataBbsPostTermRoot ){
				$id   = $dataBbsPostTermRoot["t_term_root_id"];
				$name = $dataBbsPostTermRoot["t_term_root_name"];
				if ( ! is_null($name) && isset($arrProjectTermRoot[$id]) ){
					$arrTermRoot[$id] = Util::esc($name);
					$this->countTermRoot[$id] = isset($this->countTermRoot[$id]) ? $this->countTermRoot[$id]+1 : 1;
				}
			}
		}
		
		// 翻訳メモリ
		$arrBilingualRoot = array();
		$resDAOBbsPostBilingualRoot = $objDAOBbsPostBilingualRoot->get($no, $bbsID);
		if ( $resDAOBbsPostBilingualRoot["result"] === RES_OK ){
			foreach ( $resDAOBbsPostBilingualRoot["data"] as $dataBbsPostBilingualRoot ){
				$id   = $dataBbsPostBilingualRoot["t_term_root_id"];
				$name = $dataBbsPostBilingualRoot["t_term_root_name"];
				if ( ! is_null($name) && isset($arrProjectBilingualRoot[$id]) ){
					$arrBilingualRoot[$id] = Util::esc($name);
					$this->countBilingualRoot[$id] = isset($this->countBilingualRoot[$id]) ? $this->countBilingualRoot[$id]+1 : 1;
				}
			}
		}
		
		// データ
		$arrData = array();
		$resDAOBbsPostData = $objDAOBbsPostData->get($no, $bbsID);
		if ( $resDAOBbsPostData["result"] === RES_OK ){
			foreach ( $resDAOBbsPostData["data"] as $dataBbsPostData ){
				$id   = $dataBbsPostData["t_data_id"];
				$name = $dataBbsPostData["t_data_title"];
				if ( ! is_null($name) && isset($arrProjectData) ){
					$arrData[$id] = Util::esc($name);
					$this->countData[$id] = isset($this->countData[$id]) ? $this->countData[$id]+1 : 1;
				}
			}
		}
		
		$html = $this->_detail($data, $arrTermRoot, $arrBilingualRoot, $arrData, $arrAppended, FALSE);
		
		return $html;
	}
	
	/***************************************************************
	 * 名前: target
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function target( $arrData, $arrSelect ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_BBS_POST";
		
		$html = "";
		
		$arr = array();
		$allUser = self::USER_ID_ALL_USER;
		
		foreach ( $arrData as $data ){
			$role     = $data["t_project_user_role"];
			$userID   = $data["t_user_id"];
			$userName = $data["t_user_name"];
			
			$arr[$userID]["name"] = $userName;
			$arr[$userID]["role"][] = $role;
			$arr[$userID]["select"] = array();
		}
		foreach ( $arrSelect as $selectData ){
			$arrUserRole = explode("_", $selectData);
			if ( count($arrUserRole) !== 2 ){
				continue;
			}
			$userID = $arrUserRole[0];
			$role   = $arrUserRole[1];
			if ( isset($arr[$userID]) ){
				$arr[$userID]["select"][] = $userID."_".$role;
			}
		}
		
		foreach ( $arr as $userID => $userData ){
			$userName = $userData["name"];
			$hUserName = Util::esc($userName);
			
			$arrRoleBtn = array();
			foreach ( $userData["role"] as $role ){
				if ( ($hRole = Task::ROLE_TABLE($role)) !== FALSE ){
					$arrRoleBtn[$userID."_".$role] = $hRole;
				}
			}
			if ( count($arrRoleBtn) === 0 ){
				continue;
			}
			$hUserData  = "<td>{$hUserName}</td>";
			$hUserData .= "<td>" . Printer::checkboxButtons("q_target[]", $arrRoleBtn, $userData["select"], "btn-default") . "</td>";
			$html .= "<tr>{$hUserData}</tr>";
		}
		
		$hButtonIcon = Printer::icon("icon-check");
		
$html = <<< HTML
		<div id="q_target" class="panel panel-default">
			<div class="panel-heading">
				<p class="panel-title" data-toggle="collapse" data-target="#q_target_body">{$WORD($wk, 59)}</p>
			</div>
			<div id="q_target_body" class="panel-collapse collapse in">
				<div class="panel-body">
					<button id="q_target_all" type="button" class="btn btn-default" data-toggle="button">
						{$hButtonIcon}
						<input type="checkbox" value="{$allUser}" name="q_target[]" style="display: none;"/>
						{$WORD($wk, 60)}
					</button>
					<table class="table">
						<thead>
							<th style="white-space:nowrap">{$WORD($wk, 61)}</th>
							<th>{$WORD($wk, 62)}</th>
						</thead>
						<tbody>
							{$html}
						</tbody>
					</table>
				</div>
			</div>
		</div>
HTML;
		
		return $html;
	}
	
	/***************************************************************
	 * 名前: object
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function object( $arrTermRoot, $arrBilingualRoot, $arrData, $arrAppended ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_BBS_POST";
		
		$html = "";
		
		// 用語集
		$html .= Printer::label("label-default", "{$WORD($wk, 63)}");
		$html .= $this->formTerm(TRUE, "q_term_root", $arrAppended["term"], $arrTermRoot);
		$html .= "<br />";
		
		// 対訳集
		$html .= Printer::label("label-default", "{$WORD($wk, 64)}");
		$html .= $this->formBilingual(TRUE, "q_bilingual_root", $arrAppended["bilingual"], $arrBilingualRoot);
		$html .= "<br />";
		
		// データ
		$html .= Printer::label("label-default", "{$WORD($wk, 65)}");
		$html .= $this->formData(TRUE, "q_data", $arrAppended["data"], $arrData);
		
		return $html;
	}
}
