<?php
$wk = "WORD_P_COMMON_DEFINESTRING";

//----------------------------
// language
//----------------------------
$G_LANG_TABLE = array(
	LANG_JA => "{$WORD($wk, 1)}",
	LANG_EN => "{$WORD($wk, 2)}",
	LANG_CN => "{$WORD($wk, 3)}",
	LANG_KO => "{$WORD($wk, 4)}",
	LANG_DE => "{$WORD($wk, 5)}",
	LANG_ES => "{$WORD($wk, 6)}",
	LANG_FR => "{$WORD($wk, 7)}",
);
$G_LANG_DISP_TABLE = array(
	LANG_JA => "{$WORD($wk, 8)}",
	LANG_EN => "{$WORD($wk, 9)}",
	LANG_CN => "{$WORD($wk, 10)}",
	LANG_KO => "{$WORD($wk, 11)}",
	LANG_DE => "{$WORD($wk, 12)}",
	LANG_FR => "{$WORD($wk, 13)}",
);
$G_EXTERM_LANG_TABLE = array(
	LANG_JA => "{$WORD($wk, 14)}",
	LANG_EN => "{$WORD($wk, 15)}",
	LANG_CN => "{$WORD($wk, 16)}",
	LANG_KO => "{$WORD($wk, 17)}",
);

//----------------------------
// Menu
//----------------------------
$G_MENU_TABLE = array (
	"home" => array(
		"auth"  => array(DAO::T_USER_TYPE_______, DAO::T_USER_TYPE_NORMAL, DAO::T_USER_TYPE_INSTTR, DAO::T_USER_TYPE_ORGMGR, DAO::T_USER_TYPE_SYSMGR),
		"title" => "{$WORD($wk, 18)}",
		"icon"  => NULL, //"icon-home",
		"reg"   => "(^/content/home/)",
		"url"   => "/content/home/",
		"args"  => NULL,
		"item"  => NULL,
	),
	"project" => array(
		"auth"  => array(DAO::T_USER_TYPE_______, DAO::T_USER_TYPE_NORMAL, DAO::T_USER_TYPE_INSTTR, DAO::T_USER_TYPE_ORGMGR, DAO::T_USER_TYPE_SYSMGR),
		"title" => "{$WORD($wk, 19)}",
		"icon"  => NULL, //"icon-th",
		"reg"   => "(^/content/project/|^/content/member/|^/content/workflow/|^/content/task/|^/content/bbs/|^/content/document/|^/content/data/|^/content/term_root/|^/content/term/|^/content/statistics/)",
		"url"   => "/content/project/",
		"args"  => NULL,
		"item"  => NULL,
	),
	"organization" => array(
		"auth"  => array(DAO::T_USER_TYPE_______, DAO::T_USER_TYPE_NORMAL, DAO::T_USER_TYPE_INSTTR, DAO::T_USER_TYPE_ORGMGR, DAO::T_USER_TYPE_SYSMGR),
		"title" => "{$WORD($wk, 20)}",
		"icon"  => NULL, //"icon-star",
		"reg"   => "(^/content/organization/|^/content/user/)",
		"url"   => "/content/organization/",
		"args"  => NULL,
		"item"  => NULL,
	),
	"statistics" => array(
		"auth"  => array(DAO::T_USER_TYPE_______, DAO::T_USER_TYPE_NORMAL, DAO::T_USER_TYPE_INSTTR, DAO::T_USER_TYPE_ORGMGR, DAO::T_USER_TYPE_SYSMGR),
		"title" => "{$WORD($wk, 21)}",
		"icon"  => NULL,
		"reg"   => "(^/content/statistics_system/)",
		"url"   => "/content/statistics_system/",
		"args"  => array("q_kind" => Statistics::SYSTEM_KIND_TASK_PROJECT),
		"item"  => NULL,
	),
	"bbs" => array(
		"auth"  => array(DAO::T_USER_TYPE_______, DAO::T_USER_TYPE_NORMAL, DAO::T_USER_TYPE_INSTTR, DAO::T_USER_TYPE_ORGMGR, DAO::T_USER_TYPE_SYSMGR),
		"title" => "{$WORD($wk, 22)}",
		"icon"  => NULL, //"icon-comment",
		"reg"   => "(^/content/bbs_system/)",
		"url"   => "/content/bbs_system/",
		"args"  => NULL,
		"item"  => NULL,
	),
);

$G_MENU_PROJECT_TABLE = array(
	"detail" => array(
		"title" => "{$WORD($wk, 23)}",
		"icon"  => "icon-info-sign",
		"reg"   => "(^/content/project/)",
		"url"   => "/content/project/detail.html",
		"args"  => NULL,
		"item"  => NULL,
	),
	"member" => array(
		"title" => "{$WORD($wk, 24)}",
		"icon"  => "icon-user",
		"reg"   => "(^/content/member/)",
		"url"   => "/content/member/index.html",
		"args"  => NULL,
		"item"  => NULL,
	),
	"document" => array(
		"title" => "{$WORD($wk, 25)}",
		"icon"  => "icon-file",
		"reg"   => "(^/content/document/)",
		"url"   => "/content/document/index.html",
		"args"  => NULL,
		"item"  => NULL,
	),
	"workflow" => array(
		"title" => "{$WORD($wk, 26)}",
		"icon"  => "icon-list-alt",
		"reg"   => "(^/content/workflow/|^/content/task/)",
		"url"   => "/content/workflow/index.html",
		"args"  => NULL,
		"item"  => NULL,
	),
	"term_root_term" => array(
		"title" => "{$WORD($wk, 27)}",
		"icon"  => "icon-book",
		"reg"   => "(^/content/(term|term_root)/(.*?)q_kind=term|^/content/exterm/)",
		"url"   => "/content/term_root/index.html",
		"args"  => array("q_kind" => Term::KIND_TERM),
		"item"  => NULL,
	),
	"term_root_bilingual" => array(
		"title" => "{$WORD($wk, 28)}",
		"icon"  => "icon-book",
		"reg"   => "(^/content/(term|term_root)/(.*?)q_kind=bilingual)",
		"url"   => "/content/term_root/index.html",
		"args"  => array("q_kind" => Term::KIND_BILINGUAL),
		"item"  => NULL,
	),
	"data" => array(
		"title" => "{$WORD($wk, 29)}",
		"icon"  => "icon-paperclip",
		"reg"   => "(^/content/data/)",
		"url"   => "/content/data/index.html",
		"args"  => NULL,
		"item"  => NULL,
	),
	"bbs" => array(
		"title" => "{$WORD($wk, 30)}",
		"icon"  => "icon-comment",
		"reg"   => "(^/content/bbs/)",
		"url"   => "/content/bbs/index.html",
		"args"  => NULL,
		"item"  => NULL,
	),
	"statistics" => array(
		"title" => "{$WORD($wk, 31)}",
		"icon"  => "icon-stats",
		"class" => "tab-statistics",
		"reg"   => "(^/content/statistics/)",
		"url"   => "/content/statistics/",
		"args"  => array("q_kind" => Statistics::KIND_TASK_USER),
		"item"  => NULL,
	),
);
