<?php require_once("common/Common.php"); ?>
<?php
//--------------------------------------------------------------------
// explain  : 
// argument : 
//--------------------------------------------------------------------
//----------------------------
// define
//----------------------------
//----------------------------
// variable
//----------------------------
// word key
// result
$result = RES_OK;
// data
$data = "";
// html

//----------------------------
// request parameter
//----------------------------
$qID = isset($_REQUEST["q_id"]) ? $_REQUEST["q_id"] : REQ_NON;

//----------------------------
// judge post
//----------------------------

//----------------------------
// set types
//----------------------------
Util::setType($qID, "int");

//----------------------------
// Auth-Before validate
//----------------------------
if ( $result === RES_OK ){
	if ( ! Validate::isNumeric($qID) ){
		$result = RES_NG;
	}
}

//----------------------------
// Auth
//----------------------------
if ( $result === RES_OK ){
	$auth = Auth::instance("data");
	if( ! $auth->processDownload($qID, NULL)){
		$result = RES_NG;
	}
}

//----------------------------
// Auth-After validate
//----------------------------
if ( $result === RES_OK ){
}

//----------------------------
// function
//----------------------------

//----------------------------
// process
//----------------------------
if ( $result === RES_OK ){
	$objDAOData = DAO::instance("data");
	
	if ( $result === RES_OK ){
		$objDAOData->setAuth($auth);
		$resDAOData = $objDAOData->get($qID, DAO::T_DATA_STATE_NORMAL);
		$result = $resDAOData["result"];
		
		if ( $result === RES_OK ){
			$dataDAOData = $resDAOData["data"][0];
			$dataTitle   = $dataDAOData["t_data_title"];
			
			$file = Setting::get("PATH_DATA_DATA") . "/{$qID}";
			if ( file_exists($file) ){
				$mimetype = Util::mimetype($file);
				if ( strpos($mimetype, "application/") === 0 ){
					$disposition = "inline"; // 挙動をブラウザに任せる
				} else {
					// text/plain or image/jpg ...
					$disposition = "attachment"; // ダウンロードさせる
				}
				// pdfなど直接開く場合もあるため inline
				header("Content-Disposition: {$disposition}; filename=\"{$dataTitle}\"");
				header("Content-Length: ".filesize($file));
				header("Content-Type: ".$mimetype);
				//header("Content-Type: application/octet-stream");
				//header("Content-Type: "."text/plain; charset:utf-8;");
				readfile($file);
				exit();
			}
		}
	}
}

header("HTTP/1.0 403 Forbidden");
