<?php require_once("common/Common.php"); ?>
<?php require_once("class/Graph.php"); ?>
<?php
//--------------------------------------------------------------------
// explain  : 
// argument : 
//--------------------------------------------------------------------
//----------------------------
// define
//----------------------------
//----------------------------
// variable
//----------------------------
// word key
// result
$result = RES_OK;
// data
$data = "";
// html

//----------------------------
// request parameter
//----------------------------
$qID     = isset($_REQUEST["q_id"])     ? $_REQUEST["q_id"]     : REQ_NON;
$qKind   = isset($_REQUEST["q_kind"])   ? $_REQUEST["q_kind"]   : REQ_NON;
$qOption = isset($_REQUEST["q_option"]) ? $_REQUEST["q_option"] : REQ_NON;

//----------------------------
// judge post
//----------------------------

//----------------------------
// set types
//----------------------------
Util::setType($qID,   "int");
Util::setType($qKind, "int");

//----------------------------
// Auth-Before validate
//----------------------------
if ( $result === RES_OK ){
	if ( ! Validate::isNumeric($qID) ){
		$result = RES_NG;
		Util::printLog("Error ID Is Not Numeric");
	}
	if ( ! Validate::inKeyArray($qKind, Graph::KIND_TABLE()) ){
		$result = RES_NG;
		Util::printLog("Error Kind=".$qKind);
	}
}

//----------------------------
// Auth
//----------------------------
if ( $result === RES_OK ){
	$auth = Auth::instance("statistics");
	if( ! $auth->process($qKind, $qID)){
		$result = RES_NG;
		Util::printLog("Error Auth");
	}
}

//----------------------------
// Auth-After validate
//----------------------------
if ( $result === RES_OK ){
	if ( $qKind === Graph::KIND_TRANSITION ){
		if ( ! Validate::isNumeric($qOption) ){
			$result = RES_NG;
			Util::printLog("Error Option Is Not Numeric");
		}
		if ( ! Validate::inKeyArray($qOption, DAO::T_BBS_POST_STAGE_TABLE()) ){
			$result = RES_NG;
			Util::printLog("Error Option=".$qOption);
		}
	}
}

//----------------------------
// function
//----------------------------

//----------------------------
// process
//----------------------------
if ( $result === RES_OK ){
	$graph = new Graph($qKind, $qID, $qOption);
	
	if ( $graph->fileExists() ){
		$file = $graph->getImagePath();
		
		header("Accept-Ranges: bytes");
		header("Content-Length: ".filesize($file));
		header("Content-Type: image/png");
		readfile($file);
		exit();
	}
}

header("HTTP/1.0 403 Forbidden");
