<?php require_once("common/Common.php"); ?>
<?php
//==================================================
// title   : ヘルプ
// explain :
//==================================================
//------------------------------
// constant
//------------------------------
// word key
$wk = "WORD_P_APP_HELP_CONTROLLER";

//------------------------------
// variable
//------------------------------
// result
$result = RES_OK;
// data
$title = "";
$body  = "";

//------------------------------
// request parameter
//------------------------------
$qKind = isset($_REQUEST["q_kind"]) ? $_REQUEST["q_kind"] : REQ_NON;
$qPage = isset($_REQUEST["q_page"]) ? $_REQUEST["q_page"] : REQ_NON;

//------------------------------
// set types
//------------------------------
Util::setType($qKind, "string");
Util::setType($qPage, "string");

//------------------------------
// judge post
//------------------------------

//------------------------------
// validate request parameter
//------------------------------
if ( ! validate::isString($qKind) ){
	$result = FALSE;
	$gResult->push("{$WORD($wk, 1)}");
}
if ( ! validate::isString($qPage) ){
	$result = FALSE;
	$gResult->push("{$WORD($wk, 2)}");
}

//----------------------------
// function
//----------------------------
//----------------------------
// process
//----------------------------
if ( $result === RES_OK ){
	$objViewHelp = View::instance("help");
	
	$arr = Help::get($qKind, $qPage);
	$title = $arr["title"];
	$body  = $arr["body"];
}

$arrRes["result"]  = $result;
$arrRes["message"] = $gResult->string(FALSE, $result);
$arrRes["title"]   = $title;
$arrRes["data"]    = $body;
$arrRes["isMenu"]  = ($qKind === Help::KIND_MENU);

echo json_encode($arrRes);
