<?php require_once("common/Common.php"); ?>
<?php
//--------------------------------------------------------------------
// explain  : 
// argument : 
//--------------------------------------------------------------------
//----------------------------
// define
//----------------------------
//----------------------------
// variable
//----------------------------
// word key
$wk = "WORD_P_APP_MEMBER_CONTROLLER";
// result
$result = RES_OK;
// data
$data = "";
// html

//----------------------------
// request parameter
//----------------------------
//$qToken = isset($_REQUEST["q_token"])  ? $_REQUEST["q_token"]  : REQ_NON;
$qMode  = isset($_REQUEST["q_mode"])   ? $_REQUEST["q_mode"]   : REQ_NON;
$qID    = isset($_REQUEST["q_id"])     ? $_REQUEST["q_id"]     : REQ_NON;
$qOrgID = isset($_REQUEST["q_org_id"]) ? $_REQUEST["q_org_id"] : REQ_NON;

//----------------------------
// judge post
//----------------------------

//----------------------------
// set types
//----------------------------
//Util::setType($qToken, "string");
Util::setType($qMode,  "int");
Util::setType($qID,    "int");
Util::setType($qOrgID, "int");

//----------------------------
// Auth-Before validate
//----------------------------
if ( $result === RES_OK ){
	if ( ! Validate::inArray($qMode, $APP_MEMBER_CONTROLLER_MODE_TABLE) ){
		$result = RES_NG;
		$gResult->push("{$WORD($wk, 1)}");
	}
	if ( ! Validate::isNumeric($qID) ){
		$result = RES_NG;
		$gResult->push("{$WORD($wk, 2)}");
	}
	if ( ! Validate::isNumeric($qOrgID) ){
		$result = RES_NG;
		$gResult->push("{$WORD($wk, 3)}");
	}
	/*
	if ( $qMode === APP_PROJECT_CONTROLLER_MODE_SET ){
		if ( ! Validate::isToken($qToken, "token_common", FALSE) ){
			$result = RES_NG;
			$gResult->push("{$WORD($wk, 4)}");
		}
	}
	 */
}

//----------------------------
// Auth
//----------------------------
if ( $result === RES_OK ){
	$auth = Auth::instance("project");
	switch ( $qMode ){
		case APP_MEMBER_CONTROLLER_MODE_GET_ORG:
			if ( ! $auth->read($qID) ){
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 5)}");
			}
			break;
	}
}

//----------------------------
// Auth-After validate
//----------------------------
if ( $result === RES_OK ){
}

//----------------------------
// function
//----------------------------

//----------------------------
// process
//----------------------------
if ( $result === RES_OK ){
	$objDAOUser         = DAO::instance("user");

	$objViewProjectUser = View::instance("project_user");
	
	if ( $result === RES_OK ){
		switch ( $qMode ){
			case APP_MEMBER_CONTROLLER_MODE_GET_ORG:
				// 対象ユーザー取得 --------------------
				if ( $result === RES_OK ){
					$objDAOUser->setAuth( Auth::instance("user") );
					$resDAOUser = $objDAOUser->get(NULL, NULL, DAO::T_USER_STATE_ACTIVE, NULL, $qOrgID);
					$result = $resDAOUser["result"];
					
					if ( $result === RES_OK ){
						foreach ( $resDAOUser["data"] as $dataUser ){
							$userID   = $dataUser["t_user_id"];
							$userName = $dataUser["t_user_name"];
							
							$arrTargetUser[] = $userID;
							$arrUser[$userID] = $dataUser;
						}
					} else if ( $result === RES_NO_DATA ){
						// ユーザー数が 0 の組織
					} else {
						$result = RES_NG;
						$gResult->push("{$WORD($wk, 6)}");
					}
				}
				if ( $result === RES_OK ){
					$htmlRole = "";
					foreach ( $arrUser as $userID => $dataUser ){
						$htmlRole .= $objViewProjectUser->formRoleTableRow($dataUser, NULL);
					}
				}
				if ( $result === RES_OK ){
					$data = array(
						"html_reg"  => $objViewProjectUser->formRegTable($arrUser),
						"html_role" => $htmlRole,
					);
				} else if ( $result === RES_NO_DATA ){
					$result = RES_OK;
					$data = array(
						"html_reg"  => Printer::alert(FALSE, "{$WORD($wk, 7)}"),
						"html_role" => "",
					);
				}
				break;
			default:
				break;
		}
	}
}

$res["result"]  = $result;
$res["message"] = $gResult->string(FALSE, $result);
$res["data"]    = $data;

echo json_encode($res);
