minhon.define = {
	RES_OK      :  1,  // OK *php
	RES_NG      : -1,  // NG *php
	RES_NO_DATA : -2,  // データが無い *php
	
	OFF     :  0,  // OFF *php
	ON      :  1,  // OK *php
	
	INIT_ID : 0, // 初期ID *php
	
	STR_AJAX_ERROR : "Communication error",
	
	//----------------------------
	// class
	//----------------------------
	SCRIPT : {
		PUNCTUATION : "-"  // *php
	},
	
	//----------------------------
	// database
	//----------------------------
	// project
	DB_T_PROJECT_STATE_NORMAL   :  0,  // 状態(通常)  *php
	DB_T_PROJECT_STATE_COMPLETE : 10,  // 状態(完了)  *php
	// task
	DB_T_TASK_STATE_NORMAL :  0,  // 状態(通常)    *php
	DB_T_TASK_STATE_CARIED : 10,  // 状態(実施中)  *php
	DB_T_TASK_STATE_FINISH : 20,  // 状態(完了)    *php
	// user
	DB_T_USER_WARN_NON_ACTIVE_NONE : 0, // 非活発ユーザ表示    *php
	DB_T_USER_WARN_NON_ACTIVE_HIDE : 1, // 非活発ユーザ非表示  *php
	
	//----------------------------
	// app
	//----------------------------
	// bbsController.php
	APP_BBS_CONTROLLER_MODE_POSTDOC  : 0,  // モード(文書表示)  *php
	APP_BBS_CONTROLLER_MODE_POSTFRM  : 1,  // モード(postフォーム)  *php
	APP_BBS_CONTROLLER_MODE_POSTSET  : 2,  // モード(postセット)  *php
	APP_BBS_CONTROLLER_MODE_ADDITION : 3,  // モード(追記)  *php
	APP_BBS_CONTROLLER_MODE_DELETE   : 4,  // モード(削除)  *php
	// documentController.php
	APP_DOCUMENT_CONTROLLER_MODE_GET     : 0,  // モード(ゲット)  *php
	APP_DOCUMENT_CONTROLLER_MODE_SET     : 1,  // モード(セット)  *php
	APP_DOCUMENT_CONTROLLER_MODE_EXPORT  : 2,  // モード(エクスポート-TSV)  *php
	APP_DOCUMENT_CONTROLLER_MODE_EXPORT2 : 3,  // モード(エクスポート-訳文)  *php
	APP_DOCUMENT_CONTROLLER_MODE_COPY    : 4,  // モード(コピー)  *php
	// loggingController.php
	APP_LOGGING_CONTROLLER_MODE_LOOKUP : 0,  // モード(lookup)  *php
	APP_LOGGING_CONTROLLER_MODE_LKUPSL : 1,  // モード(lookup select)  *php
	// memberController.php
	APP_MEMBER_CONTROLLER_MODE_GET_ORG : 0, // モード(ゲット)  *js
	// projectController.php
	APP_PROJECT_CONTROLLER_MODE_GET : 0,     // モード(ゲット)  *php
	APP_PROJECT_CONTROLLER_MODE_SET : 1,     // モード(セット)  *php
	APP_PROJECT_CONTROLLER_MODE_EXPORT : 2,  // モード(エクスポート)  *php
	APP_PROJECT_CONTROLLER_MODE_INFO : 3,    // モード(ゲット)  *php
	// suggestController.php
	APP_SUGGEST_CONTROLLER_MODE_USER_NAME : 0,  // モード(ユーザー名)  *php
	APP_SUGGEST_CONTROLLER_MODE_ORG_NAME  : 1,  // モード(組織名)      *php
	// taskController.php
	APP_TASK_CONTROLLER_MODE_GET_TASK_DETAIL         : 0,  // モード(ゲット)  *php
	APP_TASK_CONTROLLER_MODE_GET_TASK_NEW            : 1,  // モード(ゲット)  *php
	APP_TASK_CONTROLLER_MODE_GET_TASK_EDIT           : 2,  // モード(ゲット)  *php
	APP_TASK_CONTROLLER_MODE_SET_TASK_UPDATE         : 3,  // モード(セット)  *php
	APP_TASK_CONTROLLER_MODE_SET_TASK_DELETE         : 4,  // モード(セット)  *php
	APP_TASK_CONTROLLER_MODE_GET_TASKINFO            : 5,  // モード(ゲット)  *php
	APP_TASK_CONTROLLER_MODE_SET_STATE               : 6,  // モード(セット)  *php
	APP_TASK_CONTROLLER_MODE_GET_TASKS_FROM_DOCUMENT : 7,  // モード(ゲット)  *php
	APP_TASK_CONTROLLER_MODE_ACTION                  : 100,// モード(アクション)  *php
	// taskChartController.php
	APP_TASK_CHART_CONTROLLER_MODE_DETAIL          :  0, // モード(詳細_デフォルト) *php
	APP_TASK_CHART_CONTROLLER_MODE_DETAIL_TASK     :  1, // モード(詳細_タスクグループごと) *php
	APP_TASK_CHART_CONTROLLER_MODE_DETAIL_USER     :  2, // モード(詳細_担当者ごと) *php
	APP_TASK_CHART_CONTROLLER_MODE_DETAIL_DOCUMENT :  3, // モード(詳細_文書ごと) *php
	APP_TASK_CHART_CONTROLLER_MODE_ALLOCATE        : 10, // モード(割当て) *php
	// termController.php
	APP_TERM_CONTROLLER_MODE_FRM : 0,  // モード(フォーム)  *php
	APP_TERM_CONTROLLER_MODE_SET : 1,  // モード(セット)  *php
	APP_TERM_CONTROLLER_MODE_DEL :-1,  // モード(削除)  *php
	
	// userController.php
	APP_USER_CONTROLLER_MODE_GET                 : 0, // モード(ゲット)  *php
	APP_USER_CONTROLLER_MODE_SET_STATE           : 1, // モード(セット)  *php
	APP_USER_CONTROLLER_MODE_SET_WARN_NON_ACTIVE : 2, // モード(セット 非活発ユーザー表示)  *php
	
	// search/index.html
	CONTENT_SEARCH_INDEX_MODE_BILINGUAL : 1,  // モード(対訳検索)      *php
	CONTENT_SEARCH_INDEX_MODE_SIM       : 2,  // モード(類似文検索)    *php
	CONTENT_SEARCH_INDEX_MODE_DOCUMENT  : 3,  // モード(文書対訳検索)  *php
	
	eod : null
};
