minhon.exterm = {
};

minhon.exterm.edit = {
	initialize : function(){
		if ( $.validator ){
			$.validator.setDefaults({
				errorPlacement : function(error, element){
					// 通常処理
					error.insertAfter(element);
					if ( element.is("[name=q_target_all_document]") ){
						var label = element.closest("label");
						label.parent().append(error);
					}
					if ( element.is("[name=q_complete_register]") ){
						$("#div_complete_register_term_root").append(error);
					}
				}
			});

			// ダウンロード対象ドキュメント初期設定
			$("input[name='q_target_document_id[]']").each( function(){
				if ( $(this).is(":checked") ){
					$(this).attr("checked", "checked").closest(".btn").addClass("active");
				} else {
					$(this).removeAttr("checked").closest(".btn").removeClass("active");
				}
			});

			// 抽出対象
			$.validator.addMethod("required_target_document", function(value, element, options){
				var validator = this;
				if ( $("[name=q_target_all_document]", element.form).is(":checked") ){
					return true;
				}
				if ( $("[name=q_target_document_id]:checked", element.form).length > 0 ){
					return true;
				}
				
				return false;
			}, $.validator.messages["required"]);
			// 用語抽出結果
			$.validator.addMethod("required_complete_register", function(value, element, options){
				var validator = this;
				if ( element.form.q_complete_register.value != 2 ){
					return true;
				}
				if ( $("[name=q_register_term_root_id]:checked", element.form).length > 0 ){
					return true;
				}
				
				return false;
			}, $.validator.messages["required"]);
		}
		
		// 抽出対象-文書 の 文書を選択した時
		$("input[name='q_target_document_id[]']").on("change", function(){
			if ( $("input[name='q_target_document_id[]']:checked").length === $("input[name='q_target_document_id[]']").length ){
				// すべてにチェックが入っている場合
				$("[name='q_target_all_document']").attr("checked", "checked").valid();
			} else {
				$("[name='q_target_all_document']").removeAttr("checked").valid();
			}
		});
		// 用語抽出結果を用語集に登録 の 文書を選択した時
		$("input[name='q_register_term_root_id']").on("change", function(){
			$("#div_complete_register_term_root").removeClass("overlay");
			$("[name=q_complete_register]").val(["2"]).valid();
		});
		
		// すべての文書 にチェック
		$("input[name='q_target_all_document']").click("change", function(){
			if ( $(this).is(":checked") ){
				$("input[name='q_target_document_id[]']").each( function(){
					$(this).attr("checked", "checked").closest(".btn").addClass("active");
				});
			} else {
				$("input[name='q_target_document_id[]']").each( function(){
					$(this).removeAttr("checked").closest(".btn").removeClass("active");
				});
			}
		}).triggerHandler("change");
		
		// 既存用語集に登録 にチェック
		$("input[name='q_complete_register']").on("change", function(){
			if ( $("input[name='q_complete_register']:checked").val() == 2 ){
				$("input[name='q_register_term_root_id']").each( function(){
					if ( $(this).is(":checked") ){
						$(this).parent("label.btn-active-danger").addClass("active");
					} else {
						$(this).parent("label.btn-active-danger").removeClass("active");
					}
				});
				$("#div_complete_register_term_root").removeClass("overlay");
			} else {
				$("input[name='q_register_term_root_id']").each( function(){
					$(this).parent("label.btn-active-danger").removeClass("active");
				});
				$("#div_complete_register_term_root").addClass("overlay");
			}
		}).triggerHandler("change");
	},
	
	eod : null
}
