minhon.home = {
	initialize : function(){
	},
	
	onClickHidden : function( obj ){
		var ajaxUserHide = function( id ){
			var dfd = $.Deferred();
			
			jQuery.ajax({
				url      : "/app/userController.php",
				type     : "POST",
				data     : {
					"q_token"      : $("#token_common").val(),
					"q_mode"       : minhon.define.APP_USER_CONTROLLER_MODE_SET_WARN_NON_ACTIVE,
					"q_id"         : id,
					"q_non_active" : minhon.define.DB_T_USER_WARN_NON_ACTIVE_HIDE
				},
				dataType : "json",
				error    : function(){
					alert(minhon.define.AJAX_ERROR);
					dfd.reject();
				},
				success  : function( res ){
					if ( res.result === minhon.define.RES_OK ){
						var $obj = $("#table_home_user [data-user-id=\""+id+"\"]")
						$obj.closest("tr").remove();
						
						dfd.resolve();
					} else {
						alert(res.message);
						dfd.reject();
					}
				},
			});
			
			return dfd.promise();
		};
		
		var arrFuncAjax = [];
		if ( obj instanceof Array ){
			jQuery.each( obj, function(key, val){
				arrFuncAjax[arrFuncAjax.length] = ajaxUserHide($(val).data("user-id"));
			});
		} else {
			arrFuncAjax[0] = ajaxUserHide($(obj).data("user-id"));
		}
		
		$.when.apply(null, arrFuncAjax).then(function(){
			if ( $("#table_home_user tbody tr:visible").length == 0 ){
				$("#table_home_user").parents(".panel").find(".panel-heading a").remove();
				$("#table_home_user").remove();
			}
		});
	},
	
	eod : null
};
